; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

Global hInfoImg.i

Procedure.i InfoDialog_TranslationEnumProc(hModule.i, lpszType.i, *lpszName, wIDLanguage.i, HWndList.i)
  Define.s xChar1
  Define.i xLong1
  Define.RECT xType1

  xType1\Left = eSPTopX
  xType1\Right = eSPTopX
  ;xType1\Top = eSPTopY
  ;xType1\Bottom = eSPTopY

  xChar1 = LoadStringExML(GetModuleHandle_(0), 2221, wIDLanguage)
  ;xLong1 = LoadIconExML(GetModuleHandle_(0), 2221, 16, wIDLanguage)

  CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    If IsHighColor
      xLong1 = LoadResEx_ImageIconWEMFExML(GetModuleHandle_(0), 2221, 16 * MainDPIScaleX, 16 * MainDPIScaleY, wIDLanguage)
      EndIf
    If Not xLong1
      xLong1 = LoadIconExML(GetModuleHandle_(0), 2221, 16 * MainDPIScaleX, 16 * MainDPIScaleX, wIDLanguage)
      EndIf
    CompilerElse
    xLong1 = LoadResEx_ImageIconWEMFExML(GetModuleHandle_(0), 2221, 16 * MainDPIScaleX, 16 * MainDPIScaleY, wIDLanguage)
    CompilerEndIf
  HyperlinkList_AddItem(HWndList, xChar1, @xType1, @xLong1, 16 * MainDPIScaleX, 16 * MainDPIScaleY, #True, 1)
  ProcedureReturn #True
  EndProcedure

Procedure InfoDialog_InitCallback(HWndDialog.i, HWndList.i)
  Define.i xLong1
  Define.s xChar1
  Define.s xChar2
  Define.RECT xType1
  Define.i hIcon
  Define.i hBmp1
  Define.i xIconSizeX
  Define.i xIconSizeY

;Debug "InitInfoDlg"
  xLong1 = GetDlgItem_(HWndDialog, 2201)
  If xLong1
    If GetWindowRect_(xLong1, @xType1)
      hInfoImg = LoadResEx_ImageBitmapWEMF_MultiOS(2250, xType1\Right - xType1\Left, xType1\Bottom - xType1\Top, GetSysColor_(#COLOR_3DFACE), 0)
CompilerIf #False
      If Not hInfoImg
        hBmp1 = LoadResEx_Image_MultiOS(2200, 0)
        If hBmp1
          hInfoImg = BitmapStretchCopyEx(hBmp1, xType1\Right - xType1\Left, xType1\Bottom - xType1\Top)
          EndIf
        If hInfoImg
          DeleteObject_(hBmp1)
          Else
          hInfoImg = hBmp1
          EndIf
        EndIf
CompilerEndIf
      If hInfoImg
        SendMessage_(xLong1, $172, 0, hInfoImg)
        EndIf
      EndIf
    EndIf

  xType1\Left = eSPTopX
  xType1\Right = eSPTopX
  xType1\Top = eSPTopY
  xType1\Bottom = eSPTopY
  
  ;hIcon = LoadResEx_Image_MultiOS(2200, 1, 32)
  xIconSizeX = GetSystemMetrics_(#SM_CXICON)
  xIconSizeY = GetSystemMetrics_(#SM_CYICON)
  hIcon = LoadResEx_ImageIconWEMF_MultiOS(2000, xIconSizeX, xIconSizeY)
  HyperlinkList_AddItem(HWndList, GBN2 + LoadResString(2200), @xType1, @hIcon, xIconSizeX, xIconSizeY, #True, 0)
  HyperlinkList_AddItem(HWndList, LoadResString(2210), @xType1)
  HyperlinkList_AddItem(HWndList, LoadResString(2211), @xType1)

;ProcedureReturn
  xLong1 = ctSSLayer_CanUseItem($20)
  If xLong1 > -1 And xLong1 < 90
;Debug.Print xLong1
    If xLong1 < 10 Or xLong1 > 19
      xLong1 = 9
      EndIf
    xChar1 = ReplaceString(SSRestrictions, "$I", ReplaceString(LoadResString(2100 + xLong1), "$S", ctSSLayer_GetInfoString(5)))
    If Len(LayerHP) And Len(xChar1)
      xChar1 = xChar1 + ReplaceString(LoadResString(2205), "$H", LayerHP)
      EndIf
    EndIf
  If Len(xChar1) = 0
    xChar1 = LoadResString(2220)
    EndIf
;MessageBox_(0, ReplaceString(LoadResString(2214), "$S", #CRLF$ + xChar1), "Gaga", 0)
;ProcedureReturn
  HyperlinkList_AddItem(HWndList, ReplaceString(LoadResString(2214), "$S", #CRLF$ + xChar1), @xType1)
; Not working up to here!
  xChar1 = ctSSLayer_GetInfoString($A)
  xLong1 = FindString(xChar1, #CRLF$)
  xType1\Left = 20 * MainDPIScaleX ;(eSPTopX << 1) + xIconSizeX
  While xLong1 > 0
    xChar2 = Trim(Left(xChar1, xLong1 - 1))
    If Len(xChar2)
      HyperlinkList_AddItem(HWndList, xChar2, @xType1)
      EndIf
    xChar1 = Mid(xChar1, xLong1 + 2)
    xLong1 = FindString(xChar1, #CRLF$)
    Wend
  xChar2 = Trim(xChar1)
  If Len(xChar2)
    HyperlinkList_AddItem(HWndList, xChar1, @xType1)
    EndIf
  xType1\Left = eSPTopX

  xChar1 = LoadResString(2221)
  If Len(xChar1) = 0
    xChar1 = LoadResString(2220)
    EndIf
  xType1\bottom = 0
  HyperlinkList_AddItem(HWndList, ReplaceString(LoadResString(2215), "$L", xChar1), @xType1)
  EnumResourceLanguages_(hInstance, #RT_STRING, "#" + Str((2221 >> 4) + 1), @InfoDialog_TranslationEnumProc(), HWndList)

  xType1\top << 1
  xType1\bottom = eSPTopY
  HyperlinkList_AddItem(HWndList, LoadResString(2222), @xType1)
  ;xType1\bottom >> 3
  xType1\top >> 1

  HyperlinkList_AddItem(HWndList, LoadResString(2217), @xType1)
  HyperlinkList_AddItem(HWndList, LoadResString(2218), @xType1)

  xType1\Bottom = 0
  HyperlinkList_AddItem(HWndList, LoadResString(2230), @xType1)
  xType1\Top = 0
  xChar1 = ctSSLayer_GetInfoString($B)
  If Len(xChar1)
    HyperlinkList_AddItem(HWndList, xChar1, @xType1)
    EndIf
;  xType1\Bottom = 4
  xType1\Bottom = eSPTopY
  HyperlinkList_AddItem(HWndList, LoadResString(2239), @xType1)
  xType1\Top = eSPTopY
  HyperlinkList_AddItem(HWndList, LoadResString(2219), @xType1)
  EndProcedure

Procedure InfoDialog_OpenURL(HWndDialog.i, ptrURL.i)
  Define.s xChar1

  If UrlsAllowed
    xChar1 = PeekS(ptrURL)
    If Len(xChar1)
      ShellExecute_(HWndDialog, "Open", xChar1, 0, 0, 5)
      EndIf
    EndIf
  EndProcedure

Procedure InfoDialog_ShowInfoDialog()
  DialogTimer(#True)
  ;MessageBox_(0, "Test", "Test", 0)
  HyperLinkList_InfoDialog(2200, @InfoDialog_InitCallback(), 0, MainHWnd, @InfoDialog_OpenURL(), 2200, 2209)
  If hInfoImg
    DeleteObject_(hInfoImg)
    hInfoImg = 0
    EndIf
  DialogTimer(#False)
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = --
; EnableUnicode
; EnableXP
; Executable = id1.exe
; CompileSourceDirectory
; AddResource = res\exe64.rc