; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

Global Dim lkCombi.s(4)
Global lkCtrl.s
Global lkAlt.s
Global lkShift.s

Enumeration
  #KbdC_FFileMenu
    #KbdC_FAddFileS
    #KbdC_FAddDir
    #KbdC_FAddPList
    #KbdC_FRefreshCD
    #KbdC_FNewPL
    #KbdC_FLoadPL
    #KbdC_FLoadPLMenu
    #KbdC_FLoadPLDefault
    #KbdC_FReloadPL
    #KbdC_FSavePL
    #KbdC_FSavePLas
    #KbdC_FClearPL
    #KbdC_FRemAllMiss
    #KbdC_FQuitSD
  #KbdC_CPCMenu
    #KbdC_CPrev
    #KbdC_CPlay
    #KbdC_CPause
    #KbdC_CStop
    #KbdC_CNext
    #KbdC_CEnd
    #KbdC_CRepSingle
    #KbdC_CRepAll
    #KbdC_CRepRnd
    #KbdC_CRepToggle
    #KbdC_CIntroMode
    #KbdC_CSeekB
    #KbdC_CSeekF
    #KbdC_CCurSongMenu
      #KbdC_CCSSelFile
      #KbdC_CCSRemFile
      #KbdC_CCSDelFile
      #KbdC_CCSExplorer
  #KbdC_PPLMenu
    #KbdC_PPlaySkip
    #KbdC_PPlayEnd
    #KbdC_PPlayNext
    #KbdC_PFindCurrent
    #KbdC_PSelRnd
    #KbdC_PFind
    #KbdC_PFindNext
    #KbdC_PFindQuick
    #KbdC_PInvSel
    #KbdC_PRemSongs
    #KbdC_PRem
    #KbdC_PCopyPLEnd
    #KbdC_PCrop
    #KbdC_PDelFiles
    #KbdC_PExplorer
  #KbdC_OOptionsMenu
    #KbdC_OFading
    #KbdC_OSpektrum
    #KbdC_OFileInfos
    #KbdC_OFollowSong
    #KbdC_ORemMissing
    #KbdC_ORemSkipped
    #KbdC_ORemPlayed
    #KbdC_OEndMenu
      #KbdC_ONoEndMode
      #KbdC_OXFade
      #KbdC_OMDMode
      #KbdC_OStopEach
      #KbdC_OEndModeTggle
    #KbdC_CVolMenu
      #KbdC_CVolUp
      #KbdC_CVolDown
      #KbdC_CVolMute
      #KbdC_CVol1
      #KbdC_CVol2
      #KbdC_CVol3
      #KbdC_CVol4
      #KbdC_CVol5
      #KbdC_CVol6
      #KbdC_CVol7
      #KbdC_CVol8
      #KbdC_CVol9
      #KbdC_CVolFull
    #KbdC_OPresetMenu
      #KbdC_OPresetSave
      #KbdC_OPresetLoad
    #KbdC_OSaveSetts
    #KbdC_CMoreSetts
  #KbdC_TToolsMenu
    #KbdC_OInternetRadio
    #KbdC_OInternetRadioRe
    #KbdC_OInternetRadioHP
    #KbdC_OAutoRFMenu
      #KbdC_OAutoRF
      #KbdC_OAutoRFAlt
      #KbdC_OAutoRFRem
      #KbdC_OAutoRFRemI
      #KbdC_OAutoRFSetup
    #KbdC_ODirMenu
      #KbdC_PGotoDir
      #KbdC_ODirCombo
      #KbdC_ODirTop
      #KbdC_ODirLeft
      #KbdC_ODirAuto
      #KbdC_ODirToggle
      #KbdC_ODirInc
      #KbdC_ODirDec
    #KbdC_CPrevSongs
    #KbdC_OTimerMenu
      #KbdC_OTimerEdit
      #KbdC_OTimerImport
      #KbdC_OTimerExport
      #KbdC_OTimerClear
    #KbdC_OSoundFontMenu
;      #KbdC_OSoundFontRefresh
    #KbdC_OResetSnd
    #KbdC_OVolCtrl
  #KbdC_IInfoMenu
    #KbdC_IHelp
    #KbdC_IAbout
  
  #KbdSplit
  
  #KbdC_GPrev
  #KbdC_GPlay
  #KbdC_GPlayPause
  #KbdC_GPause
  #KbdC_GStop
  #KbdC_GNext
  #KbdC_GEnd
  #KbdC_GRepSingle
  #KbdC_GRepAll
  #KbdC_GRepRnd
  #KbdC_GRepToggle
  #KbdC_GIntroMode
  #KbdC_GSeekB
  #KbdC_GSeekF
  #KbdC_GVolMenu
    #KbdC_GVolUp
    #KbdC_GVolDown
    #KbdC_GVolMute
    #KbdC_GVol1
    #KbdC_GVol2
    #KbdC_GVol3
    #KbdC_GVol4
    #KbdC_GVol5
    #KbdC_GVol6
    #KbdC_GVol7
    #KbdC_GVol8
    #KbdC_GVol9
    #KbdC_GVolFull
  #KbdC_GPlayDef
  #KbdC_GPlaySkp
  #KbdC_GPlayEnd
  #KbdC_GPlayNxt
  #KbdC_GPrevSel
  #KbdC_GNextSel
  #KbdC_GPrevPage
  #KbdC_GNextPage
  #KbdC_GCurNSel
  #KbdC_GRandSel
  #KbdC_GIRadio
  #KbdC_GIRadioRe
  #KbdC_GIRadioHP
  #KbdC_GAutoRF
  #KbdC_GAutoRFAlt
  #KbdC_GShowPlayer
  #KbdC_GShowPlayerPS
  #KbdC_GShowMenu
  #KbdC_GShowAltMenu
  #KbdC_GShowVolMenu
  #KbdC_GShowTitle
  #KbdC_GRemFile
  #KbdC_GDelFile
  #KbdC_GExplorer
  #KbdC_GResetSND
  #KbdC_GVolCtrl
  #KbdC_GQuit
  #KbdC_GAbortReading



  #KbdCount      ;TotalCount
  EndEnumeration
#KbdSplitP = #KbdSplit - 1 ; Last item before Splitter
#KbdSplitN = #KbdSplit + 1 ; Next item after splitter
#KbdCountX = #KbdCount - 1 ;Totalcount-1 -> 0-LastItem



Global Dim xKey.i(#KbdCountX)
#KbdCountX_Minus_KbdSplitN = #KbdCountX - #KbdSplitN
  ;#KbdC_GShowTitle_Fast= #KbdC_GShowTitle - KbdSplitN

Enumeration
  #KbdCTm_Extended = 200
  #KbdCTm_FShutDown = 200
  #KbdCTm_FHibernate
  #KbdCTm_FStandby
  #KbdCTm_FMonitoff
  #KbdCTm_CPlay
  #KbdCTm_CPause
  #KbdCTm_CStop
  #KbdCTm_CIntroModeOn
  #KbdCTm_CIntroModeOff
  #KbdCTm_PFindCurrent
  #KbdCTm_OFadingOn
  #KbdCTm_OFadingOff
  #KbdCTm_OSpektrumOn
  #KbdCTm_OSpektrumOff
  #KbdCTm_OFileInfosOn
  #KbdCTm_OFileInfosOff
  #KbdCTm_OFollowSongOn
  #KbdCTm_OFollowSongOff
  #KbdCTm_ORemMissingOn
  #KbdCTm_ORemMissingOff
  #KbdCTm_ORemSkippedOn
  #KbdCTm_ORemSkippedOff
  #KbdCTm_ORemPlayedOn
  #KbdCTm_ORemPlayedOff
  #KbdCTm_ONoEndMode
  #KbdCTm_OXFadeOn
  #KbdCTm_OMDModeOff
  #KbdCTm_OStopEachOn
  EndEnumeration

Global Dim INIKeyName.s(#KbdCountX)
Global Dim VkStr.s($FF)
Global Dim xKeyReg(#KbdCountX_Minus_KbdSplitN)

Procedure SetKeyConsts()
  Define.i xLong1

  ;KbdC_FFileMenu
    INIKeyName(#KbdC_FAddFileS) = "FileAddFile"
    INIKeyName(#KbdC_FAddDir) = "FileAddDir"
    INIKeyName(#KbdC_FAddPList) = "FileAddPL"
    INIKeyName(#KbdC_FRefreshCD) = "FileRefreshDrv"
    INIKeyName(#KbdC_FNewPL) = "FileNewPL"
    INIKeyName(#KbdC_FLoadPL) = "FileLoadPL"
    ;KbdC_FLoadPLMenu
      INIKeyName(#KbdC_FLoadPLDefault) = "FileLoadDefPL"
    INIKeyName(#KbdC_FReloadPL) = "FileReloadPL"
    INIKeyName(#KbdC_FSavePL) = "FileSavePL"
    INIKeyName(#KbdC_FSavePLas) = "FileSavePLAs"
    INIKeyName(#KbdC_FClearPL) = "FileClearPL"
    INIKeyName(#KbdC_FRemAllMiss) = "FileRemAllMiss"
    INIKeyName(#KbdC_FQuitSD) = "FileQuit"
;KbdC_CPCMenu
    INIKeyName(#KbdC_CPrev) = "PlayPrev"
    INIKeyName(#KbdC_CPlay) = "PlayPlay"
    INIKeyName(#KbdC_CPause) = "PlayPause"
    INIKeyName(#KbdC_CStop) = "PlayStop"
    INIKeyName(#KbdC_CNext) = "PlayNext"
    INIKeyName(#KbdC_CEnd) = "PlayEnd"
    INIKeyName(#KbdC_CRepSingle) = "PlayRepeatSingle"
    INIKeyName(#KbdC_CRepAll) = "PlayRepAll"
    INIKeyName(#KbdC_CRepRnd) = "PlayRepRandom"
    INIKeyName(#KbdC_CRepToggle) = "PlayRepToggle"
    INIKeyName(#KbdC_CIntroMode) = "PlayIntroMode"
    INIKeyName(#KbdC_CSeekB) = "PlaySeekBack"
    INIKeyName(#KbdC_CSeekF) = "PlaySeekFore"
    ;KbdC_CCurSongMenu
      INIKeyName(#KbdC_CCSSelFile) = "PlayCurSelect"
      INIKeyName(#KbdC_CCSRemFile) = "PlayCurRemove"
      INIKeyName(#KbdC_CCSDelFile) = "PlayCurDelete"
      INIKeyName(#KbdC_CCSExplorer) = "PlayCurExplorer"
  ;KbdC_PPLMenu
    INIKeyName(#KbdC_PPlaySkip) = "PLstSkipToSong"
    INIKeyName(#KbdC_PPlayEnd) = "PLstEndToSong"
    INIKeyName(#KbdC_PPlayNext) = "PLstPlayNext"
    INIKeyName(#KbdC_PFindCurrent) = "PLstFindCurNext"
    INIKeyName(#KbdC_PFind) = "PLstFindDialog"
    INIKeyName(#KbdC_PFindNext) = "PLstFindNextMatch"
    INIKeyName(#KbdC_PFindQuick) = "PLstFindQuick"
    INIKeyName(#KbdC_PSelRnd) = "PLstSelRandom"
    INIKeyName(#KbdC_PInvSel) = "PLstInvertSelection"
    INIKeyName(#KbdC_PRemSongs) = "PLstRemoveSongs"
    INIKeyName(#KbdC_PRem) = "PLstRemove"
    INIKeyName(#KbdC_PCopyPLEnd) = "PLstCopyToEnd"
    INIKeyName(#KbdC_PCrop) = "PLstCrop"
    INIKeyName(#KbdC_PDelFiles) = "PLstDelete"
    INIKeyName(#KbdC_PExplorer) = "PLstExplorer"
  ;KbdC_OOptionsMenu
    INIKeyName(#KbdC_OFading) = "OptnFading"
    INIKeyName(#KbdC_OSpektrum) = "OptnSpektrum"
    INIKeyName(#KbdC_OFileInfos) = "OptnFileInfos"
    INIKeyName(#KbdC_OFollowSong) = "OptnFollowSong"
    INIKeyName(#KbdC_ORemMissing) = "OptnRemoveMissing"
    INIKeyName(#KbdC_ORemSkipped) = "OptnRemoveSkipped"
    INIKeyName(#KbdC_ORemPlayed) = "OptnRemovePlayed"
    INIKeyName(#KbdC_ONoEndMode) = "OptnEndSongDefault"
    INIKeyName(#KbdC_OXFade) = "OptnEndSongCrossfade"
    INIKeyName(#KbdC_OMDMode) = "OptnEndSongMiniDiskMode"
    INIKeyName(#KbdC_OStopEach) = "OptnEndSongStop"
    INIKeyName(#KbdC_OEndModeTggle) = "OptnEndSongToggle"
    ;KbdC_CVolMenu
      INIKeyName(#KbdC_CVolUp) = "OptnVolUp"
      INIKeyName(#KbdC_CVolDown) = "OptnVolDown"
      INIKeyName(#KbdC_CVolMute) = "OptnVolMute"
      INIKeyName(#KbdC_CVol1) = "OptnVol10"
      INIKeyName(#KbdC_CVol2) = "OptnVol20"
      INIKeyName(#KbdC_CVol3) = "OptnVol30"
      INIKeyName(#KbdC_CVol4) = "OptnVol40"
      INIKeyName(#KbdC_CVol5) = "OptnVol50"
      INIKeyName(#KbdC_CVol6) = "OptnVol60"
      INIKeyName(#KbdC_CVol7) = "OptnVol70"
      INIKeyName(#KbdC_CVol8) = "OptnVol80"
      INIKeyName(#KbdC_CVol9) = "OptnVol90"
      INIKeyName(#KbdC_CVolFull) = "OptnVol100"
    ;KbdC_OPresetMenu
      INIKeyName(#KbdC_OPresetSave) = "OptnPresetSave"
      INIKeyName(#KbdC_OPresetLoad) = "OptnPresetLoad"
    INIKeyName(#KbdC_OSaveSetts) = "OptnSaveAll"
    INIKeyName(#KbdC_CMoreSetts) = "OptnMoreSettings"
  ;KbdC_TToolsMenu
    INIKeyName(#KbdC_OInternetRadio) = "ToolWebRadioGoto"
    INIKeyName(#KbdC_OInternetRadioRe) = "ToolWebRadioReconnect"
    INIKeyName(#KbdC_OInternetRadioHP) = "ToolWebRadioHomepage"
    ;KbdC_OAutoRFMenu
      INIKeyName(#KbdC_OAutoRF) = "ToolAutoRfPerformDef"
      INIKeyName(#KbdC_OAutoRFAlt) = "ToolAutoRfPerformAlt"
      INIKeyName(#KbdC_OAutoRFRem) = "ToolAutoRfRemoveDef"
      INIKeyName(#KbdC_OAutoRFRemI) = "ToolAutoRfRemoveInv"
      INIKeyName(#KbdC_OAutoRFSetup) = "ToolAutoRfSetup"
    INIKeyName(#KbdC_PGotoDir) = "ToolDirGoto"
    ;KbdC_ODirMenu
      INIKeyName(#KbdC_ODirCombo) = "ToolDirListAsCombo"
      INIKeyName(#KbdC_ODirTop) = "ToolDirListOnTop"
      INIKeyName(#KbdC_ODirLeft) = "ToolDirListOnLeft"
      INIKeyName(#KbdC_ODirAuto) = "ToolDirListAutoPos"
      INIKeyName(#KbdC_ODirToggle) = "ToolDirListToggle"
      INIKeyName(#KbdC_ODirInc) = "ToolDirListInc"
      INIKeyName(#KbdC_ODirDec) = "ToolDirListDec"
    INIKeyName(#KbdC_CPrevSongs) = "ToolShowPrevSongs"
    ;KbdC_OTimerMenu
      INIKeyName(#KbdC_OTimerEdit) = "ToolTimerSetup"
      INIKeyName(#KbdC_OTimerImport) = "ToolTimerImport"
      INIKeyName(#KbdC_OTimerExport) = "ToolTimerExport"
      INIKeyName(#KbdC_OTimerClear) = "ToolClearAll"
    INIKeyName(#KbdC_OSoundFontMenu) = "ToolPopupSoundFontsMenu"
      ;INIKeyName(#KbdC_OSoundFontRefresh) = "ToolRefreshSoundFonts"
    INIKeyName(#KbdC_OResetSnd) = "ToolResetSndSystem"
    INIKeyName(#KbdC_OVolCtrl) = "ToolOpenVolMixer"
  ;KbdC_IInfoMenu
    INIKeyName(#KbdC_IHelp) = "InfoHelp"
    INIKeyName(#KbdC_IAbout) = "InfoAbout"
  
  
  
  
  
  ;KbdSplit
  INIKeyName(#KbdC_GPrev) = "GlobPlayPrev"
  INIKeyName(#KbdC_GPlay) = "GlobPlayPlay"
  INIKeyName(#KbdC_GPlayPause) = "GlobPlayOrPause"
  INIKeyName(#KbdC_GPause) = "GlobPlayPause"
  INIKeyName(#KbdC_GStop) = "GlobPlayStop"
  INIKeyName(#KbdC_GNext) = "GlobPlayNext"
  INIKeyName(#KbdC_GEnd) = "GlobPlayEnd"
  INIKeyName(#KbdC_GRepSingle) = "GlobRepSingle"
  INIKeyName(#KbdC_GRepAll) = "GlobRepAll"
  INIKeyName(#KbdC_GRepRnd) = "GlobRepRandom"
  INIKeyName(#KbdC_GRepToggle) = "GlobRepToggle"
  INIKeyName(#KbdC_GIntroMode) = "GlobIntroMode"
  INIKeyName(#KbdC_GSeekB) = "GlobSeekBack"
  INIKeyName(#KbdC_GSeekF) = "GlobSeekFore"
  ;KbdC_GVolMenu
    INIKeyName(#KbdC_GVolUp) = "GlobVolUp"
    INIKeyName(#KbdC_GVolDown) = "GlobVolDown"
    INIKeyName(#KbdC_GVolMute) = "GlobVolMute"
    INIKeyName(#KbdC_GVol1) = "GlobVol10"
    INIKeyName(#KbdC_GVol2) = "GlobVol20"
    INIKeyName(#KbdC_GVol3) = "GlobVol30"
    INIKeyName(#KbdC_GVol4) = "GlobVol40"
    INIKeyName(#KbdC_GVol5) = "GlobVol50"
    INIKeyName(#KbdC_GVol6) = "GlobVol60"
    INIKeyName(#KbdC_GVol7) = "GlobVol70"
    INIKeyName(#KbdC_GVol8) = "GlobVol80"
    INIKeyName(#KbdC_GVol9) = "GlobVol90"
    INIKeyName(#KbdC_GVolFull) = "GlobVol100"

    INIKeyName(#KbdC_PPlaySkip) = "PLstSkipToSong"
    INIKeyName(#KbdC_PPlayEnd) = "PLstEndToSong"
    INIKeyName(#KbdC_PPlayNext) = "PLstPlayNext"
    INIKeyName(#KbdC_PFindCurrent) = "PLstFindCur"


  INIKeyName(#KbdC_GPlayDef) = "GlobPLstDefToSong"
  INIKeyName(#KbdC_GPlaySkp) = "GlobPLstSkipToSong"
  INIKeyName(#KbdC_GPlayEnd) = "GlobPLstEndToSong"
  INIKeyName(#KbdC_GPlayNxt) = "GlobPLstPlayNext"
  INIKeyName(#KbdC_GPrevSel) = "GlobPLstSelPrev"
  INIKeyName(#KbdC_GNextSel) = "GlobPLstSelNext"
  INIKeyName(#KbdC_GPrevPage) = "GlobPLstPageUp"
  INIKeyName(#KbdC_GNextPage) = "GlobPLstPageDown"
  INIKeyName(#KbdC_GCurNSel) = "GlobPLstFindCurNext"
  INIKeyName(#KbdC_GRandSel) = "GlobPLstSelRandom"
  
  INIKeyName(#KbdC_GIRadio) = "GlobToolWebRadioGoto"
  INIKeyName(#KbdC_GIRadioRe) = "GlobToolWebRadioReconnect"
  INIKeyName(#KbdC_GIRadioHP) = "GlobToolWebRadioHomepage"
  INIKeyName(#KbdC_GAutoRF) = "GlobToolAutoRfPerformDef"
  INIKeyName(#KbdC_GAutoRFAlt) = "GlobToolAutoRfPerformAlt"
  INIKeyName(#KbdC_GShowPlayer) = "GlobShowPlayerDef"
  INIKeyName(#KbdC_GShowPlayerPS) = "GlobShowPlayerAlt"
  INIKeyName(#KbdC_GShowMenu) = "GlobShowMenuDef"
  INIKeyName(#KbdC_GShowAltMenu) = "GlobShowMenuAdv"
  INIKeyName(#KbdC_GShowVolMenu) = "GlobShowMenuVol"
  INIKeyName(#KbdC_GShowTitle) = "GlobShowTitle"
  ; RemoveFile
  INIKeyName(#KbdC_GRemFile) = "GlobPlayCurRemove"
  INIKeyName(#KbdC_GDelFile) = "GlobPlayCurDelete"
  INIKeyName(#KbdC_GExplorer) = "GlobPlayCurExplorer"
  ; ResetSnd
  INIKeyName(#KbdC_GResetSND) = "GlobToolResetSndSystem"
  INIKeyName(#KbdC_GVolCtrl) = "GlobToolOpenVolMixer"
  INIKeyName(#KbdC_GQuit) = "GlobFileQuit"
  INIKeyName(#KbdC_GAbortReading) = "GlobAbortReading"
  
  For xLong1 = 1 To 255
    VkStr(xLong1) = "0x" + Right("0" + Hex(xLong1), 2)
    Next
  
  
  ;VkStr($1) = "LBUTTON"
  ;VkStr($2) = "RBUTTON"
  ;VkStr($3) = "CANCEL"
  ;VkStr($4) = "MBUTTON"
  ;VkStr($8) = "BACK"
  ;VkStr($9) = "TAB"
  ;VkStr($C) = "CLEAR"
  ;VkStr($D) = "RETURN"
  ;VkStr($10) = "SHIFT"
  ;VkStr($11) = "CONTROL"
  ;VkStr($12) = "MENU"
  ;VkStr($13) = "PAUSE"
  ;VkStr($14) = "CAPITAL"
  ;VkStr($15) = "KANA"
  ;VkStr($15) = "HANGEUL"
  ;VkStr($15) = "HANGUL"
  ;VkStr($17) = "JUNJA"
  ;VkStr($18) = "FINAL"
  ;VkStr($19) = "HANJA"
  ;VkStr($19) = "KANJI"
  ;VkStr($1B) = "ESCAPE"
  ;VkStr($1C) = "CONVERT"
  ;VkStr($1D) = "NONCONVERT"
  ;VkStr($1E) = "ACCEPT"
  ;VkStr($1F) = "MODECHANGE"
  ;VkStr($20) = "SPACE"
  VkStr($21) = "PgUp" ;PRIOR"
  VkStr($22) = "PgDn" ; NEXT"
  VkStr($23) = "End"
  VkStr($24) = "Home"
  VkStr($25) = "Left"
  VkStr($26) = "Up"
  VkStr($27) = "Right"
  VkStr($28) = "Down"
  ;VkStr($29) = "SELECT"
  ;VkStr($2a) = "PRINT"
  ;VkStr($2B) = "EXECUTE"
  ;VkStr($2C) = "SNAPSHOT"
  VkStr($2D) = "Ins"
  VkStr($2E) = "Del"
  ;VkStr($2F) = "HELP"
  VkStr($30) = "0"
  VkStr($31) = "1"
  VkStr($32) = "2"
  VkStr($33) = "3"
  VkStr($34) = "4"
  VkStr($35) = "5"
  VkStr($36) = "6"
  VkStr($37) = "7"
  VkStr($38) = "8"
  VkStr($39) = "9"
  VkStr($41) = "A"
  VkStr($42) = "B"
  VkStr($43) = "C"
  VkStr($44) = "D"
  VkStr($45) = "E"
  VkStr($46) = "F"
  VkStr($47) = "G"
  VkStr($48) = "H"
  VkStr($49) = "I"
  VkStr($4a) = "J"
  VkStr($4B) = "K"
  VkStr($4C) = "L"
  VkStr($4D) = "M"
  VkStr($4E) = "N"
  VkStr($4F) = "O"
  VkStr($50) = "P"
  VkStr($51) = "Q"
  VkStr($52) = "R"
  VkStr($53) = "S"
  VkStr($54) = "T"
  VkStr($55) = "U"
  VkStr($56) = "V"
  VkStr($57) = "W"
  VkStr($58) = "X"
  VkStr($59) = "Y"
  VkStr($5a) = "Z"
  ;VkStr($5B) = "LWIN"
  ;VkStr($5C) = "RWIN"
  ;VkStr($5D) = "Apps"
  VkStr($60) = "Num0"
  VkStr($61) = "Num1"
  VkStr($62) = "Num2"
  VkStr($63) = "Num3"
  VkStr($64) = "Num4"
  VkStr($65) = "Num5"
  VkStr($66) = "Num6"
  VkStr($67) = "Num7"
  VkStr($68) = "Num8"
  VkStr($69) = "Num9"
  VkStr($6a) = "Multiply"
  VkStr($6B) = "Add"
  ;VkStr($6C) = "Seperator"
  VkStr($6D) = "Substract"
  VkStr($6E) = "Decimal"
  VkStr($6F) = "Divide"
  VkStr($70) = "F1"
  VkStr($71) = "F2"
  VkStr($72) = "F3"
  VkStr($73) = "F4"
  VkStr($74) = "F5"
  VkStr($75) = "F6"
  VkStr($76) = "F7"
  VkStr($77) = "F8"
  VkStr($78) = "F9"
  VkStr($79) = "F10"
  VkStr($7a) = "F11"
  VkStr($7B) = "F12"
  VkStr($7C) = "F13"
  VkStr($7D) = "F14"
  VkStr($7E) = "F15"
  VkStr($7F) = "F16"
  VkStr($80) = "F17"
  VkStr($81) = "F18"
  VkStr($82) = "F19"
  VkStr($83) = "F20"
  VkStr($84) = "F21"
  VkStr($85) = "F22"
  VkStr($86) = "F23"
  VkStr($87) = "F24"
  ;VkStr($90) = "NUMLOCK"
  ;VkStr($91) = "SCROLL"
  ;VkStr($A0) = "LSHIFT"
  ;VkStr($A1) = "RSHIFT"
  ;VkStr($A2) = "LCONTROL"
  ;VkStr($A3) = "RCONTROL"
  ;VkStr($A4) = "LMENU"
  ;VkStr($A5) = "RMENU"
  VkStr($Ba) = "Oem1"
  VkStr($BB) = "OemPlus"
  VkStr($BC) = "OemComma"
  VkStr($BD) = "OemMinus"
  VkStr($BE) = "OemPeriod"
  VkStr($BF) = "Oem2"
  VkStr($C0) = "Oem3"
  VkStr($DB) = "Oem4"
  VkStr($DC) = "Oem5"
  VkStr($DD) = "Oem6"
  VkStr($DE) = "Oem7"
  VkStr($DF) = "Oem8"
  VkStr($E1) = "Oem9"
  VkStr($E2) = "Oem102"

  ;VkStr($E5) = "PROCESSKEY"
  ;VkStr($F6) = "ATTN"
  ;VkStr($F7) = "CRSEL"
  ;VkStr($F8) = "EXSEL"
  ;VkStr($F9) = "EREOF"
  VkStr($FA) = "Play"
  VkStr($FB) = "Zoom"
  ;VkStr($FC) = "NONAME"
  ;VkStr($FD) = "PA1"
  ;VkStr($FE) = "OEM_CLEAR"

  lkCtrl = LoadResString(3980)
  If Left(lkCtrl, 1) = "#"
    lkCtrl = ProperCaseString(GetKeyNameText(MapVirtualKey_(17, 0) * $10000), #True)
    EndIf
  lkAlt = LoadResString(3981)
  If Left(lkAlt, 1) = "#"
    lkAlt = ProperCaseString(GetKeyNameText(MapVirtualKey_(18, 0) * $10000), #True)
    EndIf
  lkShift = LoadResString(3982)
  If Left(lkShift, 1) = "#"
    lkShift = ProperCaseString(GetKeyNameText(MapVirtualKey_(16, 0) * $10000), #True)
    EndIf

  lkCombi(0) = lkShift + "+"
  lkCombi(1) = lkCtrl + "+"
  lkCombi(2) = lkCtrl + "+" + lkShift + "+"
  lkCombi(3) = lkCtrl + "+" + lkAlt + "+"
  lkCombi(4) = lkCtrl + "+" + lkAlt + "+" + lkShift + "+"
  EndProcedure

Procedure WriteKeyboardSetup(hTxtFileOut.i)
  Define.i xLong1
  Define.s xChar1

  For xLong1 = 0 To #KbdCountX
    If Len(INIKeyName(xLong1))
      If (xKey(xLong1) & $200)
        xChar1 = "Ctrl+"
        Else
        xChar1 = ""
        EndIf
      If (xKey(xLong1) & $100)
        xChar1 = xChar1 + "Shift+"
        EndIf
      ;If (xKey(xLong1) & $400)
      ;  xChar1 = xChar1 + "Alt+"
      ;  End If
      TxtFileWriter_WriteLine(hTxtFileOut, "Key" + INIKeyName(xLong1) + "=" + xChar1 + VkStr(xKey(xLong1) & $FF))
      EndIf
    Next
  EndProcedure

; boolean
Procedure.i ApplySpecKeyByStr(xKeyStr.s, xValueStr.s, *Index, *xValue)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.i xValue
  Define.i Index

;Debug "KIParse:" + xKeyStr + "/" + xValueStr
  ;xValue = 0
  Index = PeekI(*Index)
  
  Repeat
    If Left(xValueStr, 6) = "SHIFT+"
      xValueStr = Mid(xValueStr, 7)
      xValue = xValue | $100
      ElseIf Left(xValueStr, 5) = "CTRL+"
      xValueStr = Mid(xValueStr, 6)
      xValue = xValue | $200
      ;ElseIf Left(xValueStr, 4) = "ALT+"
      ;xValueStr = Mid(xValueStr, 5)
      ;xValue = xValue | $400
      Else
      Break
      EndIf
    ForEver
  If Left(xValueStr, 2) = "0X"
    xValue = xValue | UnHex(Mid(xValueStr, 3, 2))
    ElseIf Left(xValueStr, 2) = "$"
    xValue = xValue | UnHex(Mid(xValueStr, 2, 2))
    Else
    For xLong1 = 0 To 255
      If xValueStr = UCase(VkStr(xLong1))
        xValue = xValue | xLong1
;Debug "KIFound:" + VkStr(xLong1)
        Break
        EndIf
      Next
   EndIf
  ;Stop
  If Not (xValue & $FF)
    xValue = 0
    EndIf
;Debug xValue
;Debug UCase(INIKeyName(1)) + "?=" + xKeyStr
;  Debug "--------------------------------------------------------"
;  Debug "           " + xKeyStr
;  Debug "--------------------------------------------------------"
  For xLong1 = 0 To #KbdCountX
;    Debug UCase(INIKeyName(xLong1)) + "?=" + xKeyStr
    If UCase(INIKeyName(xLong1)) = xKeyStr
;Debug "KIMatch:" + INIKeyName(xLong1)
      Index = xLong1
      xResult = #True
      Break
      EndIf
    Next
  PokeI(*xValue, xValue)
  PokeI(*Index, Index)
  ProcedureReturn xResult
  EndProcedure

Procedure ApplySpecKeyByStrAndMaybeReset(xKeyStr.s, xValueStr.s)
  Define.i Index
  Define.i xValue
  Define.i xLong1

  If ApplySpecKeyByStr(xKeyStr, xValueStr, @Index, @xValue)
    If xValue
      If Index < #KbdSplit
        For xLong1 = 0 To #KbdSplitP
          If xKey(xLong1) = xValue
            xKey(xLong1) = 0
            EndIf
          Next
        Else
        For xLong1 = #KbdSplitN To #KbdCountX
          If xKey(xLong1) = xValue
            xKey(xLong1) = 0
            EndIf
          Next
        EndIf
      EndIf
    xKey(Index) = xValue
    EndIf
  EndProcedure

Procedure GetDefControls(Array xKeyArray.i(1))
  Define.i xLong1
  Define.s xChar1
  Define.i Index
  Define.i xValue
  Define.i hTxtFileIn

  hTxtFileIn = TxtFileReader_FromRes(@"CONTROLS", @"TEXT")
  If hTxtFileIn
    For xLong1 = 0 To #KbdCountX
      xKeyArray(xLong1) = 0
      Next

    While TxtFileReader_NextLine(hTxtFileIn)
      xChar1 = UCase(Trim(TxtFileReader_GetLineString(hTxtFileIn)))
      If Left(xChar1, 1) = "KEY"
        xChar1 = Mid(xChar1, 4)
        EndIf
      xLong1 = FindString(xChar1, "=")
      If xLong1
        If ApplySpecKeyByStr(RTrim(Left(xChar1, xLong1 - 1)), LTrim(Mid(xChar1, xLong1 + 1)), @Index, @xValue)
          If xValue
            If Index < #KbdSplit
              For xLong1 = 0 To #KbdSplitP
                If xKeyArray(xLong1) = xValue
                  xKeyArray(xLong1) = 0
                  EndIf
                Next
              Else
              For xLong1 = #KbdSplitN To #KbdCountX
                If xKeyArray(xLong1) = xValue
                  xKeyArray(xLong1) = 0
                  EndIf
                Next
              EndIf
            EndIf
          xKeyArray(Index) = xValue
          EndIf
        EndIf
      Wend
    TxtFileReader_Close(hTxtFileIn)
    EndIf
  EndProcedure

Procedure.i NonRealKey(KeyCode.i)
  Define.i xResult

  Select KeyCode
    Case 5, 6 ;, $E7, $E8
      xResult = #True
    EndSelect
  ProcedureReturn xResult
  EndProcedure



Procedure.i UnassignedKey(KeyCode.i)
  Define.i xResult
  
  Select (KeyCode & $FF)
    Case $88 To $8F, $92 To $F5
      xResult = #True
    EndSelect
  ProcedureReturn xResult
  EndProcedure

Procedure.s GetKeyCaption(KeyCode.i)
  Define.s xResult

  KeyCode = KeyCode & $FF
  If KeyCode
    If NonRealKey(KeyCode)
      Select KeyCode
        Case 5
          xResult = LoadResString(3995)
        Case 6
          xResult = LoadResString(3996)
        ;Case $E7
        ;  xResult = "##Mouse Wheel up"
        ;Case $E8
        ;  xResult = "##Mouse Wheel down"
        EndSelect
      Else
      xResult = GetKeyNameText($1 + (MapVirtualKey_(KeyCode, 0) & $FF) << 16)
      If Len(xResult) = 0
        xResult = "#" + Hex(KeyCode)
        ElseIf UnassignedKey(KeyCode)
        xResult = ProperCaseString(ReplaceString(xResult, " ", ""), #True) + " (#" + Hex(KeyCode) + ")"
        Else
        xResult = ProperCaseString(ReplaceString(xResult, " ", ""), #True)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s ExtKbdEx(Index.i)
  Define.s xResult
  Define.i xLong1
  
  If Index < #KbdSplitN
    xLong1 = ((xKey(Index) & $300) >> 8)
    ElseIf UnassignedKey(xKey(Index))
    xLong1 = ((xKey(Index) & $100) >> 8)
    Else
    xLong1 = 4 + ((xKey(Index) & $100) >> 8)
    EndIf
  Index = (xKey(Index) & $FF)
  If Index
    If xLong1
      xResult = lkCombi(xLong1 - 1) + GetKeyCaption(Index)
      Else
      xResult = GetKeyCaption(Index)
      EndIf
    Else
    xResult = LoadResString(3990)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure MainForm_SetGlobalKeys(UseThem.i)
  Define.i xLong1
  
  If UseThem
    CompilerIf #UseFileLogging
      MainForm_ctConsoleA_AddLog("Registering global keys")
      CompilerEndIf
     
     For xLong1 = #KbdSplitN To #KbdCountX
      If Not xKey(xLong1) = 0
        CompilerIf #NewKeyMode
          If NonRealKey(xKey(xLong1))
            xKeyReg(xLong1 - #KbdSplitN) = 1
            ElseIf UnassignedKey(xKey(xLong1))
            xKeyReg(xLong1 - #KbdSplitN) = RegisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1 - #KbdSplitN, ((xKey(xLong1) & $100) >> 6), (xKey(xLong1) & $FF))
            Else
            xKeyReg(xLong1 - #KbdSplitN) = RegisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1 - #KbdSplitN, $3 + ((xKey(xLong1) & $100) >> 6), (xKey(xLong1) & $FF))
            EndIf
CompilerIf #UseFileLogging
          If xKeyReg(xLong1 - #KbdSplitN) = 0
            MainForm_ctConsoleA_AddLog("Could not regKey: " + Str(xLong1) + ", " + Hex(xKey(xLong1)) + " (" + Str(UnassignedKey(xKey(xLong1))) + ")")
            EndIf
  CompilerEndIf
          CompilerElse
          RegisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1 - #KbdSplitN, $3 + ((xKey(xLong1) & $100) >> 6), (xKey(xLong1) & $FF))
          CompilerEndIf
        EndIf
      Next
    Else
    CompilerIf #UseFileLogging
      MainForm_ctConsoleA_AddLog("Unregistering global keys")
      CompilerEndIf
    ;DoEvents
    For xLong1 = 0 To #KbdCountX_Minus_KbdSplitN
      CompilerIf #NewKeyMode
        If Not xKeyReg(xLong1) = 0
          If Not NonRealKey(xKey(xLong1))
            ;ElseIf UnassignedKey(xKey(xLong1))
CompilerIf #ShowRegKeyStuff = 2
            If UnregisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1) = 0
              CompilerIf #UseFileLogging
                MainForm_ctConsoleA_AddLog("Could not UnRegKey: " + Str(xLong1) + ", " + Hex(xKey(xLong1)))
                CompilerElse
                Debug.Print "Could not UnRegKey: ", xLong1
                CompilerEndIf
              EndIf
CompilerElse
            UnregisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1)
CompilerEndIf
            EndIf
          xKeyReg(xLong1) = 0
          EndIf
        CompilerElse
        If Not xKey(#KbdSplitN + xLong1) = 0
          UnregisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1)
          EndIf
        CompilerEndIf
      Next
    
CompilerIf #ShowRegKeyStuff
    For xLong1 = 0 To 1000
      If Not UnregisterHotKey_(xStaticIconsHWnd(#xStaticIcons_ShowIR), xLong1) = 0
        Debug "PostUnReg:" + Str(xLong1)
        EndIf
      Next
CompilerEndIf
    EndIf
  
  EndProcedure

Procedure.i ValidSetupKey(KeyID.i)
  Define.i xResult
  Select KeyID
    Case #KbdSplit, #KbdC_FFileMenu, #KbdC_FLoadPLMenu
    Case #KbdC_CPCMenu, #KbdC_CCurSongMenu
    Case #KbdC_PPLMenu, #KbdC_OOptionsMenu, #KbdC_CVolMenu, #KbdC_OPresetMenu
    Case #KbdC_TToolsMenu, #KbdC_OAutoRFMenu, #KbdC_ODirMenu, #KbdC_OTimerMenu;, #KbdC_OSoundFontMenu
    Case #KbdC_IInfoMenu, #KbdC_GVolMenu
    Default
      xResult = #True
    EndSelect
  ProcedureReturn xResult
  EndProcedure

Procedure.i TimerHasSubFile(EventID.i)
  Define.i xResult
  Select EventID
    Case #KbdC_FAddFileS, #KbdC_FAddDir, #KbdC_FAddPList, #KbdC_FLoadPL, #KbdC_FSavePLas
      xResult = #True
    Case #KbdC_OTimerImport, #KbdC_OTimerExport, #KbdC_OPresetSave, #KbdC_OPresetLoad
      xResult = #True
    EndSelect
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = ----
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; AddResource = res\lng\en.rc