; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

; ******************************************************************************
;                Pre(?)-Variables, real independet functions
; ******************************************************************************
EnableExplicit


;-- Global vars
#DoEventsEx_SleepPeriodical_Interval = 200

#SimpleFadingTotalTime = 2000
;global State
Global IsDialoging.i
Global xTimerEditing.i
Global xPStateIconStartup.i
Global xAutoDoing.i
;Global xForceAnimationNow.i
Global xLoadingStream.i
Global xPStateIconPlaying.i
Global xPStateIconPaused.i
; teardown / layer
Global CurMusic.i
Global xSetVolume
Global KeepMusicAliveTime.i
#ctSSLayer_MusicTypeNone = 0
#ctSSLayer_MusicTypeTracker = 1
#ctSSLayer_MusicTypeStream = 2
#ctSSLayer_MusicTypeCDAudio = 3
#ctSSLayer_MusicTypeInetStream = 4
#ctSSLayer_SpectrumArrayCount = 32
Global xModCurPattern.i
Global PLCurSongLength.i
Global TrackerLoop.i
Global OutOfSessionPause.i
Global NotOutOfSessionOld.i
Global GlobalKeys.i
Global IRUMBar_IRTicks.i
Global xPStateIconSndcard.i
Global xPStateIconDeleting.i
Global PlayerInMenuLoop.i
Global xSongIsMidi.i
Global xModPanning.i




Global xSharedDC.i
; GUI
Global MainHWnd.i
; misc
Global HWndSetupDialogSSPage.i
Global xNoIRMode.i
Global vCanVolume.i


;*- Global vars



Procedure.i GetAccessSize(*Mem)
  Define.i xResult
  Define.i xLong1
  Define.MEMORY_BASIC_INFORMATION xType1

  If VirtualQuery_(*Mem, @xType1, SizeOf(MEMORY_BASIC_INFORMATION))
    xLong1 = xType1\RegionSize + (xType1\BaseAddress - *Mem)
    If xLong1 > 0
      If Not IsBadWritePtr_(*Mem, xLong1)
        xResult = xLong1
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i CreateCompatibleBitmapX(Width.i, Height.i)
  Define.i xResult
  Define.i hDC

  hDC = GetDC_(0)
  If hDC
    xResult = CreateCompatibleBitmap_(hDC, Width, Height)
    ReleaseDC_(0, hDC)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i NoProc(hWnd.i, Message.i, wParam.i, lParam.i)
  ProcedureReturn DefWindowProc_(hWnd, Message, wParam, lParam)
  EndProcedure

Procedure LoadResEx_Dialog_ListItemSet(HWndControl.i, ListIndex.i, NewText.s, SelectIt.i)
  If HWndControl
    SendMessage_(HWndControl, #LB_DELETESTRING, ListIndex, 0)
    SendMessage_(HWndControl, #LB_INSERTSTRING, ListIndex, @NewText)
    If SelectIt
      SendMessage_(HWndControl, #LB_SETSEL, 1, ListIndex)
      EndIf
    EndIf
  EndProcedure

Procedure LoadResEx_Dialog_ListItemSetData(HWndControl.i, ListIndex.i, NewNumber.i, SelectIt.i)
  If HWndControl
    SendMessage_(HWndControl, #LB_DELETESTRING, ListIndex, 0)
    SendMessage_(HWndControl, #LB_INSERTSTRING, ListIndex, NewNumber)
    If SelectIt
      SendMessage_(HWndControl, #LB_SETSEL, 1, ListIndex)
      EndIf
    EndIf
  EndProcedure

Procedure.i GetListCaret(hWndListBox.i, *ReturnValue)
  hWndListBox = SendMessage_(hWndListBox, #LB_GETCARETINDEX, 0, 0)
  PokeI(*ReturnValue, hWndListBox)
  If hWndListBox = -1
    ProcedureReturn #False
    EndIf
  ProcedureReturn #True
  EndProcedure

Procedure.i GetListIndexMS(hWndListBox.i, *ReturnValue)
  Define.i xLong1
  
  xLong1 = SendMessage_(hWndListBox, #LB_GETCARETINDEX, 0, 0)
  PokeI(*ReturnValue, xLong1)
  If xLong1 = -1
    ProcedureReturn #False
    EndIf
  xLong1 = SendMessage_(hWndListBox, #LB_GETSEL, xLong1, 0)
  If xLong1 > 0
    ProcedureReturn #True
    EndIf
  ProcedureReturn #False
  EndProcedure

Procedure SetListIndexMS(hWndListBox.i, ListIndex.i)
  SendMessage_(hWndListBox, #LB_SETSEL, 0, -1)
  SendMessage_(hWndListBox, #LB_SETSEL, 1, ListIndex)
  SendMessage_(hWndListBox, #LB_SETCURSEL, 1, ListIndex)
  SendMessage_(hWndListBox, #CB_SETCURSEL, ListIndex, 0)
  EndProcedure

Procedure.i MixRGB(Color1.i, Color2.i, PercentColor1.i = 50)
  Define.i xResult
  Define.i xLong1

  If (Color1 & $80000000)
    Color1 = GetSysColor_(Color1 & $FFFFFF)
    EndIf
  If (Color2 & $80000000)
    Color2 = GetSysColor_(Color2 & $FFFFFF)
    EndIf
  If PercentColor1 < 0
    PercentColor1 = 0
    ElseIf PercentColor1 > 100
    PercentColor1 = 100
    EndIf
  xLong1 = 100 - PercentColor1
  xResult = ((MulDiv_(Color1 & $FF0000, PercentColor1, 100) | MulDiv_(Color2 & $FF0000, xLong1, 100)) & $FF0000)
  xResult | ((MulDiv_(Color1 & $FF00,   PercentColor1, 100) | MulDiv_(Color2 & $FF00,   xLong1, 100)) & $FF00)
  xResult | ((MulDiv_(Color1 & $FF,     PercentColor1, 100) | MulDiv_(Color2 & $FF,     xLong1, 100)) & $FF)
  ProcedureReturn xResult
  EndProcedure

Procedure.s RealURL(xChar1.s)
  Define.i xLong1

  xLong1 = FindString(xChar1, #CR$)
  If xLong1
    xChar1 = Left(xChar1, xLong1 - 1)
    EndIf
  xLong1 = FindString(xChar1, #LF$)
  If xLong1
    xChar1 = Left(xChar1, xLong1 - 1)
    EndIf
  ProcedureReturn xChar1
  EndProcedure

Procedure.s StringFromCharCode(xLen.i, CharCode.i)
  Define.s xResult
  CompilerIf #PB_Compiler_Unicode
    Define *Mem
    Define.i xLong1
  
    xResult = Space(xLen)
    *Mem = @xResult
    For xLong1 = 1 To xLen
      PokeW(*Mem, CharCode)
      *Mem + 2
      Next
    CompilerElse
    xResult = Space(xLen)
    RtlFillMemory_(@xResult, xLen, CharCode)
    CompilerEndIf
  
  ProcedureReturn xResult
  EndProcedure

Procedure.s ProperCaseString(xChar1.s, FixKeys.i)
  Define.s xResult
  Define.i xBool1
  Define.s xChar2
  Define.i xLong1
  Define.i xLong2

  xLong2 = Len(xChar1)
  xBool1 = #True
  For xLong1 = 1 To xLong2
    xChar2 = Mid(xChar1, xLong1, 1)
    Select Asc(xChar2)
      Case 32
        xResult + xChar2
        xBool1 = #True
      Case 40 ;       (
        If FixKeys
          xBool1 = #True
;          Debug "***" + xResult + "***" + Right(xResult, 1) + "***" + Hex(Asc(Right(xResult, 1))) + "***"
          If Not Right(xResult, 1) = " "
            xResult + " "
            EndIf
          EndIf
        xResult + xChar2
      Case 41, 47 ;   )/
        xResult + xChar2
      Default
        If xBool1
          xResult + UCase(xChar2)
          xBool1 = #False
          Else
          xResult + LCase(xChar2)
          EndIf
      EndSelect
    Next
  ProcedureReturn xResult
  EndProcedure

Macro CreateWindowExOC(StyleEx, Class, Caption, Style, X, Y, Width, Height, hWndParent, hMenu, lParam)
  CreateWindowEx_(StyleEx, Class, Caption, Style, X, Y, Width, Height, hWndParent, hMenu, hInstance, lParam)
  EndMacro

Procedure.s BoolChar1(xBool1.i)
  If xBool1
    ProcedureReturn "1"
    EndIf
  ProcedureReturn "0"
  EndProcedure

Procedure SetUnicodeClipboard(NewSongName.s)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  
  If OpenClipboard_(MainHWnd)
    NewSongName = NewSongName
    xLong3 = Len(NewSongName)

    CompilerIf #PB_Compiler_Unicode
      xLong3 = xLong3 << 1
      xLong1 = GlobalAlloc_($2, xLong3 + 4)
      CompilerElse
      xLong1 = GlobalAlloc_($2, xLong3 + 2)
      CompilerEndIf
      
    If xLong1
      xLong2 = GlobalLock_(xLong1)
      If xLong2
        RtlMoveMemory_(xLong2, @NewSongName, xLong3)
        CompilerIf #PB_Compiler_Unicode
          PokeL(xLong2 + xLong3, 0)
          CompilerElse
          PokeW(xLong2 + xLong3, 0)
          CompilerEndIf
        GlobalUnlock_(xLong1)
        EmptyClipboard_()
        SetClipboardData_(13, xLong1)
        Else
        GlobalFree_(xLong1)
        EndIf
      EndIf
    CloseClipboard_()
    EndIf
  EndProcedure

Procedure.i IsFileExists(xChar1.s)
  If GetFileAttributes(xChar1) & $10
    ProcedureReturn #False
    EndIf
  ProcedureReturn #True
  EndProcedure

Procedure IsDirExists(xChar1.s)
  Define.i xLong1

  xLong1 = GetFileAttributes(xChar1)
  If xLong1 = -1
    ProcedureReturn #False
    EndIf
  If (xLong1 & $10)
    ProcedureReturn #True
    EndIf
  ProcedureReturn #False
  EndProcedure

;boolean
Procedure.i CreateDirectoryEx(FullPath.s)
  Define.s xChar1
  Define.i xLong1
  
  xLong1 = FindString(FullPath, "\")
  If xLong1
    FullPath = FullPath + "\"
    xChar1 = Left(FullPath, xLong1 - 1)
    FullPath = Mid(FullPath, xLong1 + 1)
    Repeat
      xLong1 = FindString(FullPath, "\")
      If xLong1 = 0
        Break
        EndIf
      xChar1 = xChar1 + "\" + Left(FullPath, xLong1 - 1)
      CreateDirectory_(xChar1, 0)
      FullPath = Mid(FullPath, xLong1 + 1)
      ForEver
    xLong1 = GetFileAttributes(xChar1)
    If (xLong1 & 16) And Not xLong1 = -1
      ProcedureReturn #True
      EndIf
    EndIf
  ProcedureReturn #False
  EndProcedure

Procedure.s FilteredCMD(xParam.s)
  Define.i xLong1
  Define.i xLong2
  
  Repeat
    xParam = Trim(xParam)
    If Not Len(xParam)
      Break
      EndIf
    If Left(xParam, 1) = "/"
      xLong1 = FindString(xParam + " ", " ")
      xLong2 = FindString(xParam + Chr(34), Chr(34))
      If xLong2 < xLong1
        xLong1 = FindString(xParam, Chr(34), xLong2 + 1)
        If xLong1
          xParam = Left(xParam, xLong2 - 1) + Mid(xParam, xLong1 + 1)
          Else
          xParam = ""
          EndIf
        Else
        xParam = Mid(xParam, xLong1 + 1)
        EndIf
      Else
      If Left(xParam, 1) = Chr(34)
        xParam = Mid(xParam, 2)
        xLong1 = FindString(xParam, Chr(34))
        Else
        xLong1 = FindString(xParam + " ", " ")
        EndIf
      If xLong1
        xParam = Left(xParam, xLong1 - 1)
        EndIf
      Break
      EndIf
    ForEver
  ProcedureReturn xParam
  EndProcedure

; [0 - [MaxValueP
Procedure.i URndDnP(MaxValueP)
  ProcedureReturn Random(MaxValueP-1)
  EndProcedure

;Procedure.i GetLocalTimeHMS()
;  Define.SYSTEMTIME xType1
;  GetLocalTime_(@xType1)
;  ProcedureReturn (xType1\wHour * 60) + xType1\wMinute) * 60 + xType1\wSecond
;  EndProcedure

Procedure.i GetLocalTimeHM()
  Define.SYSTEMTIME xType1
  GetLocalTime_(@xType1)
  ProcedureReturn xType1\wHour * 60 + xType1\wMinute
  EndProcedure

Procedure.i GetLocalTimeHMS_HS()
  Define.SYSTEMTIME xType1
  GetLocalTime_(@xType1)
  ProcedureReturn ((xType1\wHour * 60 + xType1\wMinute) * 60 + xType1\wSecond) * 100 + Int(xType1\wMilliseconds / 10)
  EndProcedure

Procedure RemoveListItemMS(hWnd.i, Index.i)
  Define.i xLong1
  
  xLong1 = SendMessage_(hWnd, #LB_GETCARETINDEX, 0, 0)
;  Debug.Print "OldCaret (Get): ", xLong1
  SendMessage_(hWnd, #LB_DELETESTRING, Index, 0)
;CompilerIf #UseFileLogging
;  Debug.Print "Remove: ", xLong1, "from", hWnd
;CompilerEndIf
  If xLong1 >= Index And Not xLong1 = 0
    SendMessage_(hWnd, #LB_SETCARETINDEX, xLong1 - 1, 0)
;    Debug.Print "NewCaret (Set): ", xLong1 - 1
    EndIf
  EndProcedure

Procedure HookWindow(hWnd.i, *Addr)
  If hWnd
    SetWindowLong_(hWnd, -21, SetWindowLong_(hWnd, -4, *Addr))
    EndIf
  EndProcedure

Procedure.i HookedWindowProc(hWnd.i, Msg.i, wParam.i, lParam.i)
  Define.i xLong1

  xLong1 = GetWindowLong_(hWnd, -21)
  If xLong1
    xLong1 = CallWindowProc_(xLong1, hWnd, Msg, wParam, lParam)
    EndIf
  ProcedureReturn xLong1
  EndProcedure

Procedure UnhookWindow(hWnd.i)
  Define.i xLong1

  If hWnd
    xLong1 = GetWindowLong_(hWnd, -21)
    If xLong1
      SetWindowLong_(hWnd, -4, xLong1)
      EndIf
    EndIf
  EndProcedure

;ThisTimeShift
Procedure CheckboxAccelerate(hWnd.i)
  Define.i xLong1
  If IsWindowEnabled_(hWnd)
    If (GetWindowLong_(hWnd, -16) & $F) = 3
      If SendMessage_(hWnd, $F0, 0, 0) = 0
        xLong1 = 1
        EndIf
      SendMessage_(hWnd, $F1, xLong1, 0)
      EndIf
    EndIf
  EndProcedure

Procedure LoadResEx_Dialog_Enable(DialogHWnd.i, ControlID.i, Enable.i)
  ControlID = GetDlgItem_(DialogHWnd, ControlID)
  If ControlID
    If Enable
      Enable = #True
      EndIf
    EnableWindow_(ControlID, Enable)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = ------
; EnableXP
; CompileSourceDirectory