; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

#SelfPathElipse = #True ;also mainform

Global Setup_hKeyFontR.i
Global Setup_hKeyFontB.i
Global Setup_hKeyFontL.i

Global Setup_WaitForAGlobalKey.i
Global Setup_WaitForKeyDialogExProcOld.i
Global Setup_PopupMenu.i
Global Setup_Menu.i

Global Setup_HWndKeyList.i
Global HWndSetupKeyApply.i
Global Setup_KeyRow1.i
Global Setup_KeyRow2.i
Global Setup_DialogKBDOldProc.i
Global Setup_UsedTypesTmp.s

Global HWndSetupDialog.i
Global HWndSetupDialogKeyPage.i

Global Setup_KeysChangedHigh.i
Global Setup_KeysChangedLow.i
Global Dim Setup_RegRegF.i(2)
Global Dim Setup_xNewKey.i(#KbdCountX)
Global Setup_WaitForKeyApplyIcon.i

Global Setup_DPIScaleX.f
Global Setup_DPIScaleY.f
Global Dim Setup_FileBox_Hwnds.i(99)
Global Dim Setup_FileBox_SepMe.b(99)
Global Dim Setup_FileBox_Texts.s(99)
Global Setup_FileBox_Count.i
Global Setup_HasFonted.i
Global Setup_FontHeightB.i
Global Setup_FontHeightR.i
Global Setup_HWndSFPage.i

Procedure.i Setup_CreateFonts()
  Define.i xLong1
  ;Define.LOGFONT xType1
  ;Define.TEXTMETRIC xType3
  Define.NONCLIENTMETRICS xType1
  Define *xType2.LOGFONT

  If Not Setup_HasFonted
    xType1\cbSize = SizeOf(NONCLIENTMETRICS)
    If SystemParametersInfo_(#SPI_GETNONCLIENTMETRICS, 0, @xType1, 0)
      *xType2 = @xType1\lfStatusFont
      Setup_hKeyFontR = CreateFontIndirect_(*xType2)
      If Setup_hKeyFontR
        If SelectObject_(xSharedDC, Setup_hKeyFontR)
          Setup_FontHeightR = GetTextOutHeight(xSharedDC, #DefTxt)
          Setup_FontHeightB = Setup_FontHeightR
          EndIf
        Setup_hKeyFontB = Setup_hKeyFontR
        EndIf

      If *xType2\lfWeight > 499
        *xType2\lfWeight = 900
        ElseIf *xType2\lfWeight < 300
        *xType2\lfWeight = 600
        Else
        *xType2\lfWeight + 300
        EndIf

      Setup_hKeyFontL = CreateFontIndirect_(*xType2)
      If Setup_hKeyFontL
        If SelectObject_(xSharedDC, Setup_hKeyFontL)
          Setup_hKeyFontB = Setup_hKeyFontL
          Setup_FontHeightB = GetTextOutHeight(xSharedDC, #DefTxt)
          EndIf
        EndIf
      EndIf
    Setup_HasFonted = #True
    EndIf
  EndProcedure

Procedure Setup_DiscardFonts()
  If Setup_HasFonted
    Setup_hKeyFontB = 0
    If Setup_hKeyFontR
      SelectObject_(xSharedDC, hFontGFix)
      DeleteObject_(Setup_hKeyFontR)
      Setup_hKeyFontR = 0
      EndIf
    If Setup_hKeyFontL
      SelectObject_(xSharedDC, hFontGFix)
      DeleteObject_(Setup_hKeyFontL)
      Setup_hKeyFontL = 0
      EndIf
    Setup_FontHeightB = 0
    Setup_FontHeightR = 0
    Setup_HasFonted = #False
    EndIf
  EndProcedure

Procedure Setup_SetApply(HwndFromDialog.i)
  SendMessage_(HWndSetupDialog, $468, HwndFromDialog, 0)
  EndProcedure

Procedure Setup_TrySetApply(HWndDialog.i, HWndControl.i, xEvent.i)
  Select UCase(GetClassName(HWndControl))
    Case #W_BUTTON
      If (GetWindowLong_(HWndControl, -16) & $f) > 1
        Setup_SetApply(HWndDialog)
        EndIf
    Case "COMBOBOX"
      If (xEvent & $FFFF0000) = $10000
        Setup_SetApply(HWndDialog)
        EndIf
    Case #W_EDIT
      If (xEvent & $FFFF0000) = $3000000
        Setup_SetApply(HWndDialog)
        EndIf
    EndSelect
  EndProcedure

Procedure Setup_ReadRegestry()
  Define.i xLong1
  Define.i xLong2
  Define.i xBool1
  Define.s xChar1
  ;Dim xChar1 As String

  GetIsAutoRun()
  
  ; playlistformatsimport
  If RegFolderMode(2)
    If RegFolderMode(2)
      Setup_RegRegF(2) = 2
      Else
      Setup_RegRegF(2) = 1
      EndIf
CompilerIf #PB_Compiler_Unicode
    ElseIf RegisterFileTypes_GetRegistered("m3u8", LoadResString(3527), @xBool1)
CompilerElse
    ElseIf RegisterFileTypes_GetRegistered("m3u", LoadResString(3527), @xBool1)
CompilerEndIf
    If xBool1
      Setup_RegRegF(2) = 2
      Else
      Setup_RegRegF(2) = 1
      EndIf
    Else
    Setup_RegRegF(2) = 0
    EndIf
  
  For xLong2 = 0 To 1
    xChar1 = "Folder\Shell\" + LoadResString(3534 + xLong2 * 5) + "\command"
    If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1) = 0
      RegCloseKey_(xLong1)
      If RegFolderMode(xLong2)
        Setup_RegRegF(xLong2) = 1
        Else
        Setup_RegRegF(xLong2) = 2
        EndIf
      Else
      Setup_RegRegF(xLong2) = 0
      EndIf
    Next
  EndProcedure

Procedure Setup_UpdateKeyListWidth()
  Define.i xLong1
  Define.i xLong2
  Define.s xChar1
  Define.i xOldWidth3
  Define.i hdc
  Define.i hFontOld

  hDC = CreateCompatibleDC_(0)
  If hDC = 0
    hDC = xSharedDC
    EndIf
  
  hFontOld = SelectObject_(hDC, Setup_hKeyFontR)
  SelectObject_(xSharedDC, Setup_hKeyFontB)
  For xLong1 = 0 To #KbdCountX
    If Setup_xNewKey(xLong1)
      xChar1 = GetKeyCaption(Setup_xNewKey(xLong1) & $FF)
      If ValidSetupKey(xLong1) Or xLong1 = #KbdC_FLoadPLMenu
        xLong2 = GetTextOutWidth(xSharedDC, xChar1)
        Else
        xLong2 = GetTextOutWidth(hdc, xChar1)
        EndIf
      If xLong2 > xOldWidth3
        xOldWidth3 = xLong2
        EndIf
      EndIf
    Next
  
  SelectObject_(hDC, hFontOld)
  If Not hDC = xSharedDC
    DeleteDC_(hDC)
    EndIf
  
  xOldWidth3 = xOldWidth3 + Setup_KeyRow2 ;+ Setup_KeyRow2
  SendMessage_(Setup_HWndKeyList, #LB_SETHORIZONTALEXTENT, xOldWidth3 + 4, 0)
  EndProcedure

Procedure LoadResEx_PagedDialog(hWndOwner.i, ResIDFirst.i, ResIDLast.i, ResIDStep.i, CallBackProc.i = 0, Caption.s = "", ContextHelp.i = #False)
  Define.i xLong1
  Define.i xLong2
  Define *PrepShetColl

  If ResIDLast >= ResIDFirst
    *PrepShetColl = PropertySheetCollection_Create((ResIDLast - ResIDFirst) / ResIDStep + 1)
    If *PrepShetColl
      While ResIDFirst <= ResIDLast
        PropertySheetCollection_AddPage(*PrepShetColl, ResIDFirst, CallBackProc)
        ResIDFirst + ResIDStep
        Wend
      PropertySheetCollection_ShowDialogOnce(*PrepShetColl, hWndOwner, Caption, CallBackProc, ContextHelp)
      PropertySheetCollection_Discard(*PrepShetColl)
      EndIf
    EndIf
  EndProcedure

Procedure.i Setup_WaitForKeyDialogExProc(hWnd.i, Message.i, wParam.i, lParam.i)
  Define.i xLong1

  Select Message
    Case $101, $100
      Select wParam
        Case 13, 16, 17
        Case 37, 39
          xLong1 = GetShiftCode()
          If Setup_WaitForAGlobalKey Or (xLong1 & 3)
            EndDialog_(GetParent_(hWnd), wParam + xLong1 << 16)
            ProcedureReturn 0
            EndIf
        Case 33 To 40
          xLong1 = GetShiftCode()
          If Setup_WaitForAGlobalKey Or (xLong1 & 2)
            EndDialog_(GetParent_(hWnd), wParam + xLong1 * $10000)
            ProcedureReturn 0
            EndIf
        Case 46
          If Not Setup_WaitForAGlobalKey
            EndDialog_(GetParent_(hWnd), wParam + GetShiftCode() << 16)
            ProcedureReturn 0
            EndIf
        Default
          ;Debug.Print "Res:", wParam
          EndDialog_(GetParent_(hWnd), wParam + GetShiftCode() << 16)
          ProcedureReturn 0
        EndSelect
    Case $102
    Case $20B, $AB
      If (wParam & $60)
         ; similar to MainForm_TryFindKeyEventWParam!!!
        EndDialog_(GetParent_(hWnd), ((wParam & $60) >> 5) + 4 + ((wParam & $C) << 6))
        EndIf
    EndSelect
  ProcedureReturn CallWindowProc_(Setup_WaitForKeyDialogExProcOld, hWnd, Message, wParam, lParam)
  EndProcedure

Procedure.i Setup_WaitForKeyDialogProc(hWnd.i, Message.i, wParam.i, lParam.i)
  Select Message
    Case $111
      If Not wParam = 0
        ;WaitKeyDone #True
        EndDialog_(hWnd, 0)
        EndIf
    Case $10
      ;WaitKeyDone #True
      EndDialog_(hWnd, 0)
    Case $110
      lParam = GetDlgItem_(hWnd, 3701)
      If lParam
        Setup_WaitForKeyApplyIcon = LoadResEx_ImageIconWEMFToHWnd_MultiOS(lParam, 3700)
        EndIf
      If wParam = 0
        wParam = GetDlgItem_(hWnd, 3700)
        If wParam = 0
          EndDialog_(hWnd, 0)
          Else
          SetWindowLong_(wParam, -4, @Setup_WaitForKeyDialogExProc())
          SetFocus_(wParam)
          ProcedureReturn 1
          EndIf
        Else
        Setup_WaitForKeyDialogExProcOld = SetWindowLong_(wParam, -4, @Setup_WaitForKeyDialogExProc())
        ProcedureReturn 1
        EndIf
    EndSelect
  ProcedureReturn 0
  EndProcedure

Procedure Setup_SetKeyNow(xWaitKey.i, Shift.i, KeyCode.i)
  Select KeyCode
    Case 0 To 4, 7 To 31, 93, 144 ; 38, 40, 93
      ;Debug.Print "Skipped: ", KeyCode
      KeyCode = 0
    Case 5, 6, 32 To 40 ;, $E7, $E8  ;40
      If Shift = 0 And xWaitKey < #KbdSplit
        ;Debug.Print "Ignored: ", KeyCode
        KeyCode = 0
        EndIf
    Case 46
      If xWaitKey > #KbdSplit
        ;Debug.Print "Ignored: ", KeyCode
        KeyCode = 0
        EndIf
    EndSelect
  If UnassignedKey(KeyCode)
    If xWaitKey < #KbdSplit
      KeyCode = 0
      Else
      Shift = (Shift & 3)
      EndIf
    ElseIf Not xWaitKey < #KbdSplit
    Shift = (Shift & 1)
    EndIf
  
;Debug.Print "KeyCode", KeyCode
  If Not KeyCode = 0
    Setup_xNewKey(xWaitKey) = Shift * $100 + KeyCode
    LoadResEx_Dialog_ListItemSetData(Setup_HWndKeyList, xWaitKey, xWaitKey, #True)
    Setup_SetApply(HWndSetupDialogKeyPage)

    If xWaitKey > #KbdSplit
      Setup_KeysChangedHigh = #True
      For Shift = #KbdSplitN To #KbdCountX
        If Setup_xNewKey(Shift) = Setup_xNewKey(xWaitKey) And Not Shift = xWaitKey
          Setup_xNewKey(Shift) = 0
          LoadResEx_Dialog_ListItemSetData(Setup_HWndKeyList, Shift, Shift, #False)
          EndIf
        Next
      Else
      Setup_KeysChangedLow = #True
      For Shift = 0 To #KbdSplitP
        If Setup_xNewKey(Shift) = Setup_xNewKey(xWaitKey) And Not Shift = xWaitKey
          Setup_xNewKey(Shift) = 0
          LoadResEx_Dialog_ListItemSetData(Setup_HWndKeyList, Shift, Shift, #False) ;#True
          EndIf
        Next
      EndIf
    If Not HWndSetupKeyApply = 0
      EnableWindow_(HWndSetupKeyApply, #True)
      ShowWindow_(HWndSetupKeyApply, 0)
      ShowWindow_(HWndSetupKeyApply, 1)
      EndIf
    Setup_UpdateKeyListWidth()
    EndIf
  EndProcedure

Procedure Setup_TrySetupKey(HWndList.i)
  Define.i xLong1
  
  If GetListIndexMS(HWndList, @xLong1)
    If ValidSetupKey(xLong1)
      If (xLong1 > #KbdSplit)
        Setup_WaitForAGlobalKey = #True
        Else
        Setup_WaitForAGlobalKey = #False
        EndIf
      HWndList = DialogBoxParam_(hInstance, 3700, HWndSetupDialog, @Setup_WaitForKeyDialogProc(), 0)
      If Setup_WaitForKeyApplyIcon
        DestroyIcon_(Setup_WaitForKeyApplyIcon)
        Setup_WaitForKeyApplyIcon = 0
        EndIf
      If HWndList
        Setup_SetKeyNow(xLong1, (HWndList >> 16) & $3, HWndList & $Ff)
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure Setup_ClearSomeKeys()
  Define.i xLong1
  Define.i xBool1

  For xLong1 = 0 To #KbdCountX
    If Setup_xNewKey(xLong1)
      If SendMessage_(Setup_HWndKeyList, #LB_GETSEL, xLong1, 0)
        Setup_xNewKey(xLong1) = 0
        LoadResEx_Dialog_ListItemSetData(Setup_HWndKeyList, xLong1, xLong1, #True)
        If xLong1 < #KbdSplit
          Setup_KeysChangedLow = #True
          Else
          Setup_KeysChangedHigh = #True
          EndIf
        xBool1 = #True
        EndIf
      EndIf
    Next
  If xBool1
    If Not HWndSetupKeyApply = 0
      EnableWindow_(HWndSetupKeyApply, 1)
      ShowWindow_(HWndSetupKeyApply, 0)
      ShowWindow_(HWndSetupKeyApply, 1)
      EndIf
    Setup_UpdateKeyListWidth()
    Setup_SetApply(HWndSetupDialogKeyPage)
    EndIf
  EndProcedure

Procedure Setup_ApplyKbdListMenuOrButton(hList.i, xID.i)
  If hList
    Select xID
      Case 3405
        Setup_TrySetupKey(hList)
      Case 3406
        Setup_ClearSomeKeys()
      EndSelect
    EndIf
  EndProcedure

Procedure.i Setup_IntToExtDepth(Index.i)
  Select Index
    Case #KbdC_FFileMenu, #KbdC_CPCMenu, #KbdC_PPLMenu, #KbdC_OOptionsMenu, #KbdC_TToolsMenu, #KbdC_IInfoMenu, #KbdSplit
      ProcedureReturn 4
    Case #KbdC_FLoadPLDefault
      ProcedureReturn 44
    Case #KbdC_CCSSelFile To #KbdC_CCSExplorer
      ProcedureReturn 44
    Case #KbdC_CVolUp To #KbdC_CVolFull
      ProcedureReturn 44
    Case #KbdC_OPresetSave To #KbdC_OPresetLoad
      ProcedureReturn 44
    Case #KbdC_OAutoRF To #KbdC_OAutoRFSetup
      ProcedureReturn 44
    Case #KbdC_PGotoDir To #KbdC_ODirDec
      ProcedureReturn 44
    Case #KbdC_OTimerEdit To #KbdC_OTimerClear
      ProcedureReturn 44
    ;Case #KbdC_OSoundFontRefresh
    ;  ProcedureReturn 44
    Case #KbdC_GVolUp To #KbdC_GVolFull
      ProcedureReturn 44
    EndSelect
  ProcedureReturn 24
  EndProcedure

Procedure Setup_DrawSKLVItem(*lParam)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xLong5
  Define.i hFontOld
  Define.DRAWITEMSTRUCT xType1
  Define.RECT xType3
  Define.s xChar1
  
  If *lParam
    MemCopyRTL(@xType1, *lParam, SizeOf(DRAWITEMSTRUCT))
    If xType1\hdc
      xLong1 = GetBkColor_(xType1\hdc)
      xLong2 = GetTextColor_(xType1\hdc)
      xLong3 = xType1\rcItem\Left
      xLong4 = xType1\rcItem\Right
      
      If (xType1\itemState & $1)
        If xType1\ItemID = -1
          Goto IDUnknown
          EndIf
  CompilerIf #ListFocusedLists
        If ValidSetupKey(xType1\ItemID) And xCurFocusHWnd = xType1\hwndItem
  CompilerElse
        If ValidSetupKey(xType1\ItemID)
  CompilerEndIf
          FillRect_(xType1\hdc, xType1\rcItem, 14)
          SetBkColor_(xType1\hdc, SysColor13)
          SetTextColor_(xType1\hdc, SysColor14)
          Else
  IDUnknown:
          FillRect_(xType1\hdc, xType1\rcItem, 16)
          SetBkColor_(xType1\hdc, SysColor15)
          SetTextColor_(xType1\hdc, SysColor8)
          EndIf
        Else
        ;If ValidSetupKey(xType1\itemID)
        If xType1\ItemID = #KbdC_FLoadPLMenu
          SetTextColor_(xType1\hdc, SysColor17)
          EndIf
        FillRect_(xType1\hdc, xType1\rcItem, 6)
        EndIf
        
      If Not xType1\ItemID = -1
        xType1\rcItem\Left = Setup_IntToExtDepth(xType1\ItemID)
        xChar1 = LoadResString(3700 + xType1\ItemID)
        If ValidSetupKey(xType1\ItemID) Or xType1\ItemID = #KbdC_FLoadPLMenu
          hFontOld = SelectObject_(xType1\hdc, Setup_hKeyFontR)
          DrawText_(xType1\hdc, @xChar1, Len(xChar1), xType1\rcItem, $924)
          Else
          DrawText_(xType1\hdc, @xChar1, Len(xChar1), xType1\rcItem, $924)
          If Not xType1\ItemID = #KbdC_FLoadPLMenu
            xType3 = xType1\rcItem
            DrawText_(xType1\hdc, @xChar1, Len(xChar1), xType3, $D24)
            xType3\Top = xType3\Bottom - 1
            xType3\Left - 3
            xType3\Right + 4
            FillRect_(xType1\hdc, xType3, 9)
            EndIf
          EndIf
        
        If Setup_xNewKey(xType1\ItemID)
          If ValidSetupKey(xType1\ItemID)
            If xType1\ItemID < #KbdSplitN
              xLong5 = (Setup_xNewKey(xType1\ItemID) >> 8) & $3
              If xLong5 = 0
                Goto NoPrefix
                EndIf
              ElseIf UnassignedKey(Setup_xNewKey(xType1\ItemID))
              xLong5 = (Setup_xNewKey(xType1\ItemID) >> 8) & $1
              If xLong5 = 0
                Goto NoPrefix
                EndIf
              Else
              xLong5 = 4 + (Setup_xNewKey(xType1\ItemID) >> 8) & $1
              EndIf
            xType1\rcItem\Right = Setup_KeyRow2 ;- xKeyMod(xLong5)
            DrawText(xType1\hdc, lkCombi(xLong5 - 1), xType1\rcItem, $926)
  NoPrefix:
            xType1\rcItem\Left = Setup_KeyRow2
            xType1\rcItem\Right = xLong4
            xChar1 = GetKeyCaption(Setup_xNewKey(xType1\ItemID))
            DrawText_(xType1\hdc, @xChar1, Len(xChar1), xType1\rcItem, $924)
            EndIf
          EndIf
          
        ;If ValidSetupKey(xType1\itemID)
          SetTextColor_(xType1\hdc, SysColor8)
          If (xType1\itemState & $1) = 0
            SetBkColor_(xType1\hdc, SysColor5)
            Else
            SetBkColor_(xType1\hdc, SysColor15)
            EndIf
        xType1\rcItem\Left = xLong3
        If Not hFontOld = 0
          SelectObject_(xType1\hdc, hFontOld)
          EndIf
        EndIf
      SetBkColor_(xType1\hdc, xLong1)
      SetTextColor_(xType1\hdc, xLong2)
      xType1\rcItem\Right = xLong4
      EndIf
    If (xType1\itemState & $10)
      ;  DefWindowProc_(hwnd, Message, wParam, lParam)
      DrawFocusRect_(xType1\hdc, xType1\rcItem)
      EndIf
    EndIf
  EndProcedure

Procedure.i LoadResEx_Dialog_CheckLongManualHandle(DialogHWnd.i, wParam.i, lParam.i)
  Define.i xResult
  Define.i xLong1
  xLong1 = (wParam & $FFFF)
  xResult = -1
  
  If lParam
    If (GetWindowLong_(lParam, -16) & $F) = $5
      wParam = (IsDlgButtonChecked_(DialogHWnd, xLong1) + 2) % 3
      CheckDlgButton_(DialogHWnd, xLong1, wParam)
      xResult = (3 - wParam) % 3
      SetDlgItemText_(DialogHWnd, xLong1, LoadResString(xLong1 + xResult))
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure Setup_FileBox_TryClick(HWndDialog.i, ControlID.i)
  Define.i xLong1
  Define.s xChar1
  Define.s xChar2
  Define.s xChar3
  Define.i xIndex.i
  Define.i xBool1.i
  
  xIndex = ControlID - 3310
  xChar1 = Setup_FileBox_Texts(xIndex) + ","
  xChar3 = Setup_UsedTypesTmp
  
  If IsDlgButtonChecked_(HWndDialog, ControlID)
    xBool1 = 0
    Else
    xBool1 = 1
    EndIf
  
  Repeat
    xLong1 = FindString(xChar1, ",")
    If xLong1 = 0
      Break
      EndIf
    xChar2 = Left(xChar1, xLong1 - 1)
    xChar3 = ReplaceString(xChar3, #UsedTypesVBNullChar + xChar2 + #UsedTypesVBNullChar, #UsedTypesVBNullChar)
    If xBool1 = 1
      xChar3 = xChar3 + xChar2 + #UsedTypesVBNullChar
      EndIf
    xChar1 = Mid(xChar1, xLong1 + 1)
    ForEver
  
  If Not xChar3 = #UsedTypesVBNullChar
    Setup_UsedTypesTmp = xChar3
    CheckDlgButton_(HWndDialog, ControlID, xBool1)
    EndIf
  EndProcedure

Procedure Setup_FileBox_Crt(HWndDialog.i)
  Define.i xLong1
  Define.i xLong2
  Define.s xChar1

; 1 = main title / bold (padding if not first, next item force new line)
  If GetDlgItem_(HWndDialog, 3300)
    For xLong1 = 0 To 1
      CompilerIf #UsedTypesVBNullChar = ";"
        xChar1 = ctSSLayer_GetInfoString($10 + xLong1)
        If xLong1 = 1
          xChar1 = xChar1 + ctSSLayer_GetInfoString($12)
          EndIf
        CompilerElse
        xChar1 = ReplaceString(ctSSLayer_GetInfoString($10 + xLong1), ";", #UsedTypesVBNullChar)
        If xLong1 = 1
          xChar1 = xChar1 + ReplaceString(ctSSLayer_GetInfoString($12), ";", #UsedTypesVBNullChar)
          EndIf
        CompilerEndIf
      If Not xChar1 = ""
        Setup_FileBox_Hwnds(Setup_FileBox_Count) = CreateWindowEx($0, #W_STATIC, LoadResString(3300 + xLong1), $50000000, 0, 0, 127, 16, HWndDialog)
        If Setup_FileBox_Hwnds(Setup_FileBox_Count)
          Setup_FileBox_SepMe(Setup_FileBox_Count) = 1
          Setup_FileBox_Count + 1
          EndIf
    
        Repeat
          xLong2 = FindString(xChar1, #UsedTypesVBNullChar)
          If xLong2 = 0
            Break
            EndIf
          Setup_FileBox_Hwnds(Setup_FileBox_Count) = CreateWindowEx($0, #W_BUTTON, Left(xChar1, xLong2 - 1), $50010005, 0, 0, 127, 16, HWndDialog)
          If Setup_FileBox_Hwnds(Setup_FileBox_Count)
            SetWindowLong_(Setup_FileBox_Hwnds(Setup_FileBox_Count), -12, 3310 + Setup_FileBox_Count)
            Setup_FileBox_SepMe(Setup_FileBox_Count) = 0
            Setup_FileBox_Texts(Setup_FileBox_Count) = Left(xChar1, xLong2 - 1)
            Setup_FileBox_Count + 1
            EndIf
          xChar1 = Mid(xChar1, xLong2 + 1)
          ForEver
        EndIf
      Next
    
    If ctSSLayer_CanUseItem($A) = 1
      Setup_FileBox_Hwnds(Setup_FileBox_Count) = CreateWindowEx($0, #W_STATIC, LoadResString(3302), $50000000, 0, 0, 127, 16, HWndDialog)
      If Setup_FileBox_Hwnds(Setup_FileBox_Count)
        Setup_FileBox_SepMe(Setup_FileBox_Count) = 1
        Setup_FileBox_Count + 1
        EndIf
      
      
      Setup_FileBox_Hwnds(Setup_FileBox_Count) = CreateWindowEx($0, #W_BUTTON, "cda", $50010005, 0, 0, 127, 16, HWndDialog)
      If Setup_FileBox_Hwnds(Setup_FileBox_Count)
        SetWindowLong_(Setup_FileBox_Hwnds(Setup_FileBox_Count), -12, 3310 + Setup_FileBox_Count)
        Setup_FileBox_SepMe(Setup_FileBox_Count) = 0
        Setup_FileBox_Texts(Setup_FileBox_Count) = "cda"
        Setup_FileBox_Count + 1
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure Setup_FileBox_Pos(HWndDialog.i)
  Define.i CheckBoxWidth
  Define.i CurTopPos
  Define.i LeftDlgItemOffset
  Define.i ItemSpacing
  Define.i MaxLeftPos
  Define.i MaxUseableForMains
  Define.i LeftPosMain
  Define.i LeftPosFItem
  Define.RECT xType1
  Define.RECT xType2
  Define.i HWndControl
  Define.i CurLeftPos
  Define.i xLong1
  Define.i xLong2
  Define.i WidestItemWidth
  ;Define.i hFont
  
  HWndControl = GetDlgItem_(HWndDialog, 3300)
  If HWndControl
    Setup_CreateFonts()
    LeftPosMain = 4 * Setup_DPIScaleX
    LeftPosFItem = 20 * Setup_DPIScaleX
    ItemSpacing = 16 * Setup_DPIScaleX
    ;ItemHeight = 14 * Setup_DPIScaleY
    CheckBoxWidth = 20 * Setup_DPIScaleX
    If CheckBoxWidth < Setup_FontHeightB
      CheckBoxWidth = Setup_FontHeightB
      EndIf
    ;hFont = SendMessage_(HWndDialog, $31, 0, 0)
    GetClientRect_(HWndControl, @xType1)
    MaxUseableForMains = xType1\Right - xType1\Left - LeftPosMain
    If MaxUseableForMains < 0
      MaxUseableForMains = 0
      EndIf
    MaxLeftPos = xType1\Right - xType1\Left - LeftPosFItem
    GetWindowRect_(HWndControl, @xType1)
    GetWindowRect_(HWndDialog, @xType2)
    CurTopPos = xType1\Top - xType2\Top + 4 * Setup_DPIScaleY
    LeftDlgItemOffset = xType1\Left - xType2\Left

    If Setup_hKeyFontR
      SelectObject_(xSharedDC, Setup_hKeyFontR)
      Else
      SelectObject_(xSharedDC, hFontGFix)
      EndIf
    For xLong1 = 0 To Setup_FileBox_Count - 1
      If Not Setup_FileBox_SepMe(xLong1)
        xLong2 = GetTextOutWidth(xSharedDC, Setup_FileBox_Texts(xLong1))
        If xLong2 > WidestItemWidth
          WidestItemWidth = xLong2
          EndIf
        EndIf
      Next
    WidestItemWidth + CheckBoxWidth

    MaxLeftPos - WidestItemWidth
    If MaxLeftPos < 0
      MaxLeftPos = 0
      EndIf
    WidestItemWidth + ItemSpacing
    SelectObject_(xSharedDC, hFontGFix)

;Debug "DPIX: " + StrF(Setup_DPIScaleX) + "/" + StrF(Setup_DPIScaleY)
;Debug "Offset: " + Str(LeftDlgItemOffset) + "," + Str(CurTopPos)
;Debug "ItemSizes: " + Str(WidestItemWidth) + "x" + Str(Setup_FontHeightR) + "/" + Str(Setup_FontHeightB)
;Debug "FontHeights (R/B): " + Str(Setup_FontHeightR) + "/" + Str(Setup_FontHeightB)

    For xLong1 = 0 To Setup_FileBox_Count - 1
;Debug "Item(" + Str(xLong1) + ": " + Chr(34) + Setup_FileBox_Texts(xLong1)
      If Setup_FileBox_SepMe(xLong1)
        If Setup_hKeyFontB
          SendMessage_(Setup_FileBox_Hwnds(xLong1), $30, Setup_hKeyFontB, 1)
          Else
          SendMessage_(Setup_FileBox_Hwnds(xLong1), $30, hFontGFix, 1)
          EndIf
        If xLong1
          CurTopPos + 2 * Setup_FontHeightR
          EndIf
        SetWindowPos_(Setup_FileBox_Hwnds(xLong1), 0, LeftDlgItemOffset + LeftPosMain, CurTopPos, MaxUseableForMains, Setup_FontHeightB, $214)
        CurLeftPos = LeftPosFItem
        CurTopPos + Setup_FontHeightB
        Else
        If Setup_hKeyFontR
          SendMessage_(Setup_FileBox_Hwnds(xLong1), $30, Setup_hKeyFontR, 1)
          Else
          SendMessage_(Setup_FileBox_Hwnds(xLong1), $30, hFontGFix, 1)
          EndIf
        If CurLeftPos > LeftPosFItem And CurLeftPos > MaxLeftPos
          CurLeftPos = LeftPosFItem
          CurTopPos + Setup_FontHeightR
          EndIf
        SetWindowPos_(Setup_FileBox_Hwnds(xLong1), 0, LeftDlgItemOffset + CurLeftPos, CurTopPos, WidestItemWidth, Setup_FontHeightR, $214)
        CurLeftPos + WidestItemWidth
        EndIf
      Next
    EndIf
  EndProcedure

Procedure.i Setup_ApplyDialogProc(hWnd.i, Message.i, wParam.i, lParam.i)
  If Message = $111
    ProcedureReturn 1
    ElseIf Message = $110
    hWnd = GetDlgItem_(hWnd, 3001)
    If hWnd
      Setup_WaitForKeyApplyIcon = LoadResEx_ImageIconWEMFToHWnd_MultiOS(hWnd, 3000)
      EndIf
    EndIf
  ProcedureReturn 0
  EndProcedure

;boolean
Procedure.i LoadResEx_Dialog_SpinnerLong(DialogHWnd.i, ControlID.i, *Value, ReadFromDialog.i, Min.i, Max.i)
  Define.i xResult

  ControlID = GetDlgItem_(DialogHWnd, ControlID)
  If ControlID
    If ReadFromDialog
      ControlID = (SendMessage_(ControlID, $468, 0, 0) & $FFFF)
      If ControlID > Max
        ControlID = Max
        ElseIf ControlID < Min
        ControlID = Min
        EndIf
      If Not ControlID = PeekI(*Value)
        PokeI(*Value, ControlID)
        xResult = #True
        EndIf
      Else
      SendMessage_(ControlID, $465, 0, ((Min << 16) & $ffff0000) | (Max & $ffff))
      SendMessage_(ControlID, $467, 0, PeekI(*Value))
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; boolean
Procedure.i LoadResEx_Dialog_CheckLong(DialogHWnd.i, ControlID.i, *Value, ReadFromDialog.i) ;, Optional ResStringIDFirst.i = -1) As Boolean
  Define.i xResult
  Define.i xLong1
  ;x=(3-x) % 3
  
  xLong1 = GetDlgItem_(DialogHWnd, ControlID)
  If Not xLong1 = 0
    xLong1 = (GetWindowLong_(xLong1, -16) & $F)
    If ReadFromDialog
      If GetDlgItem_(DialogHWnd, ControlID)
        ControlID = IsDlgButtonChecked_(DialogHWnd, ControlID)
        If xLong1 = $5
          ControlID = ((3 - ControlID) % 3)
          EndIf
        If Not ControlID = PeekI(*Value)
          PokeI(*Value, ControlID)
          xResult = #True
          EndIf
        EndIf
      Else
      SetDlgItemText_(DialogHWnd, ControlID, LoadResString(ControlID + PeekI(*Value)))
      If xLong1 = $5
        xLong1 = ((3 - PeekI(*Value)) % 3)
        EndIf
      CheckDlgButton_(DialogHWnd, ControlID, xLong1)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure LoadResEx_Dialog_ListFill(DialogHWnd.i, ControlID.i, ResIDFirstString.i, ResIDLastString.i)
  Define.s xChar1
  ControlID = GetDlgItem_(DialogHWnd, ControlID)
  If Not ControlID = 0
    For ResIDFirstString = ResIDFirstString To ResIDLastString
      If LoadString_(hInstance, ResIDFirstString, *ptrTemp, #ptrTempSizeXaW)
        SendMessage_(ControlID, $143, 0, *ptrTemp)
        Else
        xChar1 = "#" + StrU(ResIDFirstString)
        SendMessage_(ControlID, $143, 0, @xChar1)
        EndIf
      Next
    EndIf
  EndProcedure

Procedure.i Setup_DialogKBDProc(hWnd.i, Message.i, wParam.i, lParam.i)
  Select Message
    Case $100
      Select wParam
        Case 46
          Setup_ClearSomeKeys()
        Case 93
          If (lParam & $40000000) = 0
            Setup_ApplyKbdListMenuOrButton(hWnd, GetAPIPopupMenu(HWndSetupDialog, Setup_Menu, hWnd))
            EndIf
        Case 13
          If (lParam & $40000000) = 0
            Setup_TrySetupKey(hWnd)
            EndIf
          ProcedureReturn 0
        Case 9
          LoadResEx_Dialog_ManualTab(HWndSetupDialog, hWnd)
          ProcedureReturn 0
        Case 27
          SendMessage_(HWndSetupDialog, $471, 5, 0)
        EndSelect
    Case $101, $102
    ;  If wParam = 13
    ;    Exit Function
    ;    EndIf
      ProcedureReturn 0
    Case $87
      ProcedureReturn 4
    Case $203
      lParam = CallWindowProc_(Setup_DialogKBDOldProc, hWnd, Message, wParam, lParam)
      Setup_TrySetupKey(hWnd)
      ProcedureReturn lParam
    Case $205
      Setup_ApplyKbdListMenuOrButton(hWnd, TrackListBox(xStaticIconsHWnd(#xStaticIcons_ShowIR), hWnd, HiWordS(lParam), #True, Setup_Menu, 1))
CompilerIf #ListFocusedLists
    Case 7
      xCurFocusHWnd = hWnd
;      Debug.Print "Focused to", xCurFocusHWnd
    Case 8
      xCurFocusHWnd = wParam
;      Debug.Print "(Un)Focused to", xCurFocusHWnd
CompilerEndIf
    EndSelect
  ProcedureReturn CallWindowProc_(Setup_DialogKBDOldProc, hWnd, Message, wParam, lParam)
  EndProcedure

Procedure Setup_FileBox_Upd(HWndDialog)
  Define.i xLong1
  Define.i xLong4
  Define.i xBool1
  Define.i xBool2
  Define.s xChar1
  Define.s xChar2
  Define.s xChar3

  ;xSkipMe = #True
  xChar3 = Setup_UsedTypesTmp
  
  For xLong1 = 0 To Setup_FileBox_Count - 1
    If Not Setup_FileBox_SepMe(xLong1)
      xChar1 = Setup_FileBox_Texts(xLong1) + ","
      Repeat
        xLong4 = FindString(xChar1, ",")
        If xLong4 = 0
          Break
          EndIf
        xChar2 = Left(xChar1, xLong4 - 1)
        If FindString(xChar3, #UsedTypesVBNullChar + xChar2 + #UsedTypesVBNullChar)
          xBool1 = #True
          Else
          xBool2 = #True
          EndIf
        xChar1 = Mid(xChar1, xLong4 + 1)
        ForEver
      ;0 0 -> 0 +  0* 0 = 0
      ;0 1 -> 1 + -1* 0 = 1
      ;1 0 -> 0 +  0*-1 = 1
      ;1 1 -> 1 + -1*-1 = 2
      ;If -CLng(xBool2) + CLng(xBool2) * CLng(xBool1) rsgr s grse resh sre
      If xBool1 And xBool2
        xBool1 = #BST_INDETERMINATE
        ElseIf xBool1
        xBool1 = #BST_CHECKED
        Else
        xBool1 = #BST_UNCHECKED
        EndIf
      CheckDlgButton_(HWndDialog, 3310 + xLong1, xBool1)
      xBool1 = #False
      xBool2 = #False
      EndIf
    Next
  EndProcedure

Procedure Setup_GetInitWidths()
  Define.i xLong1
  Define.i xLong2
  #Setup_KeyRow1Space = 14
  Define.i hDC
  Define.i hFontOld

  hDC = CreateCompatibleDC_(0)
  If hDC = 0
    hDC = xSharedDC
    EndIf
  
  hFontOld = SelectObject_(hDC, Setup_hKeyFontR)
  SelectObject_(xSharedDC, Setup_hKeyFontB)

  Setup_KeyRow1 = 0
  Setup_KeyRow2 = 0
  For xLong1 = 0 To #KbdCountX
    If ValidSetupKey(xLong1) Or xLong1 = #KbdC_FLoadPLMenu
      xLong2 = Setup_IntToExtDepth(xLong1) + GetTextOutWidth(hdc, LoadResString(3700 + xLong1))
      Else
      xLong2 = Setup_IntToExtDepth(xLong1) + GetTextOutWidth(xSharedDC, LoadResString(3700 + xLong1))
      EndIf
    If xLong2 > Setup_KeyRow1
      Setup_KeyRow1 = xLong2
      EndIf
    Next
  
  For xLong1 = 0 To 4
    xLong2 = GetTextOutWidth(hdc, lkCombi(xLong1))
    If xLong2 > Setup_KeyRow2
      Setup_KeyRow2 = xLong2
      EndIf
    Next
  
  Setup_KeyRow2 = Setup_KeyRow1 + Setup_KeyRow2 + #Setup_KeyRow1Space
  
  SelectObject_(hDC, hFontOld)
  If Not hDC = xSharedDC
    DeleteDC_(hDC)
    EndIf
  EndProcedure

;boolean
Procedure.i LoadResEx_Dialog_ListIndexCB(DialogHWnd.i, ControlID.i, *Value, ReadFromDialog.i)
  Define.i xResult

  ControlID = GetDlgItem_(DialogHWnd, ControlID)
  If ControlID
    If ReadFromDialog
      ControlID = SendMessage_(ControlID, $147, 0, 0)
      If Not ControlID = PeekI(*Value)
        PokeI(*Value, ControlID)
        xResult = #True
        EndIf
      Else
      SendMessage_(ControlID, #CB_SETCURSEL, PeekI(*Value), 0)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure Setup_ReFetchSoundFonts()
  Define.i hWndControl
  Define.s xChar1
  Define.i xLong1
  Define.i NumSFonts
  Define.q xQuad1

  NumSFonts = ctSSLayer_SoundFontRefreshList(#SoundFontsListFlags)
  ;NumSFonts = ctSSLayer_CanUseItem($1A)
  hWndControl = GetDlgItem_(Setup_HWndSFPage, 3211)
  If hWndControl
    SendMessage_(hWndControl, #CB_RESETCONTENT, 0, 0)
    For xLong1 = 0 To NumSFonts - 1
      xChar1 = ctSSLayer_SoundFontGetCaption(xLong1)
      If ctSSLayer_SoundFontGetSize(xLong1, @xQuad1)
        CompilerIf (#SoundFontsListFlags & 1)
          xChar1 = "[" + CLPSizeToMiBStringNeat(xQuad1) + "] " + xChar1
          CompilerElse
          xChar1 = xChar1 + " (" + CLPSizeToMiBStringNeat(xQuad1) + ")"
          CompilerEndIf
        EndIf
      SendMessage_(hWndControl, $143, 0, @xChar1)
      Next
    xLong1 = ctSSLayer_SoundFontGetCurrent()
    If Not xLong1 = -1
      SendMessage_(hWndControl, #CB_SETCURSEL, xLong1, 0)
      EndIf
    If NumSFonts > 1
      EnableWindow_(hWndControl, #True)
      Else
      EnableWindow_(hWndControl, #False)
      EndIf
    SendMessage_(hWndControl, $155, 1, 0)
    EndIf
  EndProcedure

Procedure Setup_HandleSettings(HWndDialog.i, ReadFromDialog.i)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xBool1
  Define.s xChar1
  Define.i xResetSnd
  Define.i xResetFastCD
  Define.i xResetFastSF
  Define.i xResetSndDialog
;  Define.TEXTMETRIC xType3

  xResetFastCD = #True
  xResetFastSF = #True
  xBool1 = LoadResEx_Dialog_CheckBool(HWndDialog, 3290, @CDDAUse, ReadFromDialog)
  If xBool1 Or LoadResEx_Dialog_CheckBool(HWndDialog, 3291, @CDDAJitter, ReadFromDialog)
    xResetSnd = #True
    If Not ctSSLayer_CanUseItem(2)
      xResetFastCD = #False
      EndIf
    EndIf

  If ReadFromDialog
    xLong1 = GetDlgItem_(HWndDialog, 3211)
    If xLong1
      xLong1 = SendMessage_(xLong1, #CB_GETCURSEL, 0, 0)
;Debug "CurSel: " + Str(xLong1)
      If xLong1 >= 0
        xChar1 = ctSSLayer_SoundFontGetFilename(xLong1)
        If Len(xChar1) And Not LCase(xChar1) = LCase(xMIDISoundFont)
        ;If Not xLong1 = ctSSLayer_SoundFontGetCurrent()
          xMIDISoundFont = xChar1
          xResetSnd = #True
          If Not ctSSLayer_CanUseItem($19)
            xResetFastSF = #False
            EndIf
          ;ctSSLayer_SoundFontSet(xLong1)
          EndIf
        EndIf
      EndIf
    
    If FetchSSLIDFromComboBoxAndCheckItHasChanged(HWndDialog, 3200)
      xResetSnd = #True
      xResetFastCD = #False
      xResetFastSF = #False
      EndIf
    
    If xResetSnd
      xResetSndDialog = CreateDialogParam_(hInstance, 3000, 0, @Setup_ApplyDialogProc(), 0)
      If Setup_WaitForKeyApplyIcon
        DestroyIcon_(Setup_WaitForKeyApplyIcon)
        Setup_WaitForKeyApplyIcon = 0
        EndIf
      EnableWindow_(HWndSetupDialog, 0)
      EndIf
    
    
    
    
    
    
    For xLong1 = 1 To 3
      If Not (GetDlgItem_(HWndDialog, 3239 + xLong1) = 0 Or GetDlgItem_(HWndDialog, 3259 + xLong1) = 0)
        LoadResEx_Dialog_SpinnerLong(HWndDialog, 3259 + xLong1, @xLong2, #True, 0, 100)
        LoadResEx_Dialog_CheckBool(HWndDialog, 3239 + xLong1, @xBool1, #True)
        If xBool1
          xTrackerSkipper(xLong1) = xLong2
          Else
          xTrackerSkipper(xLong1) = -xLong2
          EndIf
        EndIf
      Next
    
    
    xLong1 = GetDlgItem_(HWndDialog, 3300)
    If Not xLong1 = 0
      If Not Setup_UsedTypesTmp = xUsedTypes ;And xUsedTypesResortTmp = xUsedTypesResort
        xUsedTypes = Setup_UsedTypesTmp
        xUsedTypesResort = #True ;xUsedTypesResortTmp
        EndIf
      EndIf
    
    
    
    If Setup_KeysChangedLow Or Setup_KeysChangedHigh
      Setup_KeysChangedLow = #False
      For xLong1 = 0 To #KbdCountX
        xKey(xLong1) = Setup_xNewKey(xLong1)
        Next
      MainForm_UpdateMenus()
      EndIf
    
    
    
    xLong1 = GetDlgItem_(HWndDialog, 3500)
    If Not xLong1 = 0
      LoadResEx_Dialog_CheckBool(HWndDialog, 3500, @xBool1, #True)
      If xBool1 XOr Reg_IsAutoRun
        If xBool1
          If RegCreateKeyEx_($80000001, @"Software\Microsoft\Windows\CurrentVersion\Run", 0, 0, 0, 2, 0, @xLong1, 0) = 0
            RegSetValueEx_String(xLong1, LoadResString(3500), xRealBaseFile + "exe")
            RegCloseKey_(xLong1)
            EndIf
          Else
          If RegOpenKeyEx_($80000001, @"Software\Microsoft\Windows\CurrentVersion\Run", 0, 2, @xLong1) = 0
            xChar1 = LoadResString(3500)
            RegDeleteValue_(xLong1, @xChar1)
            RegCloseKey_(xLong1)
            EndIf
          EndIf
        Reg_IsAutoRun = xBool1
        ;TestRestoreReg #False
        EndIf
      EndIf

    xLong1 = GetDlgItem_(HWndDialog, 3520)
    If Not xLong1 = 0
      LoadResEx_Dialog_CheckLong(HWndDialog, 3520, @xLong3, #True)
      LoadResEx_Dialog_CheckBool(HWndDialog, 3521, @xBool1, #True)
      If xLong3 = 1
        RegFolderMode(2) = #True
        RegFolderMode(3) = xBool1
        Else
        RegFolderMode(2) = #False
        EndIf
; playlistformatsimport
      If xLong3 = 0
        RegisterFileTypes_RemoveRegistered("m3u", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("m3u8", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("pls", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("xspf", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("aimppl", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("plc", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("aap", LoadResString(3527), LoadResString(3529))
        RegisterFileTypes_RemoveRegistered("wpl", LoadResString(3527), LoadResString(3529))
        Else
        RegisterFileTypes_SetRegistered("m3u", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "M3U"), "", -1, xBool1, #True, LoadResString(3529))
        CompilerIf #PB_Compiler_Unicode
          RegisterFileTypes_SetRegistered("m3u8", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "M3U8"), "", -1, xBool1, #True, LoadResString(3529))
          RegisterFileTypes_SetRegistered("aimppl", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "WPL"), "", -1, xBool1, #True, LoadResString(3529))
          RegisterFileTypes_SetRegistered("plc", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "WPL"), "", -1, xBool1, #True, LoadResString(3529))
          RegisterFileTypes_SetRegistered("wpl", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "WPL"), "", -1, xBool1, #True, LoadResString(3529))
          CompilerEndIf
        RegisterFileTypes_SetRegistered("pls", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "PLS"), "", -1, xBool1, #True, LoadResString(3529))
        RegisterFileTypes_SetRegistered("aap", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "AAP"), "", -1, xBool1, #True, LoadResString(3529))
        RegisterFileTypes_SetRegistered("xspf", LoadResString(3525), LoadResString(3527), LoadResString(3526), ReplaceString(LoadResString(3528), "$", "XSPF"), "", -1, xBool1, #True, LoadResString(3529))
        EndIf
      EndIf
    
     TestRestoreReg(#False)
    
    
    
    
    ;3530 / 3535
    For xLong2 = 0 To 1
      xLong1 = GetDlgItem_(HWndDialog, 3530 + xLong2 * 5)
      If Not xLong1 = 0
        LoadResEx_Dialog_CheckLong(HWndDialog, 3530 + xLong2 * 5, @xLong3, #True)
        If (xLong3 = 1)
          RegFolderMode(xLong2) = #True
          Else
          RegFolderMode(xLong2) = #False
          EndIf
        If xLong3 = 0
          xChar1 = "Folder\Shell\" + LoadResString(3534 + xLong2 * 5)
          RegDeleteKey_($80000000, @xChar1)
          xChar1 + "\command"
          RegDeleteKey_($80000000, @xChar1)
          Else
          xChar1 = "Folder\Shell\" + LoadResString(3534 + xLong2 * 5) + "\command"
          If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, 0) = 0
            If xLong2 = 1
              RegSetValueEx_String(xLong1, "", Chr(34) + xRealBaseFile + "exe" + Chr(34) + " /ENQUEUE " + Chr(34) + "%1" + Chr(34))
              Else
              RegSetValueEx_String(xLong1, "", Chr(34) + xRealBaseFile + "exe" + Chr(34) + " " + Chr(34) + "%1" + Chr(34))
              EndIf
            RegCloseKey_(xLong1)
            xChar1 = "Folder\Shell\" + LoadResString(3534 + xLong2 * 5)
            If RegOpenKeyEx_($80000000, @xChar1, 0, 2, @xLong1) = 0
              RegSetValueEx_String(xLong1, "", LoadResString(3533 + xLong2 * 5))
              RegCloseKey_(xLong1)
              EndIf
            EndIf
          EndIf
        EndIf
      Next
    Else
    
    
    
    
    
    
    
    
    LoadResEx_Dialog_ListFill(HWndDialog, 3100, 3100, 3102)
    LoadResEx_Dialog_ListFill(HWndDialog, 3124, 3120, 3123)
    
    
;    ReadFont 0
    ;ReadFont 1
    ;SetDlgItemTextA(HWndDialog, 3151, GetFontCaption(0))
    ;SetDlgItemTextA(HWndDialog, 3156, GetFontCaption(1))
;    ShowUpdateFont HWndDialog, 0
    ;ShowUpdateFont HWndDialog, 1
    
    If ctSSLayer_CanUseItem(4)
      LoadResEx_Dialog_Enable(HWndDialog, 3160, #True)
      Else
      LoadResEx_Dialog_Enable(HWndDialog, 3160, #False)
      EndIf
    If LEDMode
      LoadResEx_Dialog_Enable(HWndDialog, 3160, #False)
      xLong1 = 3162
      ElseIf xShowSpectrum
      xLong1 = 3160
      Else
      xLong1 = 3161
      EndIf
    xChar1 = LoadResString(xLong1)
    SetDlgItemText_(HWndDialog, 3160, @xChar1)
    
    If xShellMode
      LoadResEx_Dialog_Enable(HWndDialog, 3171, #False)
      Else
      LoadResEx_Dialog_Enable(HWndDialog, 3171, #True)
      EndIf
    
    xLong1 = GetDlgItem_(HWndDialog, 3175)
    If Not xLong1 = 0
      If (xTrayIconVisible Or xTrayIconEnabled)
        LoadResEx_Dialog_Enable(HWndDialog, 3175, #True)
        Else
        LoadResEx_Dialog_Enable(HWndDialog, 3175, #False)
        EndIf
      LoadResEx_Dialog_ListFill(HWndDialog, 3175, 3170, 3176)
      EndIf
    xLong1 = GetDlgItem_(HWndDialog, 3176)
    If Not xLong1 = 0
      xChar1 = LoadResString(3170)
      SendMessage_(xLong1, $143, 0, @xChar1)
      xChar1 = LoadResString(3174)
      SendMessage_(xLong1, $143, 0, @xChar1)
      xChar1 = LoadResString(3175)
      SendMessage_(xLong1, $143, 0, @xChar1)
      If xTrayIconVisible Or xTrayIconEnabled
        LoadResEx_Dialog_Enable(HWndDialog, 3176, #True)
        Else
        LoadResEx_Dialog_Enable(HWndDialog, 3176, #False)
        EndIf
      SendMessage_(xLong1, $155, 1, 0)
      EndIf
    
    
    LoadResEx_Dialog_ListFill(HWndDialog, 3180, 3180, 3183)
    
    If GetDlgItem_(HWndDialog, 3200)
      MaxDeviceCount = ctSSLayer_RefreshDeviceList(MainHWnd)
      HWndSetupDialogSSPage = HWndDialog
      UpdateSnds(HWndDialog, 3200)
      EndIf

    If GetDlgItem_(HWndDialog, 3211)
      Setup_HWndSFPage = HWndDialog
      If ctSSLayer_CanUseItem($18)
        Setup_ReFetchSoundFonts()
        LoadResEx_Dialog_Enable(HWndDialog, 3210, #True)
        LoadResEx_Dialog_Enable(HWndDialog, 3212, #True)
        Else
        LoadResEx_Dialog_Enable(HWndDialog, 3210, #False)
        LoadResEx_Dialog_Enable(HWndDialog, 3211, #False)
        LoadResEx_Dialog_Enable(HWndDialog, 3212, #False)
        EndIf
      EndIf


    If ctSSLayer_CanUseItem($E) = 1
      LoadResEx_Dialog_Enable(HWndDialog, 3201, #True)
      Else
      LoadResEx_Dialog_Enable(HWndDialog, 3201, #False)
      EndIf
    CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      CompilerIf #PB_Compiler_Unicode
        If Not IsMinWindowsXP
          LoadResEx_Dialog_Enable(HWndDialog, 3206, #False)
          EndIf
        CompilerElse
        LoadResEx_Dialog_Enable(HWndDialog, 3206, #False)
        CompilerEndIf
      CompilerEndIf

;WinHasUserSwitchFeature:
    If Len(ctSSLayer_GetInfoString($10))
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3240, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3250, xBool1)
    
    If ctSSLayer_CanUseItem(3) = 2 And Len(ctSSLayer_GetInfoString($10))
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3270, xBool1)
    
    If Len(ctSSLayer_GetInfoString($11)) Or Len(ctSSLayer_GetInfoString($12))
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3241, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3251, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3275, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3276, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3277, xBool1)
    
    If ctSSLayer_CanUseItem($A)
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3242, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3252, xBool1)
    
    If ctSSLayer_CanUseItem($12) = 2
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3573, xBool1)
    
 ;324x/325x -> HH:mm, 99.9 / TrackerSkipperMinValF = 0.1
    For xLong1 = 1 To 3
      If xTrackerSkipper(xLong1) > 0
        xBool1 = #True
        Else
        xBool1 = #False
        EndIf
      xLong2 = xTrackerSkipper(xLong1)
      If Not xBool1
        xLong2 = -xLong2
        EndIf
      LoadResEx_Dialog_Enable(HWndDialog, 3249 + xLong1, xBool1)
      LoadResEx_Dialog_Enable(HWndDialog, 3259 + xLong1, xBool1)
      ;LoadResEx_Dialog_TimeLongA HWndDialog, 3250 - 1 + xLong1, xLong2, #False
      LoadResEx_Dialog_SpinnerLong(HWndDialog, 3259 + xLong1, @xLong2, #False, #xAnySkipperMin, #xAnySkipperMax)
      If xBool1
        xBool1 = #BST_CHECKED
        EndIf
      CheckDlgButton_(HWndDialog, 3239 + xLong1, xBool1)
      Next
    
    If ctSSLayer_CanUseItem(0) = 2 And ctSSLayer_CanUseItem($A)
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3290, xBool1)
    
    If (ctSSLayer_CanUseItem(1) = 2) And CDDAUse And ctSSLayer_CanUseItem($A) And ctSSLayer_CanUseItem(0)
      xBool1 = #True
      Else
      xBool1 = #False
      EndIf
    LoadResEx_Dialog_Enable(HWndDialog, 3291, xBool1)
    

    
    xLong1 = GetDlgItem_(HWndDialog, 3300)
    If Not xLong1 = 0
      Setup_UsedTypesTmp = xUsedTypes
      ;xUsedTypesResortTmp = xUsedTypesResort
      Setup_FileBox_Upd(HWndDialog)
      EndIf

    
    ;KeyListFont
    If Setup_HWndKeyList = 0
      Setup_HWndKeyList = GetDlgItem_(HWndDialog, 3400)
      If Setup_HWndKeyList
        ;HWndSetupDialogSSPage = 0
        HWndSetupDialogKeyPage = HWndDialog
        
        HWndSetupKeyApply = GetDlgItem_(HWndDialog, 3420)
        Setup_DialogKBDOldProc = SetWindowLong_(Setup_HWndKeyList, -4, @Setup_DialogKBDProc())
        
        Setup_CreateFonts()
        If Setup_FontHeightB
          SendMessage_(Setup_HWndKeyList, $30, Setup_hKeyFontB, 0)
          SendMessage_(Setup_HWndKeyList, $1A0, 0, Setup_FontHeightB)
          EndIf
        
        xBool1 = #False
        
        Setup_GetInitWidths()
        GetDefControls(Setup_xNewKey())
        For xLong1 = 0 To #KbdCountX
          If Not (Setup_xNewKey(xLong1) = xKey(xLong1))
            xBool1 = #True
            Setup_xNewKey(xLong1) = xKey(xLong1)
            EndIf
          SendMessage_(Setup_HWndKeyList, $180, 0, xLong1)
          Next
        
        Setup_UpdateKeyListWidth()
        
        xLong1 = GetDlgItem_(HWndDialog, 3410)
        If Not xLong1 = 0
          xChar1 = ReplaceString(ReplaceString(GetWindowText(xLong1), "$C", lkCtrl), "$A", lkAlt)
          SetWindowText_(xLong1, @xChar1)
          EndIf
        If Not HWndSetupKeyApply = 0
          ;If xBool1
          ;  xBool1 = #True
          ;  EndIf
          EnableWindow_(HWndSetupKeyApply, xBool1)
          ShowWindow_(HWndSetupKeyApply, 0)
          ShowWindow_(HWndSetupKeyApply, 1)
          EndIf
        EndIf
      EndIf


    If Reg_IsAutoRun
      xLong1 = #BST_CHECKED
      Else
      xLong1 = #BST_UNCHECKED
      EndIf
    CheckDlgButton_(HWndDialog, 3500, xLong1)
    
    If RegFolderMode(2)
      xLong3 = 1
      LoadResEx_Dialog_CheckLong(HWndDialog, 3520, @xLong3, #False)
      LoadResEx_Dialog_Enable(HWndDialog, 3521, #True)
      
      If RegFolderMode(3)
        xLong3 = #BST_CHECKED
        Else
        xLong3 = #BST_UNCHECKED
        EndIf
      CheckDlgButton_(HWndDialog, 3521, xLong3)
      Else
      If Setup_RegRegF(2) = 0
        LoadResEx_Dialog_Enable(HWndDialog, 3521, #False)
        xLong3 = 0
        Else
        LoadResEx_Dialog_Enable(HWndDialog, 3521, #True)
        xLong3 = 2
        EndIf
      LoadResEx_Dialog_CheckLong(HWndDialog, 3520, @xLong3, #False)
      If xLong3
        xLong3 = #BST_CHECKED
        EndIf
      CheckDlgButton_(HWndDialog, 3520, xLong3)
      EndIf
    If xSecureMode
      LoadResEx_Dialog_Enable(HWndDialog, 3520, #False)
      LoadResEx_Dialog_Enable(HWndDialog, 3521, #False)
      xBool1 = #False
      Else
      xBool1 = #True
      EndIf
    
    LoadResEx_Dialog_CheckLong(HWndDialog, 3530, @Setup_RegRegF(0), #False)
    LoadResEx_Dialog_CheckLong(HWndDialog, 3535, @Setup_RegRegF(1), #False)

    LoadResEx_Dialog_Enable(HWndDialog, 3520, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3530, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3535, xBool1)
    LoadResEx_Dialog_Enable(HWndDialog, 3567, xBool1)   ;3540
    LoadResEx_Dialog_Enable(HWndDialog, 3580, xBool1) ;3542

    LoadResEx_Dialog_ListFill(HWndDialog, 3580, 3580, 3585)
  
  
    ;xSkipMe = #False
    EndIf
  
  
  
  
  
  
  If LoadResEx_Dialog_ListIndexCB(HWndDialog, 3100, @PlDClickAction, ReadFromDialog)
    If InterfaceMode = #Interface_Mode_Search
      SearchForm_CheckBoxTxtChange()
      EndIf
    EndIf

  If LoadResEx_Dialog_CheckBool(HWndDialog, 3120, @ShowFullPathSet, ReadFromDialog)
    MainForm_CheckFullPathSetting(#True)
    EndIf
  xBool1 = LoadResEx_Dialog_CheckBool(HWndDialog, 3123, @ShowFullTitle, ReadFromDialog)
  
  
  If LoadResEx_Dialog_CheckBool(HWndDialog, 3121, @MP3GetFormat, ReadFromDialog)
    If MP3GetFormat
      MainForm_ReadLate("", #True)
      EndIf
    MP3GetFormatChanged(#True)
    EndIf
  LoadResEx_Dialog_CheckBool(HWndDialog, 3122, @xShowElapsed, ReadFromDialog)
  LoadResEx_Dialog_CheckLong(HWndDialog, 3125, @xTitlesWhenMinimized, ReadFromDialog)
  If LoadResEx_Dialog_ListIndexCB(HWndDialog, 3124, @xTitlesPos, ReadFromDialog)
    IRUMBar_ReCreateFont()
    IRUMBar_ForcePosUpdate()
;    If ShowIRWin
;      ShowIR_Do #True      ;#False
;      EndIf
    ElseIf xBool1
CompilerIf #SelfPathElipse
    IRUMBar_NeedPathElipseStr = ""
CompilerEndIf
    If IRUMBar_WindowActive
      IRUMBar_Do(#True)
      EndIf
    EndIf
  
  LoadResEx_Dialog_CheckBool(HWndDialog, 3160, @xDeluxeSpectrum, ReadFromDialog)
  StartUpWindowMode = StartUpWindowMode + 1
  
  
  xBool1 = LoadResEx_Dialog_CheckBool(HWndDialog, 3170, @xTrayIconVisible, ReadFromDialog)
  If xBool1 Or LoadResEx_Dialog_CheckBool(HWndDialog, 3171, @xTrayIconEnabled, ReadFromDialog)
    MainForm_ShowTray(#False)
    EndIf
  
  LoadResEx_Dialog_ListIndexCB(HWndDialog, 3175, @xTrayIconLeft, ReadFromDialog)
  LoadResEx_Dialog_ListIndexCB(HWndDialog, 3176, @xTrayIconRight, ReadFromDialog)
  
  LoadResEx_Dialog_ListIndexCB(HWndDialog, 3180, @StartUpWindowMode, ReadFromDialog)
  StartUpWindowMode = StartUpWindowMode - 1

  LoadResEx_Dialog_CheckBool(HWndDialog, 3185, @xAutoSwitchIRadioOEPl, ReadFromDialog)




  If LoadResEx_Dialog_CheckBool(HWndDialog, 3205, @xAutoPlayback, ReadFromDialog)
    xReAutoPlay = xAutoPlayback
    EndIf
  LoadResEx_Dialog_CheckBool(HWndDialog, 3206, @OutOfSessionPause, ReadFromDialog)
  
  
  xCrossFadeTimeM = xCrossFadeTimeM + #xFadeConsts1
  LoadResEx_Dialog_SpinnerLong(HWndDialog, 3220, @xCrossFadeTimeM, ReadFromDialog, #xFadeConsts1, #xFadeConsts2)
  xCrossFadeTimeM = xCrossFadeTimeM - #xFadeConsts1
  
  
  LoadResEx_Dialog_SpinnerLong(HWndDialog, 3225, @IntroModeTime, ReadFromDialog, #IntroMdSkipperMinVal, #IntroMdSkipperMaxVal)
  LoadResEx_Dialog_CheckBool(HWndDialog, 3230, @RandomPosOnTrackerSkipper, ReadFromDialog)
  LoadResEx_Dialog_CheckBool(HWndDialog, 3270, @CheckAccurate, ReadFromDialog)
  If LoadResEx_Dialog_SpinnerLong(HWndDialog, 3276, @xModPanning, ReadFromDialog, 0, 100)
    UpdatePanning(xModPanning)
    EndIf
  
  
  
  
  
  
  LoadResEx_Dialog_CheckBool(HWndDialog, 3301, @IgnoreUnderscored, ReadFromDialog)
  
  
  If LoadResEx_Dialog_CheckBool(HWndDialog, 3410, @GlobalKeys, ReadFromDialog)
    MainForm_SetGlobalKeys(GlobalKeys)
    ElseIf Setup_KeysChangedHigh And GlobalKeys
    MainForm_SetGlobalKeys(#False)
    MainForm_SetGlobalKeys(#True)
    EndIf
  Setup_KeysChangedHigh = #False
  

  
  LoadResEx_Dialog_CheckBool(HWndDialog, 3550, @xSorting, ReadFromDialog)
  LoadResEx_Dialog_CheckBool(HWndDialog, 3560, @UsePLSettings, ReadFromDialog)
  LoadResEx_Dialog_CheckBool(HWndDialog, 3565, @RemoveMissingOnPLLoad, ReadFromDialog)
  If LoadResEx_Dialog_CheckBool(HWndDialog, 3567, @xDelMode, ReadFromDialog)
    MainForm_EnableApiMenu(133, xDelMode)
    MainForm_EnableApiMenu(230, xDelMode)
    EndIf
  LoadResEx_Dialog_CheckLong(HWndDialog, 3570, @LockWinUpd, ReadFromDialog)
  If LoadResEx_Dialog_CheckLong(HWndDialog, 3575, @SoundSchemePointerMode, ReadFromDialog)
    MainForm_ApplyProcessMode()
    EndIf
  
  LoadResEx_Dialog_CheckBool(HWndDialog, 3573, @xClassicBlockingOnLoad, ReadFromDialog)
  
  PlayerPriority = PlayerPriority + 2
  If LoadResEx_Dialog_ListIndexCB(HWndDialog, 3580, @PlayerPriority, ReadFromDialog)
    UpdatePriority(PlayerPriority - 2)
    Else
    PlayerPriority = PlayerPriority - 2
    EndIf
  
  
  LoadResEx_Dialog_SpinnerLong(HWndDialog, 3590, @IPCDelayFix, ReadFromDialog, 0, 2000)


    
    
  ;  EndIf
  
  If xResetSnd
    MainForm_OutputChange(HWndSetupDialog, xResetFastCD, xResetFastSF, #False)
    
    EnableWindow_(HWndSetupDialog, 1)
    If xResetSndDialog
      If GetForegroundWindow_() = xResetSndDialog
        SetForegroundWindow_(HWndSetupDialog)
        EndIf
      DestroyWindow_(xResetSndDialog)
      EndIf
    EndIf
  
  EndProcedure

Procedure Setup_TryApply(HWndDialog.i, *lParam.NMHDR)
  If *lParam
    If *lParam\code = -211
      Setup_HandleSettings(HWndDialog, #True)
      SendMessage_(HWndSetupDialog, $46D, HWndDialog, 0)
      EndIf
    EndIf
  EndProcedure

Procedure.i Setup_DialogProc(hWnd.i, Msg.i, wParam.i, lParam.i)
  Select Msg
    Case $2B ; WM_DRAWITEM
      Setup_DrawSKLVItem(lParam)
      ProcedureReturn 1
    Case $111
      Select (wParam & $FFFF)
        Case 3125, 3530, 3535, 3570, 3575
          LoadResEx_Dialog_CheckLongManualHandle(hWnd, wParam, lParam)
        Case 3170, 3171
          If (IsDlgButtonChecked_(hWnd, 3170) Or IsDlgButtonChecked_(hWnd, 3171))
            Msg = #True
            Else
            Msg = #False
            EndIf
          LoadResEx_Dialog_Enable(hWnd, 3175, Msg)
          LoadResEx_Dialog_Enable(hWnd, 3176, Msg)
        Case 3201
          If HWndSetupDialogSSPage
            MaxDeviceCount = ctSSLayer_RefreshDeviceList(MainHWnd)
            UpdateSnds(HWndSetupDialogSSPage, 3200)
            EndIf
        Case 3212
          If Setup_HWndSFPage
            Setup_ReFetchSoundFonts()
            EndIf
        Case 3240 To 3242
          wParam = (wParam & $FFFF)
          If IsDlgButtonChecked_(hWnd, wParam)
            Msg = #True
            Else
            Msg = #False
            EndIf
          LoadResEx_Dialog_Enable(hWnd, wParam + 10, Msg)
          LoadResEx_Dialog_Enable(hWnd, wParam + 20, Msg)
        Case 3290
          wParam = (wParam & $FFFF)
          If IsDlgButtonChecked_(hWnd, wParam)
            Msg = #True
            Else
            Msg = #False
            EndIf
          LoadResEx_Dialog_Enable(hWnd, wParam + 1, Msg)
        Case 3310 To 3399
          Setup_FileBox_TryClick(hWnd, wParam & $FFFF)
;          GoTo lbl1
        
        Case 3405, 3406
          Setup_ApplyKbdListMenuOrButton(Setup_HWndKeyList, wParam & $FFFF)
        Case 3420
          If Setup_HWndKeyList
            If CalaymMessageBox(HWndSetupDialog, LoadResString(3401), LoadResString(3400), #MB_OKCANCEL) = #IDOK
              ;EnableWindow(hwnd, 0)
              GetDefControls(Setup_xNewKey())
              ;lstRes(3301).Clear
              SendMessage_(Setup_HWndKeyList, #LB_RESETCONTENT, 0, 0)
              For wParam = 0 To #KbdCountX
                SendMessage_(Setup_HWndKeyList, $180, 0, wParam)
                Next
              Setup_KeysChangedLow = #True ;#False
              Setup_KeysChangedHigh = #True ;#False
              Setup_UpdateKeyListWidth()
              If Not HWndSetupKeyApply = 0
                EnableWindow_(HWndSetupKeyApply, 0)
                ShowWindow_(HWndSetupKeyApply, 0)
                ShowWindow_(HWndSetupKeyApply, 1)
                EndIf
              Setup_SetApply(HWndSetupDialogKeyPage)
              EndIf
            EndIf
        Case 3520
          Select LoadResEx_Dialog_CheckLongManualHandle(hWnd, wParam, lParam)
            Case 1
              If RegFolderMode(3)
                lParam = #BST_CHECKED
                Else
                lParam = #BST_UNCHECKED
                EndIf
              CheckDlgButton_(hWnd, 3521, lParam)
              LoadResEx_Dialog_Enable(hWnd, 3521, #True)
            Case 2
              CheckDlgButton_(hWnd, 3521, #BST_CHECKED)
              LoadResEx_Dialog_Enable(hWnd, 3521, #True)
            Default
              LoadResEx_Dialog_Enable(hWnd, 3521, #False)
            EndSelect
        EndSelect
      
      
      Setup_TrySetApply(hWnd, lParam, wParam)
      
    Case $110
      If HWndSetupDialog = 0
        HWndSetupDialog = GetParent_(hWnd)
        If Setup_Menu = 0
          Setup_Menu = LoadResEx_Menu(3400)
          Setup_PopupMenu = MakePopupMenu(Setup_Menu)
          EndIf
        GetWindowDPIScalingFloatMul(hWnd, @Setup_DPIScaleX, @Setup_DPIScaleY)
        EndIf
      If Setup_FileBox_Count = 0
        Setup_FileBox_Crt(hWnd)
        Setup_FileBox_Pos(hWnd)
        EndIf
      Setup_HandleSettings(hWnd, #False)
      ProcedureReturn 1
    Case $4E
      Setup_TryApply(hWnd, lParam)
    EndSelect
  ProcedureReturn 0
  EndProcedure

Procedure Setup_ShowSetupDialog()
  DialogTimer(#True)
  Setup_ReadRegestry()
  LoadResEx_PagedDialog(MainHWnd, 3100, 3550, 50, @Setup_DialogProc(), LoadResString(3000))     ;, , AddressOf Setup_DialogProcInit)
  
  Setup_KeysChangedHigh = #False
  Setup_KeysChangedLow = #False
  HWndSetupDialogSSPage = 0
  Setup_HWndSFPage = 0
  HWndSetupDialogKeyPage = 0
  HWndSetupDialog = 0
  Setup_HWndKeyList = 0
  HWndSetupKeyApply = 0
  Setup_DialogKBDOldProc = 0
  Setup_FileBox_Count = 0

  Setup_DiscardFonts()
  
  If Setup_Menu
    DestroyMenu_(Setup_Menu)
    If Setup_PopupMenu
      DestroyMenu_(Setup_PopupMenu)
      EndIf
    EndIf
  For Setup_Menu = 0 To #KbdCountX
    Setup_xNewKey(Setup_Menu) = 0
    Next
  Setup_Menu = 0

  DialogTimer(#False)
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = -------
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; AddResource = res\exe64.rc