Macro CatchError()
  EndMacro

; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

Global Dim xModPatterns.b(0)

Global AnimateForTearCountX.i
Global xTearWaitCall.i

Global RGK_xOldKey.i
Global RGK_xOldKeyTime.i
Global RGK_xOldKeyTimeWait.i
#RGK_xOldKeyTimeWaitLong = 250 ;750
#RGK_xOldKeyTimeWaitShort = 40 ;150
Global ctSSLayer_MaxIDs.i
Global ctSSLayer_MaxIDsX.i
Global DoAnimate_CurStep.i

Global Dim Tear_Type.i(0)
Global Dim Tear_STime.i(0) ; lasttime
Global Dim Tear_Delay.i(0)
Global Dim Tear_WasVolume.f(0)
Global Dim Tear_Volume.f(0)
Global Dim Tear_Special.i(0)
Global Dim Tear_ShouldVolume.i(0)
Global Dim Tear_StepT.i(0)
Global Dim SongPointer.i(0)
Global Dim Tear_Filename.s(0)
Global Dim Tear_Caption.s(0)
Global Dim Tear_IsINet.i(0)
Global Dim Tear_IsMode.i(0)
Global Dim Tear_TotLength.i(0)
Global Dim AllTears_IDs.b(0)
#MaxWaitID = 3
#MaxWaitIDP = #MaxWaitID + 1

Global Dim AllTears_Types.i(#MaxWaitID)
Global AllTears_TypesCount.i
Global CurrentSongID.i
Global LastLoudestTearFn.s
Global LastLoudestTearCp.s
Global LastLoudestTearIS.i
Global LastLoudestTearID.i
Global LastLoudestTearBC.i
;Global LastLoudestTearVl.f
Global ForceLoudestTear.i
Global AnimDirSDotSperatX.i
Global AnimDirSDotFTMult.i
Global AnimDirSDotWidthP.i
Global AnimDirIconWidth.i
Global AnimDirTotalWidth.i
Global AnimDirIconTopPS.i
Global AnimDirIconMasLeftP.i
Global AnimDirIconHeight.i
Global AnimDirSDotTopPos.i
Global AnimDirSDotBotPos.i
Global AnimHeightAnimNone.i
Global AnimHeightAnimOnly.i
Global AnimDirProgTopPos.i
Global AnimDirProgBotPos.i
Global AnimHeightAnimProg.i
Global AnimExtraPadding.i
Global OldAnimWEMF.i
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
  Global OldAnimhIcon.i
  CompilerEndIf
Global xDoAnimColor1.i
Global xDoAnimColor2.i
Global xDoAnimColor3.i
Global xClassicBlockingOnLoad.i
Global xIsActiveBW.i
Global xIsActiveAN.i

#xDefBWDifL = 65535
#xDefBWDifC = #xDefBWDifL
Global xCurBWPos.i
Global *TasBarPrg
Global FLineColor
Global xPStateIconPlugging.i


Declare.i TearDown(xLong1.i, xLong2.i, xLong3.i, xLong4.i)


Procedure Tear_StartDropping(SongID.i, DesiredType.i, SpecialMode.i, Delay.i, FullTime.i, DesiredVolumeDir.i)
  If Not SongID = -1
CompilerIf #PB_Compiler_Debugger
    If Not AllTears_IDs(SongID)
      AllTears_IDs(SongID) = 0
      EndIf
CompilerEndIf

    If SpecialMode = 1 Or SpecialMode = 11
      AllTears_Types(DesiredType) = AllTears_Types(DesiredType) + 1
      Tear_Type(SongID) = DesiredType
      EndIf
    Tear_STime(SongID) = GetTickTimeMSEx()
    CatchError()
    Tear_WasVolume(SongID) = Tear_Volume(SongID)
    Tear_Special(SongID) = SpecialMode
    Tear_Delay(SongID) = Delay ; xfade only, overwrite on action!
    If SpecialMode = 11
      Tear_StepT(SongID) = Delay + FullTime
      Else
      Tear_StepT(SongID) = Delay + FullTime * Abs(DesiredVolumeDir - Tear_WasVolume(SongID)) ;* 5
      EndIf
    
    If Tear_StepT(SongID) = 0
      Tear_StepT(SongID) = 1
      EndIf
    Tear_ShouldVolume(SongID) = DesiredVolumeDir
    EndIf
  
  If SpecialMode < 10 ;Or SongID = -1
    For SpecialMode = 0 To ctSSLayer_MaxIDsX
      If Tear_Special(SpecialMode) = 11 And Tear_StepT(SpecialMode)
        If Tear_Delay(SpecialMode) + Tear_STime(SpecialMode) - GetElapsedTickTimeMS(Tear_STime(SpecialMode)) > FullTime + Delay
          Tear_STime(SpecialMode) = GetTickTimeMSEx()
          Tear_WasVolume(SpecialMode) = Tear_Volume(SpecialMode)
          Tear_Delay(SpecialMode) = 0 ;Delay ;Tear_Special(SpecialMode) - 10
          Tear_Special(SpecialMode) = 1
          Tear_StepT(SpecialMode) = Delay + FullTime ;* Abs(Tear_ShouldVolume(SpecialMode) - Tear_WasVolume(SpecialMode)) ;FullTime
          If Tear_StepT(SpecialMode) = 0
            Tear_StepT(SpecialMode) = 1
            EndIf
          EndIf
        EndIf
      Next
    EndIf
  EndProcedure

Procedure Tear_Dropped(SongID.i)
  Tear_StepT(SongID) = 0
  AllTears_Types(Tear_Type(SongID)) = AllTears_Types(Tear_Type(SongID)) - 1
  AllTears_TypesCount = AllTears_TypesCount - 1
  AllTears_IDs(SongID) = 0
  If AllTears_TypesCount = 2
    MainForm_TearIconChance()
    ;ElseIf AllTears_TypesCount = AnimateForTearCountX And Not (xPStateIconStartup Or xAutoDoing)
    ;DoAnimateStepDrawCheck(#True)
    EndIf
  EndProcedure

Procedure ShortenWeakTear()
  Define.i xLong1
  Define.i xLong2
  Define.f xVal1
  Define.f xVal2

  xLong1 = -1
  For xLong2 = 0 To ctSSLayer_MaxIDsX
    If Tear_ShouldVolume(xLong2) = 0 And Not (xLong2 = CurrentSongID Or Tear_StepT(xLong2) = 0)
      xVal1 = (Tear_StepT(xLong2) + KeepMusicAliveTime - GetElapsedTickTimeMS(Tear_STime(xLong2)) - Tear_Delay(xLong2)) * Tear_Volume(xLong2)
      If xVal1 < xVal2 Or xLong1 = -1
        xVal2 = xVal1
        xLong1 = xLong2
        EndIf
      EndIf
    Next
  
  If xVal2 < 750 And Not xLong1 = -1
    Tear_Dropped(xLong1)
    ctSSLayer_UnloadSong(SongPointer(xLong1))
    EndIf
  EndProcedure

Procedure Tear_WaitFor(WaitForDesiredType.i)
  ;Define.i xLong1
  
  If WaitForDesiredType < 0
    ;-1 ;waitforall
    Tear_StartDropping(-1, 0, 0, 0, #SimpleFadingTotalTime, 0)
    ElseIf WaitForDesiredType > 0 And WaitForDesiredType < #MaxWaitIDP
    ; wait for midis / cdda /
    If AllTears_Types(WaitForDesiredType) Or AllTears_TypesCount = ctSSLayer_MaxIDs
      Tear_StartDropping(-1, 0, 0, 0, #SimpleFadingTotalTime, 0)
      EndIf
    EndIf
  Repeat
    xTearWaitCall = #True
    TearDown(0, 0, 0, 0)
    xTearWaitCall = #False
    If WaitForDesiredType < 0
      ;-1 ;waitforall
      If AllTears_TypesCount < -WaitForDesiredType
        Break
        EndIf
      ElseIf Not WaitForDesiredType
      ; 0 ; -1 reserved  any = stream/tracker
      If AllTears_TypesCount = ctSSLayer_MaxIDs
        ShortenWeakTear()
        Else
        Break
        EndIf
      ElseIf WaitForDesiredType > 0 And WaitForDesiredType < #MaxWaitIDP
      ; wait for midis / cdda
      If AllTears_Types(WaitForDesiredType) = 0 And Not AllTears_TypesCount = ctSSLayer_MaxIDs
        Break
        EndIf
      EndIf
    
    ;If (xPStateIconPlugging Or xLoadingStream) ;And Not xForceAnimationNow
      DoAnimateStepDrawCheck(#False)
      ;EndIf
    DoEventsEx_Sleep(25)
    ForEver
  EndProcedure

Procedure.i Tear_Create()
  Define.i xResult
  Define.i xLong1

  Tear_WaitFor(0)
  AllTears_TypesCount = AllTears_TypesCount + 1
  For xLong1 = 0 To ctSSLayer_MaxIDsX
    If AllTears_IDs(xLong1) = 0
      xResult = xLong1
      Break
      EndIf
    Next
  AllTears_IDs(xResult) = 1
  If AllTears_TypesCount > 2
    MainForm_TearIconChance()
    EndIf
  ProcedureReturn xResult
  EndProcedure

; ask if set (for return) and set if not
Procedure.i QuerySetPattern(PatternPos.i)
  Define.i xResult
  Define.i xLong1

  xLong1 = 1 << (PatternPos & 7) ; mask
  PatternPos >> 3                ; offset
  xResult = xModPatterns(PatternPos) & xLong1
  If Not xResult
    xModPatterns(PatternPos) | xLong1
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ResetPatternLog()
  Define.i xLong1
  
  xModCurPattern = -1
  If CurMusic = #ctSSLayer_MusicTypeTracker And (ctSSLayer_CanUseItem(6) & $1)
    If (ctSSLayer_CanUseItem(6) & $4) = $4
      xLong1 = ctSSLayer_MusicGetPatterns(SongPointer(CurrentSongID))
      Else
      xLong1 = PLCurSongLength
      EndIf
    If xLong1 = 0
      ReDim xModPatterns(0) ; always need at least 1 bit
      Else
      ReDim xModPatterns((xLong1 + 9) >> 3)
      EndIf
    Else
    ReDim xModPatterns(0) ; always need at least 1 bit
    EndIf
  TrackerLoop = #False
  EndProcedure

Procedure MainForm_RestartEx()
  Tear_Volume(CurrentSongID) = 1
  ctSSLayer_SetPause(SongPointer(CurrentSongID), 1)
  ctSSLayer_SeekSong(SongPointer(CurrentSongID), 0)
  ctSSLayer_SetVolume(SongPointer(CurrentSongID), xSetVolume)
  Tear_Volume(CurrentSongID) = 1
  ctSSLayer_SetPause(SongPointer(CurrentSongID), 0)
  If CurMusic = #ctSSLayer_MusicTypeTracker
    ResetPatternLog()
    EndIf
  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("Sound restarted")
    CompilerEndIf
  EndProcedure

Procedure.i TearDown(xLong1.i, xLong2.i, xLong3.i, xLong4.i)
  ;Dim xLong3.i
  Define.f xSingle2
  Define.f xSingle1
  Static xBool1.i
  Define.POINT xType1
  Static xType2.POINT
  Static HasMovedState.i
  ;Static AnimateReadDirTM.i
  Static xLong5.i
  ;Define.POINT xType3
  Define.i RePossible
  
  ;xLong3 = 0 ; -1
  xLong4 = -1
  If CurMusic
    If Tear_StepT(CurrentSongID)
      xSingle2 = Tear_Volume(CurrentSongID)
      xLong4 = CurrentSongID
      Else
      If xPStateIconPlaying
        If xPStateIconPaused
          xSingle2 = 0
          Else
          xSingle2 = 1
          EndIf
        xLong4 = CurrentSongID
        EndIf
      EndIf
    EndIf
  For xLong1 = 0 To ctSSLayer_MaxIDsX
    If Tear_StepT(xLong1)
      xLong2 = GetElapsedTickTimeMS(Tear_STime(xLong1)) - Tear_Delay(xLong1)
      If xLong2 > 0
        If xLong2 > Tear_StepT(xLong1)
          If Not Tear_Volume(xLong1) = Tear_ShouldVolume(xLong1)
            ctSSLayer_SetVolume(SongPointer(xLong1), xSetVolume * Tear_ShouldVolume(xLong1))
            Tear_Volume(xLong1) = Tear_ShouldVolume(xLong1)
            EndIf
          If xLong2 > Tear_StepT(xLong1) + KeepMusicAliveTime
            Tear_StepT(xLong1) = 0
            Select Tear_Special(xLong1)
              Case 1, 11
                Tear_Dropped(xLong1)
                ctSSLayer_UnloadSong(SongPointer(xLong1))
              Case 2
                ctSSLayer_SetPause(SongPointer(xLong1), #True)
              Case 3
                MainForm_RestartEx()
              EndSelect
            EndIf
          Else
          xSingle1 = (1 - Cos((Tear_WasVolume(xLong1) + (Tear_ShouldVolume(xLong1) - Tear_WasVolume(xLong1)) * xLong2 / Tear_StepT(xLong1)) * 3.14159265)) / 2
          ctSSLayer_SetVolume(SongPointer(xLong1), xSingle1 * xSetVolume)
          Tear_Volume(xLong1) = xSingle1
          EndIf
        EndIf
      If Tear_StepT(xLong1)
        ;Stop
        If Tear_Volume(xLong1) > xSingle2
;Debug.Print "Cur3:" + Str(Tear_Volume(xLong1)) + " " + Tear_Caption(xLong1)
          xSingle2 = Tear_Volume(xLong1)
          xLong4 = xLong1
          EndIf
        EndIf
      EndIf
    Next

  ;Stop
  ;LastLoudestTearID = -1 ;xLong4
  If xLong4 = -1; Or xSingle2 = 0
    LastLoudestTearFn = ""
    LastLoudestTearCp = ""
    LastLoudestTearIS = #False
    LastLoudestTearBC = #False
    LastLoudestTearID = -1
    Else
;Debug.Print "Cur3:" + Str(Tear_Volume(xLong4)) + " " + Tear_Caption(xLong4)
    If xSingle2 = 0
      LastLoudestTearBC = #False
      Else
      LastLoudestTearBC = #True
      EndIf
    If Not ForceLoudestTear = -1
      If ForceLoudestTear = CurrentSongID
        xLong4 = ForceLoudestTear
        Else
        ForceLoudestTear = #False
        EndIf
      EndIf
    If Not (xPStateIconStartup Or (LastLoudestTearFn = Tear_Filename(xLong4) And LastLoudestTearCp = Tear_Caption(xLong4) And LastLoudestTearIS = Tear_IsINet(xLong4) And LastLoudestTearID = xLong4))
      LastLoudestTearFn = Tear_Filename(xLong4)
      LastLoudestTearCp = Tear_Caption(xLong4)
      LastLoudestTearIS = Tear_IsINet(xLong4)
      LastLoudestTearID = xLong4
      If Not xPStateIconPaused
        IRUMBar_TryAutoShow()
        EndIf
      EndIf
    EndIf
    
;Debug.Print LastLoudestTearFn
    
  If Not xBool1
    xBool1 = #True
    
    ;If IsDialoging = 0 And OutOfSessionPause And NotOutOfSessionOld
    If IsDialoging = 0 And (NotOutOfSessionOld Or Not OutOfSessionPause)
      If GlobalKeys
        xLong5 = 0
        ;xLong5 = 0
        If (GetAsyncKeyState_($10) & #AsyncKeyPressedMask)
          ;Shift
          xLong2 = $100
          Else
          xLong2 = 0
          EndIf
        
        If GetAsyncKeyState_($12) & #AsyncKeyPressedMask
          ;alt
          If GetAsyncKeyState_($11) & #AsyncKeyPressedMask
            ;ctrl
            ;Debug.Print "RespondTo2: ", xLong2
            For xLong1 = 0 To #KbdCountX_Minus_KbdSplitN
              If xKeyReg(xLong1) And (xKey(xLong1 + #KbdSplitN) & $100) = xLong2
                ;Debug.Print "RespondTo3: ", Hex(xKey(xLong1 + #KbdSplitN))
                If Not UnassignedKey(xKey(xLong1 + #KbdSplitN))
                  If GetAsyncKeyState_(xKey(xLong1 + #KbdSplitN) & $FF) & #AsyncKeyPressedMask
                    xLong5 = xLong1 + #KbdSplitN
                    EndIf
                  EndIf
                EndIf
              Next
            EndIf
          Else
          For xLong1 = 0 To #KbdCountX_Minus_KbdSplitN
            If xKeyReg(xLong1) And (xKey(xLong1 + #KbdSplitN) & $100) = xLong2
              If UnassignedKey(xKey(xLong1 + #KbdSplitN))
                If GetAsyncKeyState_(xKey(xLong1 + #KbdSplitN) & $FF) & #AsyncKeyPressedMask
                  xLong5 = xLong1 + #KbdSplitN
                  EndIf
                EndIf
              EndIf
            Next
          EndIf
        
        ;Debug.Print "HK: ", xLong5, RGK_xOldKey
        If xLong5 = RGK_xOldKey
          If Not xLong5 = 0
;Debug.Print "HotKeyEx again"
            If IsTickTimeElapsedMS(RGK_xOldKeyTime, RGK_xOldKeyTimeWait)
              Select xLong5
                Case #KbdC_GShowMenu, #KbdC_GShowAltMenu, #KbdC_GShowVolMenu, #KbdC_GShowTitle
                Default
                  MainForm_ProcessKey(xLong5)
                EndSelect
              RGK_xOldKeyTime = GetTickTimeMSEx()
              RGK_xOldKeyTimeWait = #RGK_xOldKeyTimeWaitShort
              If xLong5 = #KbdC_GShowTitle ;KbdC_GShowTitle_Fast
                IRUMBar_IRTicks = RGK_xOldKeyTime
                EndIf
              EndIf
            ;Else
            ;Debug.Print "HotKeyNot again"
            EndIf
          Else
          If Not xLong5 = 0
;Debug.Print "HotKeyEx first", xLong5, RGK_xOldKey
            MainForm_ProcessKey(xLong5)
            RGK_xOldKeyTime = GetTickTimeMSEx()
            RGK_xOldKeyTimeWait = #RGK_xOldKeyTimeWaitLong
;Else
;Debug.Print "HotKeyNot removed"
            EndIf
          If RGK_xOldKey = #KbdC_GShowTitle And RGK_xOldKeyTimeWait = #RGK_xOldKeyTimeWaitShort
            IRUMBar_Hide()
            EndIf
          RGK_xOldKey = xLong5
;Debug.Print "LP: ", RGK_xOldKey
          EndIf
        EndIf
      ;If AllTears_TypesCount > AnimateForTearCountX Or xPStateIconSndcard Or xPStateIconDeleting
      ;  If Not (xTearWaitCall Or xPStateIconStartup Or xAutoDoing Or xLoadingStream)
      ;;;DoAnimateStepDrawCheck(#False)
      ;    EndIf
      ;  EndIf
      EndIf

    DoAnimateStepDrawCheck(#False)



    GetCursorPosPX(@xType1)
    If GetForegroundWindow_() = MainHWnd
      Repeat
        If HasMovedState Or RePossible
          RePossible = #False
          If Not (PlayerInMenuLoop Or MainFormIsSplitterMovingTH Or MainFormIsSplitterMovingLW)
            xLong3 = -1
            xLong1 = WindowFromPoint_Point(xType1)
            
            
            For xLong2 = 0 To #xStaticIcons_Tags
              If xStaticIconsHWnd(xLong2) = xLong1
                If xLong2 = #xStaticIcons_DirList And IsWindowVisible_(xListHWnd(0))
                  Break
                  ElseIf xLong2 = #xStaticIcons_CurSong And IsWindowVisible_(xListHWnd(1))
                  Break
                  EndIf
                xLong3 = xLong2
                Break
                EndIf
              Next

            If xLong3 = CurShownToolTip
              If Not CurShownToolTip = -1
                If ToolTipInitTime = -1
                  If Not (xType1\x = xType2\x And xType1\y = xType2\y)
                    If ToolTipDelay = 0
                      CalcToolTip()
                      EndIf
                    EndIf
                  Else
                  If (xType1\x = xType2\x And xType1\y = xType2\y)
                    If IsTickTimeElapsedMS(ToolTipInitTime, ToolTipDelay)
;ShowNow:
                      ToolTipInitTime = -1
                      CalcToolTip()
                      ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 4)
                      EndIf
                    Else
                    ;Goto ReSetTTime
                    ToolTipInitTime = GetTickTimeMSEx()
                    EndIf
                  EndIf
                EndIf
              Else
              CurShownToolTip = xLong3
              If CurShownToolTip = -1
;HideOld:
                If ToolTipInitTime = -1
                  ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
                  EndIf
                Else
                If ToolTipDelay = 0
                  ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
                  ;Goto ShowNow
                  ToolTipInitTime = -1
                  CalcToolTip()
                  ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 4)
                  Else
                  If ToolTipInitTime = -1
                    ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
                    EndIf
;ReSetTTime:
                  ToolTipInitTime = GetTickTimeMSEx()
                  EndIf
                EndIf
              EndIf
            ElseIf Not CurShownToolTip = -1
;HideAll:
            CurShownToolTip = -1
            ;Goto HideOld
            If ToolTipInitTime = -1
              ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
              EndIf
            EndIf
          ElseIf Not (xType1\x = xType2\x And xType1\y = xType2\y)
          HasMovedState = #True
          RePossible = #True
          EndIf
        Until RePossible = #False
      ElseIf HasMovedState
      HasMovedState = #False
      ;Goto HideAll
;HideAll:
      CurShownToolTip = -1
      ;;;;Goto HideOld
      If ToolTipInitTime = -1
        ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
        EndIf
      EndIf
    xType2\x = xType1\x
    xType2\y = xType1\y
    xBool1 = #False
    EndIf
  EndProcedure

Procedure ReSetTearArrayCount()
  ctSSLayer_MaxIDs = ctSSLayer_CanUseItem($D) + 1
  If ctSSLayer_MaxIDs < 2
    ctSSLayer_MaxIDs = 2
    ElseIf ctSSLayer_MaxIDs > 16
    ctSSLayer_MaxIDs = 16 ;enough for music!
    EndIf
  ctSSLayer_MaxIDsX = ctSSLayer_MaxIDs - 1
  
  ReDim Tear_Type(ctSSLayer_MaxIDsX)
  ReDim Tear_STime(ctSSLayer_MaxIDsX)
  ReDim Tear_Delay(ctSSLayer_MaxIDsX)
  ReDim Tear_WasVolume(ctSSLayer_MaxIDsX)
  ReDim Tear_Volume(ctSSLayer_MaxIDsX)
  ReDim Tear_Special(ctSSLayer_MaxIDsX)
  ReDim Tear_ShouldVolume(ctSSLayer_MaxIDsX)
  ReDim Tear_StepT(ctSSLayer_MaxIDsX)
  ReDim Tear_Filename(ctSSLayer_MaxIDsX)
  ReDim Tear_Caption(ctSSLayer_MaxIDsX)
  ReDim Tear_IsINet(ctSSLayer_MaxIDsX)
  ReDim Tear_IsMode(ctSSLayer_MaxIDsX)
  ReDim Tear_TotLength(ctSSLayer_MaxIDsX)
  ReDim SongPointer(ctSSLayer_MaxIDsX)
  ReDim AllTears_IDs(ctSSLayer_MaxIDsX)
  
  AnimateForTearCountX = ctSSLayer_MaxIDsX ;- 1
  EndProcedure

Procedure TearDown_Relocate(OrgTimer.i)
  Define.i xLong1
  
  OrgTimer = GetElapsedTickTimeMS(OrgTimer)
  For xLong1 = 0 To ctSSLayer_MaxIDsX
    If Tear_StepT(xLong1)
      Tear_STime(xLong1) = ((Tear_STime(xLong1) + OrgTimer) & TickTimeMSAndMask())
      EndIf
    Next
  EndProcedure

CompilerIf #False
PublicDimLong(Function Tear_GetLoudest().i
  Dim xLong1.i
  Dim xLong2.i
  Dim xLong3.i
  

  For xLong1 = 0 To ctSSLayer_MaxIDsX
    If Tear_StepT(xLong1)
      If Tear_Volume(xLong1) > xLong2
        xLong2 = Tear_Volume(xLong1)
        xLong3 = xLong1
        EndIf
      EndIf
    Next
  ;Debug.Print "LoudestTear: (" + CStr(xLong2) + ") " & Tear_GetLoudest
  ;Debug.Print "LoudestTear1: " + Tear_GetLoudest
  ;Debug.Print "LoudestTear2: " + Tear_Filename(CurrentSongID)
  ProcedureReturn xResult
  EndProcedure

CompilerEndIf


Procedure UpdatePanning(xPanning)
  If CurMusic = #ctSSLayer_MusicTypeTracker And Not xSongIsMidi
    ctSSLayer_UpdatePanning(SongPointer(CurrentSongID), xModPanning)
    EndIf
  EndProcedure

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Macro DoAnimFactorX
    MainDPIScaleX
    EndMacro
  Macro DoAnimFactorY
    MainDPIScaleY
    EndMacro
  CompilerElse
  Macro DoAnimFactorX
    xScaleX
    EndMacro
  Macro DoAnimFactorY
    xScaleY
    EndMacro
  CompilerEndIf

Procedure DoAnimateCalcSizePoses()
  Define.i AnimDirSDotSperatY
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    CompilerElse
    Define.f xScaleX
    Define.f xScaleY
    
    If IsHighColor
      xScaleX = MainDPIScaleX
      xScaleY = MainDPIScaleY
      Else
      xScaleX = 1
      xScaleY = 1
      EndIf
    CompilerEndIf

  AnimDirSDotSperatX = Round(3 * DoAnimFactorX, #PB_Round_Down)
  AnimDirSDotSperatY = Round(3 * DoAnimFactorY, #PB_Round_Down)
  AnimDirSDotFTMult = 6 * DoAnimFactorX
  AnimDirSDotWidthP = AnimDirSDotFTMult - AnimDirSDotSperatX + 1
  AnimDirIconWidth = 5 * (AnimDirSDotWidthP - 1) + (AnimDirSDotSperatX << 2)
  AnimDirTotalWidth = AnimDirIconWidth + AnimDirSDotSperatX << 1
  AnimDirIconMasLeftP = AnimDirSDotSperatX + 5 * AnimDirSDotFTMult
  AnimDirIconHeight = AnimDirIconWidth * DoAnimFactorY / DoAnimFactorX
  AnimDirIconTopPS = AnimDirSDotSperatY;2 * DoAnimFactorY()
  AnimDirSDotTopPos = AnimDirIconHeight + (AnimDirSDotSperatY << 1) ;AnimDirIconTopPS << 1
  AnimHeightAnimNone = AnimDirSDotTopPos
  AnimDirSDotBotPos = AnimDirSDotTopPos + 2.25 * DoAnimFactorY
  AnimHeightAnimOnly = AnimDirSDotBotPos + AnimDirSDotSperatY;2 * DoAnimFactorY()
  AnimDirProgTopPos = AnimDirSDotBotPos + AnimDirSDotSperatY;3 * DoAnimFactorY()
  AnimDirProgBotPos = AnimDirProgTopPos + 5 * DoAnimFactorY
  AnimHeightAnimProg = AnimDirProgBotPos + AnimDirSDotSperatY;DoAnimFactorY()

  AnimExtraPadding = ScrollComboWidth + AnimDirTotalWidth + 8 * MainDPIScaleX
  EndProcedure

Procedure DoAnimateRealDraw()
  Define.i xLong2.i
  Define.RECT xType1
  Define.i hBmp
  Define.i hBmpOld
  Define.i hBrush
  #xStepperA = 10

  If xIsActiveBW
    hBmp = CreateCompatibleBitmapX(AnimDirTotalWidth, AnimHeightAnimProg)
    ElseIf xIsActiveAN
    hBmp = CreateCompatibleBitmapX(AnimDirTotalWidth, AnimHeightAnimOnly)
    Else
    hBmp = CreateCompatibleBitmapX(AnimDirTotalWidth, AnimHeightAnimNone)
    EndIf
  If hBmp
    hBmpOld = SelectObject_(xSharedDC, hBmp)
    If hBmpOld
      xType1\Right = AnimDirTotalWidth
      xType1\Bottom = AnimHeightAnimProg
      FillRect_(xSharedDC, @xType1, 6)
      If OldAnimWEMF
        BitmapFromWEMFEx(xSharedDC, OldAnimWEMF, AnimDirSDotSperatX, AnimDirIconTopPS, AnimDirIconWidth, AnimDirIconHeight, SysColor5, 0)
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
        ElseIf OldAnimhIcon
        DrawIconEx_(xSharedDC, (AnimDirTotalWidth >> 1) - 16, AnimDirIconTopPS + (AnimDirIconHeight >> 1) - 16, OldAnimhIcon, 32, 32, 0, 0, 3)
  CompilerEndIf
        EndIf
      xType1\Top = AnimDirSDotTopPos ; 34
      xType1\Bottom = AnimDirSDotBotPos + 1 ; 38
      
      
      If xIsActiveAN
        hBrush = CreateSolidBrush_(xDoAnimColor3)
        If hBrush
          For xLong2 = DoAnimate_CurStep + 5 To (DoAnimate_CurStep + #xStepperA)
            xType1\Left = AnimDirSDotSperatX + (xLong2 % #xStepperA) * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            Next
          DeleteObject_(hBrush)
          EndIf
        If DoAnimate_CurStep < 5 Or DoAnimate_CurStep > #xStepperA - 6
          hBrush = CreateSolidBrush_(xDoAnimColor2)
          If hBrush
            xType1\Left = AnimDirSDotSperatX + ((DoAnimate_CurStep + 1) % #xStepperA) * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            xType1\Left = AnimDirSDotSperatX + ((DoAnimate_CurStep + 5) % #xStepperA) * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            DeleteObject_(hBrush)
            EndIf
          EndIf
        If DoAnimate_CurStep < 4 Or DoAnimate_CurStep > #xStepperA - 5
          hBrush = CreateSolidBrush_(xDoAnimColor1)
          If hBrush
            xType1\Left = AnimDirSDotSperatX + ((DoAnimate_CurStep + 2) % #xStepperA) * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            xType1\Left = AnimDirSDotSperatX + ((DoAnimate_CurStep + 4) % #xStepperA) * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            DeleteObject_(hBrush)
            EndIf
          EndIf
        xType1\Left = AnimDirSDotSperatX + ((DoAnimate_CurStep + 3) % #xStepperA) * AnimDirSDotFTMult
        If xType1\Left < AnimDirIconMasLeftP
          hBrush = CreateSolidBrush_(FLineColor)
          If hBrush
            xType1\Right = xType1\Left + AnimDirSDotWidthP
            FillRect_(xSharedDC, xType1, hBrush)
            DeleteObject_(hBrush)
            EndIf
          EndIf




        If xIsActiveBW
          hBrush = CreateSolidBrush_(xDoAnimColor1)
          If hBrush
            xType1\Top = AnimDirProgTopPos
            xType1\Bottom = AnimDirProgBotPos
            xType1\Left = AnimDirSDotSperatX
            xType1\Right = AnimDirTotalWidth - AnimDirSDotSperatX + 1
            FrameRect_(xSharedDC, @xType1, hBrush)
            DeleteObject_(hBrush)
            hBrush = CreateSolidBrush_(xDoAnimColor2)
            If hBrush
              xType1\Left + 1
              xType1\Top + 1
              xType1\Bottom - 1
;Debug "ProgIR: " + Str(AnimDirIconTotWidth - (AnimDirSDotSperatX + 1) << 1)
              xType1\Right = AnimDirSDotSperatX + MulDiv_(xCurBWPos, AnimDirTotalWidth - (AnimDirSDotSperatX + 1) << 1, #xDefBWDifL) + 2
              FillRect_(xSharedDC, @xType1, hBrush)
              DeleteObject_(hBrush)
              EndIf
            EndIf
          If *TasBarPrg
            TaskBarProgress_SetProgress(*TasBarPrg, MainHWnd, xCurBWPos, #xDefBWDifC)
            EndIf
          EndIf
        Else
        hBrush = CreateSolidBrush_(xDoAnimColor3)
        If hBrush
          For xLong2 = 0 To 4
            xType1\Left = AnimDirProgTopPos + xLong2 * AnimDirSDotFTMult
            If xType1\Left < AnimDirIconMasLeftP
              xType1\Right = xType1\Left + AnimDirSDotWidthP
              FillRect_(xSharedDC, xType1, hBrush)
              EndIf
            Next
          DeleteObject_(hBrush)
          EndIf
        EndIf
      SelectObject_(xSharedDC, hBmpOld)
      SendMessage_(xStaticIconsHWnd(#xStaticIcons_Anim), $172, 0, hBmp)
      If xStaticIconsBMP(#xStaticIcons_Anim)
        DeleteObject_(xStaticIconsBMP(#xStaticIcons_Anim))
        EndIf
      xStaticIconsBMP(#xStaticIcons_Anim) = hBmp
      Else
      DeleteObject_(hBmp)
      EndIf
    EndIf
  EndProcedure

Procedure DoAnimateStepDrawCheck(Force.i)
  Static xCurTick.i
  Static.i HadAnim
  Static.i HadProg
  Define.i xLong1

     ;If Not (xHiddenAutoDoing Or xPStateIconSndcard Or xPStateIconStartup Or AllTears_TypesCount > AnimateForTearCountX)
  If xPStateIconSndcard Or xPStateIconStartup Or xAutoDoing Or AllTears_TypesCount > AnimateForTearCountX Or xPStateIconDeleting Or (xLoadingStream And Not xClassicBlockingOnLoad)
    xIsActiveAN = #True
    Else
    xIsActiveAN = #False
    EndIf

  If Not xIsActiveBW
    If HadProg And xIsActiveAN
      SetWindowPos_(xStaticIconsHWnd(#xStaticIcons_Anim), 0, 0, 0, AnimDirTotalWidth, AnimHeightAnimOnly, $216)
      ElseIf (HadProg Or HadAnim) And Not xIsActiveAN
      SetWindowPos_(xStaticIconsHWnd(#xStaticIcons_Anim), 0, 0, 0, AnimDirTotalWidth, AnimHeightAnimNone, $216)
      EndIf
    EndIf

;Debug "DASDC: Anim: " + Str(HasAnim) + " (prev: " + Str(HadAnim) + "), Force: " + Str(Force)

  xLong1 = GetTickCount_() & $f00
  If Not xLong1 = xCurTick
    DoAnimate_CurStep = (DoAnimate_CurStep + 1) % #xStepperA
    xCurTick = xLong1
    If xIsActiveAN Or HadAnim Or Force
      DoAnimateRealDraw()
      EndIf
    ElseIf Force Or HadAnim
    DoAnimateRealDraw()
    EndIf

  If xIsActiveAN And Not (xIsActiveBW Or HadAnim)
    SetWindowPos_(xStaticIconsHWnd(#xStaticIcons_Anim), 0, 0, 0, AnimDirTotalWidth, AnimHeightAnimNone, $216)
    EndIf

  HadAnim = xIsActiveAN
  HadProg = xIsActiveBW
  EndProcedure

Procedure DoAnimateSetIcon(IconID.i)
  If OldAnimWEMF
    CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
      DeleteEnhMetaFile_(OldAnimWEMF)
      CompilerElse
      DeleteMetaFile_(OldAnimWEMF)
      CompilerEndIf
    OldAnimWEMF = 0
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    ElseIf OldAnimhIcon
    DestroyIcon_(OldAnimhIcon)
    OldAnimhIcon = 0
  CompilerEndIf
    EndIf
  
  If IconID = -1
    ShowWindow_(xStaticIconsHWnd(#xStaticIcons_Anim), 0)
    If CurShownToolTip = #xStaticIcons_Anim
      CurShownToolTip = -1
      If ToolTipInitTime = -1
        ShowWindow_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0)
        EndIf
      EndIf
    Else
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      OldAnimWEMF = LoadResEx_WEMF_MultiOS(IconID)
      CompilerElse
      If IsHighColor
        OldAnimWEMF = LoadResEx_WEMF_MultiOS(IconID)
        EndIf
      If Not OldAnimWEMF
        OldAnimhIcon = LoadResEx_Image_MultiOS(IconID, 1, 32, 32)
        EndIf
      CompilerEndIf
    DoAnimateStepDrawCheck(#True)
    ShowWindow_(xStaticIconsHWnd(#xStaticIcons_Anim), 1)
    EndIf
;Debug AnimDirIconTotWidth
;Debug AnimDirIconHeight
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 489
; FirstLine = 483
; Folding = ------
; EnableUnicode
; EnableXP
; CompileSourceDirectory