; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2015 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

Global Dim TimerEdit_xPopupMenu.i(2)
Global TimerEditor_xEventCount.i
Global Dim TimerEditor_xEventID.i(#xTimerEvMaxSubEventsX)
Global Dim TimerEditor_xEventFile.s(#xTimerEvMaxSubEventsX)
Global Dim xEvAlias.i(#KbdSplitP)
Global Dim TimerEdit_HWndList.i(1)

Global TimerEditKBDProcOld.i ;TimerEditKBDProc)
Global TimerEditKBDProcOldLite.i ;TimerEditKBDProcLite
Global TimerEditTxtProcOld.i ;TimerEditTxtProc)
Global TimerEditOldDropMode.i

Global TimerEditWarnIcon.i


Procedure TimerEdit_SetDragDrop(Enabled.i)
  If TimerEdit_HWndList(1)
    If Enabled XOr TimerEditOldDropMode
      ;DragAcceptFiles(xTimerEditingHWnd, -CLng(Enabled))
      DragAcceptFiles_(TimerEdit_HWndList(1), Enabled)
      TimerEditOldDropMode = Enabled
      EndIf
    EndIf
  EndProcedure

Procedure UpdateWidths()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  ;Dim xType1 As POINTAPI
  Define.s xChar1
  Dim xLongA1.i(1)

  SelectObject_(xSharedDC, hFontGSys)
  For xLong1 = 0 To TimerEditor_xEventCount - 1
    xChar1 = LoadResString(3700 + TimerEditor_xEventID(xLong1))
    xLong4 = GetTextOutWidth(xSharedDC, xChar1)
    If xLong4 > xLong2
      xLong2 = xLong4
      EndIf
    ;xTimerDisplayExtraLen = xLong4 + xTimerDisplaySpace1
    If TimerHasSubFile(TimerEditor_xEventID(xLong1))
      xLong4 = GetTextOutWidth(xSharedDC, TimerEditor_xEventFile(xLong1))
      If xLong4 > xLong3
        xLong3 = xLong4
        EndIf
      EndIf
    Next
  If xLong3 = 0
    If Not TimerEdit_HWndList(1) = 0
      SendMessage_(TimerEdit_HWndList(1), $192, 0, 0) ;xLongA1(0))
      If xLong2 = 0
        SendMessage_(TimerEdit_HWndList(1), #LB_SETHORIZONTALEXTENT, 0, 0)
        Else
        SendMessage_(TimerEdit_HWndList(1), #LB_SETHORIZONTALEXTENT, xLong2 + 4, 0)
        EndIf
      EndIf
    Else
    xLongA1(0) = 0
    xLongA1(1) = (xLong2 + 16) * xGlobalDialogUnitsGFix
    If Not TimerEdit_HWndList(1) = 0
      SendMessage_(TimerEdit_HWndList(1), $192, 2, @xLongA1(0))
      SendMessage_(TimerEdit_HWndList(1), #LB_SETHORIZONTALEXTENT, xLong2 + xLong3 + 16 + 4, 0)
      EndIf
    ;Else
    EndIf
  EndProcedure

Procedure.i GetSelected(Index.i, *SelIndex)
  Define.i xResult

  If Index = 0 Or TimerEditor_xEventCount
    If TimerEdit_HWndList(Index)
      xResult = GetListIndexMS(TimerEdit_HWndList(Index), *SelIndex)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ListSelChange(Index.i)
  If TimerHasSubFile(TimerEditor_xEventID(Index))
    LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #True)
    SetDlgItemText_(xTimerEditingHWnd, 2760, @TimerEditor_xEventFile(Index))
    Else
    LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #False)
    SetDlgItemText_(xTimerEditingHWnd, 2760, @"")
    EndIf
  EndProcedure

Procedure ListSelChangeUnknown()
  Define.i xLong1
    
  If GetSelected(1, @xLong1)
    ListSelChange(xLong1)
    EndIf
  EndProcedure

Procedure.s GetBrowsedItem(ForID.i, ByButton.i, GivenDir.s)
  Define.s xResult
  Define.i xLong2
  Define.i xLong3
  Define.i xBool1
  Define.s xChar1
  
  Select ForID
    Case #KbdC_FAddPList, #KbdC_FLoadPL
      xLong2 = 0
      xBool1 = #True
    Case #KbdC_FSavePLas
      xLong2 = 0
    Case #KbdC_OTimerImport
      xLong2 = 2
      xBool1 = #True
    Case #KbdC_OTimerExport
      xLong2 = 2
    Case #KbdC_OPresetSave
      xLong2 = 1
    Case #KbdC_OPresetLoad
      xLong2 = 1
      xBool1 = #True
    Case #KbdC_FAddDir, #KbdC_FAddFileS
      xLong2 = 3
    Default
      xLong2 = -1
    EndSelect
  If xLong2 = 3
    If ForID = #KbdC_FAddFileS
      If Not xSecureMode
        If xUsedTypesResort
          xUsedTypes = MainForm_ResortTypes(xUsedTypes)
          EndIf
        xChar1 = GetUsedFileFilters()
        xChar1 = CalaymLoadSingleFile(xChar1, LoadResString(1200), xLastDirectory, xTimerEditingHWnd, #False)
        If Not Len(xChar1) = 0
          xLastDirectory = SimpleDir(xChar1)
          If AllowedItem(xChar1, #True) = 1
            xResult = xChar1
            EndIf
          EndIf
        EndIf
      Else ;If Not xSecureMode
      ;xChar1 = SHBrowseForFolder(xTimerEditingHWnd, LoadResString(1210), GivenDir)
      xChar1 = PathRequester(LoadResString(1210), GivenDir)
      If Right(xChar1, 1) = "\"
        xChar1 = Left(xChar1, Len(xChar1) - 1)
        EndIf
      If Len(xChar1)
        xLastDir = xChar1
        ;If Len(xChar1) = 3
        ;  xChar1 = Left(xChar1, 2)
        ;  EndIf
        If AllowedItem(xChar1, #True) = 0 Or Len(xChar1) = 2
          xResult = xChar1
          EndIf
        EndIf
      EndIf
    Else
    If Not xLong2 = -1
      Select ByButton
        Case 5
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), TimerEdit_HWndList(1))
        Case 4
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), 0)
        Case 3
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), 0)
        Case 2
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), GetDlgItem_(xTimerEditingHWnd, 2740))
        Case 1
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), GetDlgItem_(xTimerEditingHWnd, 2761))
        Default
          xLong3 = GetAPIPopupMenu(xTimerEditingHWnd, xTimerPLMenu(xLong2), TimerEdit_HWndList(0))
        EndSelect
      Select xLong3
        Case 2700
          If Not xSecureMode
 ; playlistformatsimport
            xChar1 = CalaymLoadSingleFile(GetPLTypes(#False), LoadResString(1220), m3uList, xTimerEditingHWnd, #False)
            If Not Len(xChar1) = 0
              m3uList = SimpleDir(xChar1)
              If AllowedItem(xChar1, xBool1) = 255
                xResult = xChar1
                EndIf
              EndIf
            EndIf
        Case 2720
          If Not xSecureMode
            xChar1 = CalaymLoadSingleFile(LoadResString(1605) + #FileFilterVBNullChar + "*.cpt", LoadResString(1600), TimerDir, xTimerEditingHWnd, #False)
            If Not Len(xChar1) = 0
              TimerDir = SimpleDir(xChar1)
              If AllowedItem(xChar1, xBool1) = 254
                xResult = xChar1
                EndIf
              EndIf
            EndIf
        Case 2710
          If Not xSecureMode
            xChar1 = CalaymLoadSingleFile(LoadResString(1655) + #FileFilterVBNullChar + "*.cps" + #FileFilterVBNullChar + LoadResString(1656) + #FileFilterVBNullChar + "*.ini", LoadResString(1650), PresetFile, xTimerEditingHWnd, #False)
            If Not Len(xChar1) = 0
              PresetFile = SimpleDir(xChar1)
              If AllowedItem(xChar1, xBool1) = 253
                xResult = xChar1
                EndIf
              EndIf
            EndIf
        Case 3000 + xLong2 * 100 To 3099 + xLong2 * 100
          xResult = vPLXMain + vPLX(#vPLXMax * xLong2 + xLong3 - (3000 + xLong2 * 100))
        EndSelect
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure UpdateByMenu(xIndex.i, ByButton.i)
  Define.s xChar1
  
  xChar1 = GetBrowsedItem(TimerEditor_xEventID(xIndex), ByButton, TimerEditor_xEventFile(xIndex))
  If Not Len(xChar1) = 0
    SetDlgItemText_(xTimerEditingHWnd, 2760, @xChar1)
    ;txtRes(2760).Text = xChar1
    TimerEditor_xEventFile(xIndex) = xChar1
;    lstRes(2750).List(xIndex) =
    If Not TimerEdit_HWndList(1) = 0
      LoadResEx_Dialog_ListItemSet(TimerEdit_HWndList(1), xIndex, LoadResString(3700 + TimerEditor_xEventID(xIndex)) + #TAB$ + xChar1, #True)
      UpdateWidths()
      EndIf
    EndIf
  EndProcedure

Procedure WriteSettings(TimerEvSetts.s)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.s xChar2

  xLong1 = FindString(TimerEvSetts, "=")
  If xLong1
    xChar2 = Trim(Left(TimerEvSetts, xLong1 - 1))
    SetDlgItemText_(xTimerEditingHWnd, 2705, @xChar2)
    EndIf
  TimerEvSetts = TimerEvSetts + #TimerSepp
  
  Repeat
    xLong2 = FindString(TimerEvSetts, #TimerSepp, xLong1 + 1)
    If xLong2 = 0
      Break
      EndIf
    xChar2 = Mid(TimerEvSetts, xLong1 + 1, xLong2 - xLong1 - 1)
    xLong3 = FindString(xChar2, ",")
    If xLong3
      TimerEditor_xEventID(TimerEditor_xEventCount) = Val(Left(xChar2, xLong3 - 1))
      TimerEditor_xEventFile(TimerEditor_xEventCount) = Trim(Mid(xChar2, xLong3 + 1))
      If TimerEdit_HWndList(1)
        xChar2 = LoadResString(3700 + TimerEditor_xEventID(TimerEditor_xEventCount)) + #TAB$ + TimerEditor_xEventFile(TimerEditor_xEventCount)
        SendMessage_(TimerEdit_HWndList(1), $180, 0, @xChar2)
        EndIf
      TimerEditor_xEventCount = TimerEditor_xEventCount + 1
      Else
      TimerEditor_xEventID(TimerEditor_xEventCount) = Val(xChar2)
      If TimerEdit_HWndList(1)
        If TimerEditor_xEventID(TimerEditor_xEventCount) >= #KbdC_CVolUp And TimerEditor_xEventID(TimerEditor_xEventCount) <= #KbdC_CVolFull
          xChar2 = LoadResString(3960 + TimerEditor_xEventID(TimerEditor_xEventCount) - #KbdC_CVolUp)
          Else
          xChar2 = LoadResString(3700 + TimerEditor_xEventID(TimerEditor_xEventCount))
          EndIf
        SendMessage_(TimerEdit_HWndList(1), $180, 0, @xChar2)
        EndIf
      TimerEditor_xEventCount = TimerEditor_xEventCount + 1
      EndIf
    xLong1 = xLong2
    ForEver
  If TimerEditor_xEventCount = 0
    TimerEdit_SetDragDrop(#True)
    Else
    If TimerEditor_xEventCount = #xTimerEvMaxSubEvents
      LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2740, #False)
      TimerEdit_SetDragDrop(#False)
      EndIf
    If TimerEditor_xEventCount > 1
      LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2742, #True)
      LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2743, #True)
      EndIf
    LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2741, #True)
    UpdateWidths()
    EndIf
  EndProcedure

Procedure LoadResEx_Dialog_ListIndexMS(DialogHWnd.i, ControlID.i, Value.i)
  ControlID = GetDlgItem_(DialogHWnd, ControlID)
  If ControlID
    SendMessage_(ControlID, $185, 0, -1)
    SendMessage_(ControlID, $185, 1, Value)
    SendMessage_(ControlID, #LB_SETCURSEL, 1, Value)
    SendMessage_(ControlID, #CB_SETCURSEL, Value, 0)
    EndIf
  EndProcedure

Procedure AddNow(ByButton.i)
  Define.i xLong1
  Define.s xChar1
  
  If Not TimerEditor_xEventCount = #xTimerEvMaxSubEvents
    If GetSelected(0, @xLong1)
      If ValidSetupKey(xEvAlias(xLong1))
        If TimerHasSubFile(xEvAlias(xLong1))
          xChar1 = GetBrowsedItem(xEvAlias(xLong1), ByButton, xLastDir)
          If Len(xChar1) = 0
            ProcedureReturn
            Else
            TimerEditor_xEventFile(TimerEditor_xEventCount) = xChar1
            If TimerEdit_HWndList(1)
              xChar1 = LoadResString(3700 + xEvAlias(xLong1)) + #TAB$ + TimerEditor_xEventFile(TimerEditor_xEventCount)
              SendMessage_(TimerEdit_HWndList(1), $180, 0, @xChar1)
              EndIf
            SetDlgItemText_(xTimerEditingHWnd, 2760, @TimerEditor_xEventFile(TimerEditor_xEventCount))
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #False)
            EndIf
          Else
          If TimerEdit_HWndList(1)
            If xEvAlias(xLong1) >= #KbdC_CVolUp And xEvAlias(xLong1) <= #KbdC_CVolFull
              xChar1 = LoadResString(3960 + xEvAlias(xLong1) - #KbdC_CVolUp)
              Else
              xChar1 = LoadResString(3700 + xEvAlias(xLong1))
              EndIf
            SendMessage_(TimerEdit_HWndList(1), $180, 0, @xChar1)
            EndIf
          SetDlgItemText_(xTimerEditingHWnd, 2760, @"")
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #False)
          EndIf
          
        TimerEditor_xEventID(TimerEditor_xEventCount) = xEvAlias(xLong1)
        LoadResEx_Dialog_ListIndexMS(xTimerEditingHWnd, 2750, TimerEditor_xEventCount)
        ListSelChange(TimerEditor_xEventCount)

        TimerEditor_xEventCount + 1
        UpdateWidths()
        
        If TimerEditor_xEventCount = #xTimerEvMaxSubEvents
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2740, #False)
          TimerEdit_SetDragDrop(#False)
          ElseIf TimerEditor_xEventCount = 1
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2741, #True)
          ElseIf TimerEditor_xEventCount = 2
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2742, #True)
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2743, #True)
          EndIf
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure.s LoadResEx_Dialog_ListItemGet(HWndControl.i, ListIndex.i)
  Define.s xResult
  Define.i xLong1

  If HWndControl
    xLong1 = SendMessage_(HWndControl, $18A, ListIndex, 0)
    If xLong1 > 0 And xLong1 < #ptrTempSizeXAW
      HWndControl = SendMessage_(HWndControl, $189, ListIndex, *ptrTemp)
      If Not HWndControl = -1
        xResult = PeekS(*ptrTemp, HWndControl)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ToggleEvents(OrigIndex.i, NewIndex.i)
  Define.s xChar1
  Define.i xLong1
  
  xChar1 = TimerEditor_xEventFile(OrigIndex)
  TimerEditor_xEventFile(OrigIndex) = TimerEditor_xEventFile(NewIndex)
  TimerEditor_xEventFile(NewIndex) = xChar1
  
  xLong1 = TimerEditor_xEventID(OrigIndex)
  TimerEditor_xEventID(OrigIndex) = TimerEditor_xEventID(NewIndex)
  TimerEditor_xEventID(NewIndex) = xLong1
  
  ;xChar1 = lstRes(2750).List(OrigIndex)
  ;lstRes(2750).List(OrigIndex) = lstRes(2750).List(NewIndex)
  ;lstRes(2750).List(NewIndex) = xChar1
  
  ;xChar1 = lstRes(2750).List(OrigIndex)
  If Not TimerEdit_HWndList(1) = 0
    xChar1 = LoadResEx_Dialog_ListItemGet(TimerEdit_HWndList(1), OrigIndex)
  
    LoadResEx_Dialog_ListItemSet(TimerEdit_HWndList(1), OrigIndex, LoadResEx_Dialog_ListItemGet(TimerEdit_HWndList(1), NewIndex), #False)
    LoadResEx_Dialog_ListItemSet(TimerEdit_HWndList(1), NewIndex, xChar1, #False)
    LoadResEx_Dialog_ListIndexMS(xTimerEditingHWnd, 2750, NewIndex)
    EndIf
  EndProcedure

;boolean
Procedure.i LoadResEx_Dialog_TimeLongA(HWndDialog.i, ControlID.i, *Value, ReadFromDialog.i = #False)
  Define.i xResult
  Define.i xLong1
  Define.SYSTEMTIME xType1
  Define.s xChar1
  ;Dim xTypeA1(1) As SystemTime
  ;Dim xType1 As SystemTime

  ControlID = GetDlgItem_(HWndDialog, ControlID)
  If Not ControlID = 0
    xLong1 = PeekI(*Value)
    If ReadFromDialog
      SendMessage_(ControlID, $1001, 0, @xType1)
      ControlID = (xType1\wHour * 60 + xType1\wMinute) ;* 1000
      If Not ControlID = xLong1
        xResult = #True
        PokeI(*Value, ControlID)
        EndIf
      Else
      xChar1 = "HH':'mm"
      CompilerIf #PB_Compiler_Unicode
        SendMessage_(ControlID, $1032, 0, @xChar1)
        CompilerElse
        SendMessage_(ControlID, $1005, 0, @xChar1)
        CompilerEndIf
      If xLong1 = -1
        GetLocalTime_(@xType1)
        SendMessage_(ControlID, $1002, 2, @xType1)
        Else
        With xType1
          \wYear = 2000
          \wMonth = 1
          \wDay = 1
          \wHour = Int(xLong1 / 60)
          \wMinute = xLong1 % 60
          EndWith
        SendMessage_(ControlID, $1002, 0, @xType1)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure TimerEdit_RaiseButton(ButtonID.i)
  Define.i xLong1
  Define.i xLong2
  Define.s xChar1

  Select (ButtonID & $FFFf)
    Case 2750
      If (ButtonID & $FFFF0000) = $10000
        ListSelChangeUnknown()
        EndIf
    Case 2740 ;add
      AddNow(2)
    Case 2741 ;rem
      If GetSelected(1, @xLong1)
        For xLong2 = xLong1 To TimerEditor_xEventCount - 2
          TimerEditor_xEventID(xLong2) = TimerEditor_xEventID(xLong2 + 1)
          TimerEditor_xEventFile(xLong2) = TimerEditor_xEventFile(xLong2 + 1)
          Next
        TimerEditor_xEventCount = TimerEditor_xEventCount - 1
        If Not TimerEdit_HWndList(1) = 0
          SendMessage_(TimerEdit_HWndList(1), $182, xLong1, 0)
          EndIf
        UpdateWidths()
        If TimerEditor_xEventCount = 0
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2741, #False)
          SetDlgItemText_(xTimerEditingHWnd, 2760, @"")
          LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #False)
          Else
          If TimerEditor_xEventCount = 1
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2742, #False)
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2743, #False)
            EndIf
          If xLong1 < TimerEditor_xEventCount
            ;lstRes(2750).ListIndex = xLong1
            LoadResEx_Dialog_ListIndexMS(xTimerEditingHWnd, 2750, xLong1)
            Else
            LoadResEx_Dialog_ListIndexMS(xTimerEditingHWnd, 2750, xLong1 - 1)
            EndIf
          If TimerEditor_xEventCount = #xTimerEvMaxSubEventsX
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2740, #True)
            TimerEdit_SetDragDrop(#True)
            EndIf
          EndIf
        EndIf
    Case 2742 ;up
      If GetSelected(1, @xLong1)
        If Not xLong1 = 0 Or TimerEditor_xEventCount = 1
          ToggleEvents(xLong1, xLong1 - 1)
          EndIf
        EndIf
    Case 2743 ;down
      If GetSelected(1, @xLong1)
        If Not xLong1 = TimerEditor_xEventCount - 1
          ToggleEvents(xLong1, xLong1 + 1)
          EndIf
        EndIf
    Case 2761 ;browse!
      If GetSelected(1, @xLong1)
        UpdateByMenu(xLong1, 1)
        EndIf
    Case 2790
      ;xLong1 = CorrectDate(eTime.Value)
      LoadResEx_Dialog_TimeLongA(xTimerEditingHWnd, 2700, @xLong1, #True)
      CompilerIf #TimeTestDebug And #UseFileLogging
        MainForm_ctConsoleA_AddLog("TimeDebug: Trying " + Str(xLong1))
        CompilerEndIf

      ;xChar1 = Trim(txtRes(2706).Text)
      xChar1 = GetDlgItemText(xTimerEditingHWnd, 2705)
      If TimerEditor_xEventCount = 0
        CalaymMessageBox(xTimerEditingHWnd, LoadResString(2743), LoadResString(2740), #MB_ICONINFORMATION)
        ElseIf FindString(xChar1, ":")
        CalaymMessageBox(xTimerEditingHWnd, LoadResString(2741), LoadResString(2740), #MB_ICONINFORMATION)
        Else
        ;If chkres(2710).Value = 1
          ;xLong1 = (Timer \ 60 + xLong1) % 1440
          ;endif
        xLong2 = GetLocalTimeHM()
        If (xLong1 = xLong2 Or (xLong1 + 1) % 1440 = xLong2 Or (xLong1 + 1439) % 1440 = xLong2 Or (xLong1 + 1438) % 1440 = xLong2)
          CalaymMessageBox(xTimerEditingHWnd, LoadResString(2742), LoadResString(2740), #MB_ICONINFORMATION)
          Else
          For xLong2 = 0 To xTimerEvCount - 1
            If xTimerEvTime(xLong2) = xLong1 And Not xLong2 = xTimerEvMode
              CalaymMessageBox(xTimerEditingHWnd, LoadResString(2744), LoadResString(2740), #MB_ICONINFORMATION)
              ProcedureReturn
              EndIf
            Next
          For xLong2 = 0 To TimerEditor_xEventCount - 1
            If xLong2 = 0
              xChar1 = xChar1 + "=" + Str(TimerEditor_xEventID(xLong2))
              Else
              xChar1 = xChar1 + #TimerSepp + Str(TimerEditor_xEventID(xLong2))
              EndIf
            If TimerHasSubFile(TimerEditor_xEventID(xLong2))
              xChar1 = xChar1 + "," + TimerEditor_xEventFile(xLong2)
              EndIf
            Next
          CompilerIf #TimeTestDebug And #UseFileLogging
            MainForm_ctConsoleA_AddLog("TimeDebug: New/Changed timer: " + Str(xLong1))
            CompilerEndIf
          xLong1 = xTimerChange(xTimerEvMode, xLong1, xChar1, #False)
          If xTimerEvMode = xTimerEvIR And Not xTimerEvIR = -1
            xTimerEvIR = xLong1
            EndIf
          CompilerIf #TimeTestDebug And #UseFileLogging
            ;xTimerDisplayLastParamValue = ""
            ;MainForm_ctConsoleA_AddLog("TimeDebug: Listitem: (#" + Str(xLong1) + ") " + MainForm_xTimerDisplay(xLong1))
            CompilerEndIf
          xTimerDisplayLastParamValue = ""
          xChar1 = MainForm_xTimerDisplay(xLong1, 1, #False)
          SendMessage_(Interface_Control(#Interface_Control_Timer_List), #LB_INSERTSTRING, xLong1, @xChar1)
          SetListIndexMS(Interface_Control(#Interface_Control_Timer_List), xLong1)
          TimerListForm_ListUpdate()
          TimerEdit_SetDragDrop(#False)
          EndDialog_(xTimerEditingHWnd, 0)
          ;Unload Me
          EndIf
        EndIf
    Case 2791
      TimerEdit_SetDragDrop(#False)
      EndDialog_(xTimerEditingHWnd, 0)
    EndSelect
  EndProcedure

Procedure TrySpecialKey()
  Define.i xLong1

  If GetSelected(1, @xLong1)
    If TimerHasSubFile(TimerEditor_xEventID(xLong1))
      UpdateByMenu(xLong1, 5)
      EndIf
    EndIf
  EndProcedure

Procedure WantsQuit()
  If TimerEditor_xEventCount = 0
    SendMessage_(xTimerEditingHWnd, $471, 5, 0)
    EndIf
  EndProcedure

Procedure TimerEditor_DropFiles(hDrop.i) ;, message.i, wParam.i, lParam.i).i
  Define.s xChar1

  If Not TimerEditor_xEventCount = #xTimerEvMaxSubEvents
    If DragQueryFileCount(hDrop) = 1
      xChar1 = DragQueryFile(hDrop, 0)
      If Len(xChar1)
        TimerEditor_xEventFile(TimerEditor_xEventCount) = xChar1
        Select AllowedItem(TimerEditor_xEventFile(TimerEditor_xEventCount), #True)
          Case 255 ;playlist
            TimerEditor_xEventID(TimerEditor_xEventCount) = #KbdC_FLoadPL
          Case 254 ;timer
            TimerEditor_xEventID(TimerEditor_xEventCount) = #KbdC_OTimerImport
          Case 253 ;settings/preset
            TimerEditor_xEventID(TimerEditor_xEventCount) = #KbdC_OPresetLoad
          Case 0 ;dir
            TimerEditor_xEventID(TimerEditor_xEventCount) = #KbdC_FAddDir
          Case 1 ; supp-file
            TimerEditor_xEventID(TimerEditor_xEventCount) = #KbdC_FAddFileS
          Default
            TimerEditor_xEventID(TimerEditor_xEventCount) = -1
          EndSelect
        If Not TimerEditor_xEventID(TimerEditor_xEventCount) = -1
          xChar1 = LoadResString(3700 + TimerEditor_xEventID(TimerEditor_xEventCount)) + #TAB$ + TimerEditor_xEventFile(TimerEditor_xEventCount)
          SendMessage_(TimerEdit_HWndList(1), $180, 0, @xChar1)
          SetDlgItemText_(xTimerEditingHWnd, 2760, @TimerEditor_xEventFile(TimerEditor_xEventCount))
          LoadResEx_Dialog_ListIndexMS(xTimerEditingHWnd, 2750, TimerEditor_xEventCount)
          TimerEditor_xEventCount = TimerEditor_xEventCount + 1

          UpdateWidths()

          If TimerEditor_xEventCount = #xTimerEvMaxSubEvents
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2740, #False)
            TimerEdit_SetDragDrop(#False)
            ElseIf TimerEditor_xEventCount = 1
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2741, #True)
            ElseIf TimerEditor_xEventCount = 2
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2742, #True)
            LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2743, #True)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  DragFinish_(hDrop)
  EndProcedure

Procedure EditListItem1(lParam.i)
  TrackListBox(xStaticIconsHWnd(#xStaticIcons_ShowIR), TimerEdit_HWndList(1), HiWordS(lParam), #False, 0, 0)
  If GetSelected(1, @lParam)
    If TimerHasSubFile(TimerEditor_xEventID(lParam))
      UpdateByMenu(lParam, 4)
      EndIf
    EndIf
  EndProcedure

Procedure.i TimerEditKBDProc(hWnd.i, Message.i, wParam.i, lParam.i)
  ;Debug.Print Message
  Select Message
    Case $100
      Select wParam
        Case 46
          TimerEdit_RaiseButton(2741)
        Case 93
          If (lParam & $40000000) = 0
            TrySpecialKey()
            EndIf
        Case 9
          LoadResEx_Dialog_ManualTab(xTimerEditingHWnd, hWnd)
          ProcedureReturn 0
        Case 27
          WantsQuit()
        EndSelect
    Case $87
      ProcedureReturn 4
    Case $203 ;WM_LBUTTONDBLCLK
      lParam = CallWindowProc_(TimerEditKBDProcOld, hWnd, Message, wParam, lParam)
      TimerEdit_RaiseButton(2741)
      ProcedureReturn lParam
    Case $233
      TimerEditor_DropFiles(wParam)
    Case $205 ;Mouseup
      EditListItem1(lParam)
    EndSelect
  ProcedureReturn CallWindowProc_(TimerEditKBDProcOld, hWnd, Message, wParam, lParam)
  EndProcedure

Procedure.i TimerEditKBDProcLite(hWnd.i, Message.i, wParam.i, lParam.i)
  Select Message
    Case $100
      Select wParam
        Case 13
          AddNow(0)
        ;Case 93
          ;If (lParam & $40000000) = 0
          ;  EndIf
        Case 9
          LoadResEx_Dialog_ManualTab(xTimerEditingHWnd, hWnd)
          ProcedureReturn 0
        Case 27
          WantsQuit()
        EndSelect
    Case $87
      ProcedureReturn 4
    Case $203 ;WM_LBUTTONDBLCLK
      lParam = CallWindowProc_(TimerEditKBDProcOldLite, hWnd, Message, wParam, lParam)
      AddNow(3)
      ProcedureReturn lParam
    Case $205 ;mouseup
      TrackListBox(xStaticIconsHWnd(#xStaticIcons_ShowIR), TimerEdit_HWndList(0), HiWordS(lParam), #False, 0, 0)
    EndSelect
  ProcedureReturn CallWindowProc_(TimerEditKBDProcOldLite, hWnd, Message, wParam, lParam)
  EndProcedure

Procedure.i TimerEditTxtProc(hWnd.i, Message.i, wParam.i, lParam.i)
  Select Message
    Case $100 To $102
      If wParam = 61
        wParam = 58 ;59
        EndIf
    EndSelect
  ProcedureReturn CallWindowProc_(TimerEditTxtProcOld, hWnd, Message, wParam, lParam)
  EndProcedure


Procedure AddKeyEx(*xLong2, *xLong3, xChar1.s)
  Define.i xLong1
  Define.i xLong3

  xLong1 = GetTextOutWidth(xSharedDC, xChar1)
  xLong3 = PeekI(*xLong3)
  If xLong1 > xLong3
    PokeI(*xLong3, xLong1)
    EndIf
  SendMessage_(TimerEdit_HWndList(0), $180, 0, @xChar1)
  PokeI(*xLong2, PeekI(*xLong2) + 1)
  EndProcedure

Procedure AddKey(*xLong2, *xLong3)
  AddKeyEx(*xLong2, *xLong3, "    " + LoadResString(3700 + xEvAlias(PeekI(*xLong2))))
  EndProcedure

Procedure AddKeyInt2(*xLong2, *xLong3)
  AddKeyEx(*xLong2, *xLong3, "        " + LoadResString(3700 + xEvAlias(PeekI(*xLong2))))
  EndProcedure

Procedure TimerEdit_Initialize()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  ;Dim xLong5.i
  Define.s xChar1
  ;Dim xType1 As POINTAPI
  
  ;If IsMinWindows7
    ;ChangeWindowMessageFilterEx(xTimerEditingHWnd, $233, 1, 0)
    ;ChangeWindowMessageFilterEx(xTimerEditingHWnd, $49, 1, 0)
    ;EndIf
  
  LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2741, #False)
  LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2742, #False)
  LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2743, #False)
  LoadResEx_Dialog_Enable(xTimerEditingHWnd, 2761, #False)
 
  
  For xLong1 = 0 To 2
    xTimerPLMenu(xLong1) = LoadResEx_Menu(2700 + xLong1 * 10)
    TimerEdit_xPopupMenu(xLong1) = MakePopupMenu(xTimerPLMenu(xLong1))
    xTimerPLMenuLoaded(xLong1) = 0
    EnableMenuItem_(xTimerPLMenu(xLong1), 2750 + xLong1 * 10, 3)
    Next
  
  If xSecureMode
    EnableMenuItem_(xTimerPLMenu(0), 2700, 3)
    EnableMenuItem_(xTimerPLMenu(1), 2710, 3)
    EnableMenuItem_(xTimerPLMenu(2), 2720, 3)
    EndIf
  
  MainForm_XMenuRefresherFileDir()
  
  
  TimerEdit_HWndList(0) = GetDlgItem_(xTimerEditingHWnd, 2730)
  TimerEdit_HWndList(1) = GetDlgItem_(xTimerEditingHWnd, 2750)

  xLong1 = GetDlgItem_(xTimerEditingHWnd, 2701)
  If xLong1
    TimerEditWarnIcon = LoadResEx_ImageIconWEMFToHWnd_MultiOS(xLong1, 2700)
    ;Debug TimerEditWarnIcon
    ;TimerEditWarnIcon = LoadResEx_Image_MultiOS(2700, 1)
    ;If TimerEditWarnIcon
      ;SendMessage_(xLong1, #STM_SETICON, TimerEditWarnIcon, 0)
      ;EndIf
    EndIf


  If Not TimerEdit_HWndList(0) = 0
    ;SelectObject_(xSharedDC, hFontGSys)
    For xLong1 = 0 To #KbdSplitP
        Select xLong1
          Case #KbdC_FAddPList, #KbdC_FSavePLas
          Case #KbdC_CRepToggle, #KbdC_CCSSelFile, #KbdC_CCSRemFile, #KbdC_CCSDelFile, #KbdC_CCSExplorer
          Case #KbdC_PPlayNext, #KbdC_PFind, #KbdC_PFindNext, #KbdC_PFindQuick
          Case #KbdC_PInvSel, #KbdC_PRemSongs, #KbdC_PRem, #KbdC_PCopyPLEnd, #KbdC_PCrop, #KbdC_PDelFiles, #KbdC_PExplorer
          Case #KbdC_OInternetRadioHP, #KbdC_OAutoRFSetup, #KbdC_OTimerEdit, #KbdC_OTimerExport, #KbdC_OSoundFontMenu
          Case #KbdC_OEndModeTggle, #KbdC_CMoreSetts, #KbdC_PGotoDir, #KbdC_ODirCombo, #KbdC_ODirTop, #KbdC_ODirLeft, #KbdC_ODirAuto, #KbdC_ODirToggle, #KbdC_ODirInc, #KbdC_ODirDec, #KbdC_OVolCtrl, #KbdC_OPresetSave, #KbdC_CPrevSongs, #KbdC_OEndMenu
          Case #KbdC_IHelp, #KbdC_IAbout
          Case #KbdC_FFileMenu, #KbdC_CPCMenu, #KbdC_PPLMenu, #KbdC_OOptionsMenu, #KbdC_TToolsMenu
            AddKeyEx(@xLong2, @xLong3, LoadResString(3700 + xLong1))

          Case #KbdC_CVolMenu
            AddKeyEx(@xLong2, @xLong3, "    " + LoadResString(3700 + xLong1))

          Case #KbdC_CVolUp, #KbdC_CVolDown, #KbdC_CVolMute, #KbdC_CVol1, #KbdC_CVol2, #KbdC_CVol3, #KbdC_CVol4, #KbdC_CVol5, #KbdC_CVol6, #KbdC_CVol7, #KbdC_CVol8, #KbdC_CVol9, #KbdC_CVolFull
            xEvAlias(xLong2) = xLong1
            AddKeyInt2(@xLong2, @xLong3)


          Case #KbdC_FQuitSD
            xEvAlias(xLong2) = #KbdC_FQuitSD
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_FShutDown
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_FHibernate
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_FStandby
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_FMonitoff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_CPlay
            xEvAlias(xLong2) = #KbdCTm_CPlay
            AddKey(@xLong2, @xLong3)
          Case #KbdC_CPause
            xEvAlias(xLong2) = #KbdCTm_CPause
            AddKey(@xLong2, @xLong3)
          Case #KbdC_CStop
            xEvAlias(xLong2) = #KbdCTm_CStop
            AddKey(@xLong2, @xLong3)
          Case #KbdC_PFindCurrent
            xEvAlias(xLong2) = #KbdCTm_PFindCurrent
            AddKey(@xLong2, @xLong3)
          
          
          Case #KbdC_CIntroMode
            xEvAlias(xLong2) = #KbdCTm_CIntroModeOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_CIntroModeOff
            AddKey(@xLong2, @xLong3)
          
          Case #KbdC_OFading
            xEvAlias(xLong2) = #KbdCTm_OFadingOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_OFadingOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OSpektrum
            xEvAlias(xLong2) = #KbdCTm_OSpektrumOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_OSpektrumOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OFileInfos
            xEvAlias(xLong2) = #KbdCTm_OFileInfosOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_OFileInfosOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OFollowSong
            xEvAlias(xLong2) = #KbdCTm_OFollowSongOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_OFollowSongOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_ORemMissing
            xEvAlias(xLong2) = #KbdCTm_ORemMissingOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_ORemMissingOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_ORemSkipped
            xEvAlias(xLong2) = #KbdCTm_ORemSkippedOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_ORemSkippedOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_ORemPlayed
            xEvAlias(xLong2) = #KbdCTm_ORemPlayedOn
            AddKey(@xLong2, @xLong3)
            xEvAlias(xLong2) = #KbdCTm_ORemPlayedOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_ONoEndMode
            xEvAlias(xLong2) = #KbdCTm_ONoEndMode
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OXFade
            xEvAlias(xLong2) = #KbdCTm_OXFadeOn
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OMDMode
            xEvAlias(xLong2) = #KbdCTm_OMDModeOff
            AddKey(@xLong2, @xLong3)
          Case #KbdC_OStopEach
            xEvAlias(xLong2) = #KbdCTm_OStopEachOn
            AddKey(@xLong2, @xLong3)
          ;Case #KbdC_OEndModeTggle
          ;  xEvAlias(xLong2) = #KbdCTm_OEndModeOff
          ;  AddKey(@xLong2, @xLong3)
          Case #KbdC_OInternetRadio ; needs special handling... soon...
          ;Case #KbdC_OInternetRadioRe ;...
          ;Case #KbdC_OInternetRadioHP
            ;OpenIRUrl
          Default
            If ValidSetupKey(xLong1)
              xEvAlias(xLong2) = xLong1
              AddKey(@xLong2, @xLong3)
              EndIf
          EndSelect
      Next
    
    If Not xLong3 = 0
      xLong1 = GetDlgItem_(xTimerEditingHWnd, 2730)
      If Not xLong1 = 0
        SendMessage_(xLong1, #LB_SETHORIZONTALEXTENT, xLong3 + 4, 0)
        EndIf
      EndIf
    TimerEditKBDProcOldLite = SetWindowLong_(TimerEdit_HWndList(0), -4, @TimerEditKBDProcLite())
    EndIf
  If Not TimerEdit_HWndList(1) = 0
    If IsMinWindows7
      ChangeWindowMessageFilterEx(TimerEdit_HWndList(1), $233, 1, 0)
      ChangeWindowMessageFilterEx(TimerEdit_HWndList(1), $49, 1, 0)
      EndIf

    TimerEditKBDProcOld = SetWindowLong_(TimerEdit_HWndList(1), -4, @TimerEditKBDProc())
    EndIf

  xLong1 = GetDlgItem_(xTimerEditingHWnd, 2705)
  If Not xLong1 = 0
    TimerEditTxtProcOld = SetWindowLong_(xLong1, -4, @TimerEditTxtProc())
    EndIf



  If xTimerEvMode = -1
    xLong1 = -1
    LoadResEx_Dialog_TimeLongA(xTimerEditingHWnd, 2700, @xLong1)
    Else
    LoadResEx_Dialog_TimeLongA(xTimerEditingHWnd, 2700, @xTimerEvTime(xTimerEvMode))
    WriteSettings(xTimerEv(xTimerEvMode))
    EndIf
  TimerEdit_SetDragDrop(#True)
  EndProcedure

Procedure.i TimerEditProc(hWnd.i, Message.i, wParam.i, lParam.i)
  Select Message
    Case $111
       TimerEdit_RaiseButton(wParam)
    Case $233
      TimerEditor_DropFiles(wParam)
    Case $10
      TimerEdit_SetDragDrop(#False)
      EndDialog_(hWnd, 1)
    Case $110
      xTimerEditingHWnd = hWnd
      TimerEdit_Initialize()
      ProcedureReturn 1
    EndSelect
  ProcedureReturn 0
  EndProcedure

Procedure ShowTimerEditor()
  Define.i xLong1
  ;Dim xChar1 As String
  
  xTimerEditing = #True
  ;xChar1 = LoadResEx_Data("#2700", "#5", #True)
  ;If Not Len(xChar1) = 0
    DialogTimer(#True)
    
    ;xLong1 = DialogBoxIndirectParam(2700, MainHWnd, AddressOf TimerEditProc, 0)
    DialogBoxParam_(hInstance, 2700, MainHWnd, @TimerEditProc(), 0)

    xTimerEditingHWnd = 0
    For xLong1 = 0 To 2
      If xTimerPLMenu(xLong1)
        DestroyMenu_(xTimerPLMenu(xLong1))
        If TimerEdit_xPopupMenu(xLong1)
          DestroyMenu_(TimerEdit_xPopupMenu(xLong1))
          EndIf
        xTimerPLMenu(xLong1) = 0
        EndIf
      Next
    For xLong1 = 0 To #xTimerEvMaxSubEventsX
      TimerEditor_xEventID(xLong1) = 0
      TimerEditor_xEventFile(xLong1) = ""
      Next
    TimerEditor_xEventCount = 0
    TimerEditOldDropMode = 0

    If TimerEditWarnIcon
      DeleteObject_(TimerEditWarnIcon)
      TimerEditWarnIcon = 0
      EndIf

    DialogTimer(#False)
;    EndIf
  xTimerEditing = #False
  EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = ------
; EnableXP
; AddResource = res\exe64.rc