EnableExplicit

CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
  Procedure.i BitmapFromEMFDataEx_ColorFix(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, *lpProc)
    Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
    Define.i xEMRL_ECP.EMREXTCREATEPEN
  
    If *lpEMFR
      Select *lpEMFR\iType
        ;Case #EMR_CREATEPEN
          ;Debug "CreatePen"
        Case #EMR_CREATEBRUSHINDIRECT
          MemCopyRTL(@xEMRL_CBI, *lpEMFR, SizeOf(EMRCREATEBRUSHINDIRECT))
          xEMRL_CBI\lb\lbColor = CallFunctionFast(*lpProc, #EMR_CREATEBRUSHINDIRECT, #BS_SOLID, xEMRL_CBI\lb\lbColor)
          PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_CBI, nObj)
        Case #EMR_EXTCREATEPEN
          MemCopyRTL(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
          xEMRL_ECP\elp\elpColor = CallFunctionFast(*lpProc, #EMR_EXTCREATEPEN, 0, xEMRL_ECP\elp\elpColor)
          PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
        Default
          PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
        EndSelect
      EndIf
    ProcedureReturn #True
    EndProcedure
  CompilerElse
  Procedure.i BitmapFromWMFDataEx_ColorFix(hDC.i, *lpHTable, *lpWMFR.METARECORD, nObj.i, *lpProc)
    Structure METACBI
      MR.METARECORD
      StructureUnion
        BrushHatch.w
        ColorRef.l
        EndStructureUnion
      BrushStyle.w
      EndStructure
    ;Structure METACPI
      ;MR.METARECORD
      ;ColorRef.l ; R G B Reserved
      ;WidthYIgnored.w
      ;WidthXWidth.w
      ;PenStyle.w
      ;EndStructure
    Structure METACPI
      MR.METARECORD
      PenStyle.w
      ;WidthYIgnored.w ;;; This works in Win7, against documentation; btw the records is set to 8+8 bytes!?!
      WidthXWidth.w
      ColorRef.l ; R G B Reserved
      EndStructure
      
    Define.i xWMRL_CBI.METACBI
    Define.i xWMRL_CPI.METACPI
    Define.i xSize
  
  
    If *lpWMFR
      Select *lpWMFR\rdFunction
        Case #META_CREATEBRUSHINDIRECT
;Debug "Brush:"
          xSize = *lpWMFR\rdSize << 1
          If xSize <= SizeOf(METACBI)
            MemCopyRTL(@xWMRL_CBI, *lpWMFR, xSize)
            If xWMRL_CBI\BrushStyle = #BS_SOLID ; also BS_HATCHED?
;Debug xWMRL_CBI\ColorRef
              xWMRL_CBI\ColorRef = CallFunctionFast(*lpProc, #EMR_CREATEBRUSHINDIRECT, #BS_SOLID, xWMRL_CBI\ColorRef)
              PlayMetaFileRecord_(hDC, *lpHTable, @xWMRL_CBI, nObj)
              Else
              PlayMetaFileRecord_(hDC, *lpHTable, *lpWMFR, nObj)
              EndIf
            Else
            PlayMetaFileRecord_(hDC, *lpHTable, *lpWMFR, nObj)
            EndIf
        Case #META_CREATEPENINDIRECT
;Debug "PenIndirect:"
          xSize = *lpWMFR\rdSize << 1
          If xSize <= SizeOf(METACPI)
            MemCopyRTL(@xWMRL_CPI, *lpWMFR, xSize)
;Debug xSize
;Debug xWMRL_CPI\PenStyle
;Debug xWMRL_CPI\WidthXWidth
;Debug xWMRL_CPI\WidthYIgnored
;Debug xWMRL_CPI\ColorRef
            xWMRL_CPI\ColorRef = CallFunctionFast(*lpProc, #EMR_EXTCREATEPEN, 0, xWMRL_CPI\ColorRef)
            PlayMetaFileRecord_(hDC, *lpHTable, @xWMRL_CPI, nObj)
            Else
            PlayMetaFileRecord_(hDC, *lpHTable, *lpWMFR, nObj)
            EndIf
        Default
          PlayMetaFileRecord_(hDC, *lpHTable, *lpWMFR, nObj)
        EndSelect
      EndIf
  
    ProcedureReturn #True
    EndProcedure
  CompilerEndIf

Macro BitmapFromWEMFEx_QualityShift(Value)
  (Value << 2)
  ;(Value * 3)
  EndMacro

Procedure.i BitmapFromWEMFEx(hDC1.i, hMeta.i, Left.i, Top.i, Width.i, Height.i, BgColor.i, *ColorFixer)
  Define.i xResult
  Define.i hDC2
  Define.i hBmp
  Define.i hBmpOld
  Define.RECT xType1

  If hDC1 And hMeta
    hDC2 = GetDC_(0)
    If hDC2
      hBmp = CreateCompatibleBitmap_(hDC2, BitmapFromWEMFEx_QualityShift(Width), BitmapFromWEMFEx_QualityShift(Height))
      ;hBmp = CreateBitmap_(BitmapFromWEMFEx_QualityShift(Width), BitmapFromWEMFEx_QualityShift(Height), 1, 32, 0)
      ReleaseDC_(0, hDC2)
      If hBmp
        hDC2 = CreateCompatibleDC_(0)
        If hDC2
          hBmpOld = SelectObject_(hDC2, hBmp)
          If hBmpOld
            xType1\right = BitmapFromWEMFEx_QualityShift(Width)
            xType1\bottom = BitmapFromWEMFEx_QualityShift(Height)
            BgColor = CreateSolidBrush_(BgColor)
            If BgColor
              FillRect_(hDC2, @xType1, BgColor)
              DeleteObject_(BgColor)
              EndIf
            CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
              If *ColorFixer
                xResult = EnumEnhMetaFile_(hDC2, hMeta, @BitmapFromEMFDataEx_ColorFix(), *ColorFixer, @xType1)
                Else
                xResult = PlayEnhMetaFile_(hDC2, hMeta, @xType1)
                EndIf
              CompilerElse
              SetMapMode_(hDC2, #MM_ANISOTROPIC)
              SetViewportOrgEx_(hDC2, 0, 0, 0)
              SetViewportExtEx_(hDC2, BitmapFromWEMFEx_QualityShift(Width), BitmapFromWEMFEx_QualityShift(Height), 0)
              If *ColorFixer
                xResult = EnumMetaFile_(hDC2, hMeta, @BitmapFromWMFDataEx_ColorFix(), *ColorFixer)
                Else
                xResult = PlayMetaFile_(hDC2, hMeta)
                EndIf
              SetMapMode_(hDC2, #MM_TEXT)
              CompilerEndIf
            If xResult
              SetStretchBltMode_(hDC1, #HALFTONE)
              If StretchBlt_(hDC1, Left, Top, Width, Height, hDC2, 0, 0, BitmapFromWEMFEx_QualityShift(Width), BitmapFromWEMFEx_QualityShift(Height), #SRCCOPY)
                xResult = #True
                EndIf
              SetStretchBltMode_(hDC1, 3)
              EndIf
            SelectObject_(hDC2, hBmpOld)
            EndIf
          DeleteDC_(hDC2)
          EndIf
        DeleteObject_(hBmp)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 130
; FirstLine = 101
; Folding = --
; EnableUnicode
; EnableThread
; EnableXP