EnableExplicit

Structure EnumVolumes_DataType
  Initial.i
  ApiResult.i
  HasData.i
  FVNext.i
  FVClose.i
  Buffer.b[4098]
  EndStructure

Procedure.i EnumVolumes_Start()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define *xResult.EnumVolumes_DataType

  xLong1 = GetModuleHandle_("kernel32.dll")
  If xLong1
    xLong2 = GetProcAddress(xLong1, "FindFirstVolumeW")
    If xLong2
      *xResult = AllocateMemory(SizeOf(EnumVolumes_DataType))
      If *xResult
        *xResult\ApiResult = CallFunctionFast(xLong2, @*xResult\Buffer, 2048)
        *xResult\HasData = #True
        If *xResult\ApiResult = #INVALID_HANDLE_VALUE
          FreeMemory(*xResult)
          *xResult = 0
          Else
          *xResult\FVNext = GetProcAddress(xLong1, "FindNextVolumeW")
          *xResult\FVClose = GetProcAddress(xLong1, "FindVolumeClose")
          *xResult\Initial = #True
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn *xResult
  EndProcedure

Procedure.i EnumVolumes_NextVolume(*hFindVols.EnumVolumes_DataType)
  If *hFindVols
    If *hFindVols\Initial
      *hFindVols\Initial = #False
      Else
      *hFindVols\HasData = CallFunctionFast(*hFindVols\FVNext, *hFindVols\ApiResult, @*hFindVols\Buffer, 2048)
      EndIf
    If *hFindVols\HasData
      ProcedureReturn #True
      EndIf
    EndIf
  EndProcedure

Procedure.s EnumVolumes_GetVolumeString(*hFindVols.EnumVolumes_DataType)
  Define.i xLong1
  Define.s xResult

  If *hFindVols
    If *hFindVols\HasData
      xResult = PeekS(@*hFindVols\Buffer, -1, #PB_Unicode)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure EnumVolumes_Close(*hFindVols.EnumVolumes_DataType)
  If *hFindVols
    CallFunctionFast(*hFindVols\FVClose, *hFindVols\ApiResult)
    FreeMemory(*hFindVols)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 44
; FirstLine = 36
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnablePurifier