EnableExplicit

LibBuild_Include(HyperlinkList_GetURLPointerFromItem)
LibBuild_Include(HyperLinkList_AddItem)

Structure HyperLinkList_InfoDialog_Data
  ;hIcon.i
  InitCallback.i
  DestCallback.i
  HListID.i
  ;FocusID.i
  CallURL.i
  EndStructure

Procedure.i HyperLinkList_InfoDialog_Init(HWndDialog.i, *lParam.HyperLinkList_InfoDialog_Data)
  Define.i xLong1

  If *lParam
    xLong1 = GetDlgItem_(HWndDialog, *lParam\HListID)
    If xLong1
      SetWindowLong_(xLong1, -21, SetWindowLong_(xLong1, -4, @HyperlinkList_Proc()))
      CallFunctionFast(*lParam\InitCallback, HWndDialog, xLong1)
      EndIf
    SetWindowLong_(HWndDialog, -21, *lParam)
    EndIf
  ProcedureReturn 0
  EndProcedure

Procedure.i HyperLinkList_InfoDialog_GetListDlgID(HWndDialog.i)
  Define.i xResult
  Define *xType1.HyperLinkList_InfoDialog_Data
  
  *xType1 = GetWindowLong_(HWndDialog, -21)
  If *xType1
    xResult = *xType1\HListID
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure HyperLinkList_InfoDialog_OpenURL(HWndDialog.i, hWnd.i)
  Define.i xLong1
  Define *xType1.HyperLinkList_InfoDialog_Data

  If hWnd
    *xType1 = GetWindowLong_(HWndDialog, -21)
    If *xType1
      If *xType1\CallURL
        xLong1 = SendMessage_(hWnd, #LB_GETCARETINDEX, 0, 0)
        If xLong1 >= 0
          xLong1 = HyperlinkList_GetURLPointerFromItem(hWnd, xLong1)
          If xLong1
            CallFunctionFast(*xType1\CallURL, HWndDialog, xLong1)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure HyperLinkList_InfoDialog_Destroy(HWndDialog.i)
  Define.i xLong1
  Define.i xLong2
  Define *xType1.HyperLinkList_InfoDialog_Data
  
  *xType1 = GetWindowLong_(HWndDialog, -21)
  If *xType1
    xLong1 = GetDlgItem_(HWndDialog, *xType1\HListID)
    If xLong1
      xLong2 = GetWindowLong_(xLong1, -21)
      If xLong2
        SetWindowLong_(xLong1, -4, xLong2)
        EndIf
      If *xType1\DestCallback
        CallFunctionFast(*xType1\DestCallback, HWndDialog, xLong1)
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure.i HyperLinkList_InfoDialog_Proc(HWndDialog.i, Msg.i, wParam.i, lParam.i)
  Select Msg
    Case $2B ; WM_DRAWITEM
      ProcedureReturn HyperlinkList_WM_DRAWITEM(lParam)
    Case $110 ;WM_INITDIALOG
      ProcedureReturn HyperLinkList_InfoDialog_Init(HWndDialog, lParam)
    Case $111 ;WM_COMMAND
      If lParam = 0
        If wParam = 2
          EndDialog_(HWndDialog, 0)
          EndIf
        ElseIf (GetWindowLong_(lParam, -16) & $E) = 0
        If (wParam & $FFFF) = HyperLinkList_InfoDialog_GetListDlgID(HWndDialog)
          If (wParam & $FFFF0000) = $20000
            HyperLinkList_InfoDialog_OpenURL(HWndDialog, lParam)
            EndIf
          Else
          EndDialog_(HWndDialog, 0)
          EndIf
        EndIf
    Case $10 ;WM_CLOSE
      EndDialog_(HWndDialog, 0)
    Case $2 ;WM_DESTROY
      HyperLinkList_InfoDialog_Destroy(HWndDialog)
    Case $2C ; WM_MEASUREITEM
      ProcedureReturn HyperlinkList_WM_MEASUREITEM(lParam)
    Case $2D ; WM_DELETEITEM
      ProcedureReturn HyperlinkList_WM_DELETEITEM(lParam)
    EndSelect
  ;HyperLinkList_InfoDialog_Proc = HookedWindowProc(hwnd, Msg, wParam, lParam)
  ProcedureReturn 0
  EndProcedure

Procedure HyperLinkList_InfoDialog(*ResID, InitCallback.i, DestroyCallback.i = 0, hWndParent.i = 0, URLHandler.i = 0, ListID.i = 5, FocusID.i = 9)
  Define.i xLong1
  Define.HyperLinkList_InfoDialog_Data xType1

  If InitCallback 
    With xType1
      \InitCallback = InitCallback
      \DestCallback = DestroyCallback
      \HListID = ListID
      ;\FocusID = FocusID
      \CallURL = URLHandler
      EndWith
    DialogBoxParam_(hInstance, *ResID, hWndParent, @HyperLinkList_InfoDialog_Proc(), @xType1)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3
; Folding = --
; EnableUnicode
; EnableXP
; DisableDebugger