EnableExplicit

LibBuild_Include(HyperlinkList)
LibBuild_Include(MemAlloc_FromString)
LibBuild_Include(WordWrapText)
LibBuild_Include(DrawTextGetHeight)
LibBuild_Include(DrawTextGetWidth)

Procedure HyperlinkList_AddItemReal(hWnd.i, xText.s, xHeight.i, *LnkRect.RECT, *Padding.RECT, LnkURL.s, LnkCaption.s, hIcon.i, IconSizeX.i, IconSizeY.i, IconDescardable.i, FormatingOptions.i)
  Define.i xLong1
  Define *xType1.HyperlinkListItemStruct 
  *xType1 = MemAlloc(SizeOf(HyperlinkListItemStruct))
  If *xType1
    With *xType1
      \LenText = Len(xText)
      If \LenText
        \xText = MemAlloc_FromString(xText, \LenText)
        EndIf
      \LnkCapLen = Len(LnkCaption)
      If \LnkCapLen
        \LnkCaption = MemAlloc_FromString(LnkCaption, \LnkCapLen)
        xLong1 = Len(LnkURL)
        If xLong1
          \LnkURL = MemAlloc_FromString(LnkURL, xLong1)
          Else
          \LnkURL = \LnkCaption
          EndIf
        MemCopyRTL(@\LnkRect, *LnkRect, SizeOf(RECT))
        Else
        \LnkCapLen = Len(LnkURL)
        If \LnkCapLen
          \LnkCaption = MemAlloc_FromString(LnkURL, \LnkCapLen)
          \LnkURL = \LnkCaption
          MemCopyRTL(@\LnkRect, *LnkRect, SizeOf(RECT))
          EndIf
        EndIf
      MemCopyRTL(@\Padding, *Padding, SizeOf(RECT))
      If hIcon
        If IconSizeX And IconSizeY
          \hIcon = hIcon
          If IconSizeY > xHeight
            If FormatingOptions & 1
              xLong1 = (IconSizeY - xHeight + 1) >> 1
              If xLong1
                \IconTOff = -xLong1
                \Padding\Top + xLong1
                EndIf
              EndIf
            xHeight = IconSizeY
            ElseIf FormatingOptions & 1
            \IconTOff = (xHeight - IconSizeY) >> 1
            EndIf
          \IconIdent = *Padding\Left
          \IconSizeX = IconSizeX
          \IconSizeY = IconSizeY
          \IconDescardable = IconDescardable
          ElseIf hIcon And IconDescardable
          DestroyIcon_(hIcon)
          hIcon = 0
          EndIf
        \Padding\Left = *Padding\Left + #HyperlinkList_PaddingIcon + IconSizeX
        EndIf
      \xHeight = xHeight + \Padding\Top + *Padding\Bottom
      EndWith
    If SendMessage_(hWnd, $180, 0, *xType1) < 0
ShowCallstack()
CallDebugger
      If hIcon And IconDescardable
        DestroyIcon_(hIcon)
        EndIf
      If *xType1\xText
        MemFree(*xType1\xText)
        EndIf
      If *xType1\LnkCaption
        MemFree(*xType1\LnkCaption)
        EndIf
      If *xType1\LnkURL
        If Not *xType1\LnkURL = *xType1\LnkCaption
          MemFree(*xType1\LnkURL)
          EndIf
        EndIf
      MemFree(*xType1)
      EndIf
    EndIf
  EndProcedure

Procedure HyperlinkList_AddItem(hWnd.i, xText.s, *Padding.RECT, *hIcon = 0, IconSizeX.i = 0, IconSizeY.i = 0, IconDescardable.i = #False, FormatingOptions.i = #False)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xLong5
  Define.i hdc
  Define.i hFont
  Define.i hFontOld
  Define.i hIconInt
  Define.RECT xType1
  Define.RECT xType2
  Define.s xChar1
  Define.s xChar2
  Define.i xBoolLoop1

  GetClientRect_(hWnd, xType1)
  If (GetWindowLong_(hWnd, -16) & $200000) = $0
    xType1\Right = xType1\Right - GetSystemMetrics_(2)
    EndIf

  hdc = CreateCompatibleDC_(0)
  If hdc
    hFont = SendMessage_(hWnd, $31, 0, 0)
    If *hIcon
      hIconInt = PeekI(*hIcon)
      EndIf
    If Not hFont = 0
      hFontOld = SelectObject_(hdc, hFont)
      EndIf
    If hFont = 0 Or Not hFontOld = 0
      MemCopyRTL(@xType2, *Padding, SizeOf(RECT))
      If IconSizeX And IconSizeY
        xText = WordWrapText(hdc, xText, xType1\Right - xType1\Left - #HyperlinkList_PaddingIcon - *Padding\Left - *Padding\Right - IconSizeX)
        Else
        xText = WordWrapText(hdc, xText, xType1\Right - xType1\Left - *Padding\Left - *Padding\Right)
        EndIf

      xLong1 = FindString(xText, "://")
      xLong2 = FindString(xText, "@")
      If (xLong2 < xLong1 And xLong2) Or xLong1 = 0
        xLong1 = xLong2
        EndIf
      If xLong1
        xType2\Bottom = 0
        Repeat
HLLoop:
          xLong2 = FindString(xText, "://", xLong1 + 1)
          xLong5 = FindString(xText, "@", xLong1 + 1)
          If (xLong5 < xLong2 And Not xLong5 = 0) Or xLong2 = 0
            xLong2 = xLong5
            EndIf
          If Not xLong2 = 0
            xLong2 = InStrRevstring(xText, #CRLF$, xLong2)
            EndIf
          If xLong2 = 0
            xChar1 = xText
            xText = ""
            Else
            xChar1 = Left(xText, xLong2 - 1)
            xText = Mid(xText, xLong2 + 2)
            EndIf
    
    
          xLong2 = InstrRevChar(xChar1, 32, xLong1) ; " "
; <-- other begin signs ---
          xLong5 = InstrRevChar(xChar1, 40, xLong1) ; "("
          If xLong5 > xLong2
            xLong2 = xLong5
            EndIf
; --- other begin signs -->
          xLong3 = InstrRevString(xChar1, #CRLF$, xLong1)
          If Not xLong3 = 0
            xLong3 = xLong3 + 1
            EndIf
          If xLong3 > xLong2
            xLong2 = xLong3
            EndIf
          xLong4 = FindString(xChar1, " ", xLong1)
; <-- other end signs ---
          xLong5 = FindString(xChar1, ")", xLong1)
          If (xLong5 < xLong4 Or xLong4 = 0) And Not xLong5 = 0
            xLong4 = xLong5
            EndIf
; --- other end signs -->
          xLong5 = FindString(xChar1, #CRLF$, xLong1)
          If xLong5 = 0
            xLong5 = Len(xChar1) + 1
            EndIf
          If (xLong5 < xLong4 Or xLong4 = 0)
            xLong4 = xLong5
            EndIf
          
          xChar2 = Left(xChar1, xLong4 - 1)
;        Stop
          xType1\Bottom = DrawTextGetHeight(hdc, xChar2, $510)   ; total height
          xChar2 = Mid(xChar1, xLong3 + 1, xLong4 - xLong3 - 1)
          xType1\Right = DrawTextGetWidth(hdc, xChar2, $510) + 1 ; effective line total width
          xChar2 = Mid(xChar1, xLong2 + 1, xLong4 - xLong2 - 1)
            
          xType1\Top = xType1\Bottom - DrawTextGetHeight(hdc, xChar2, $510)
          xType1\Left = xType1\Right - DrawTextGetWidth(hdc, xChar2, $510) - 1
            
      
          If Len(xText) = 0
            xType2\Bottom = *Padding\Bottom
            EndIf
          HyperlinkList_AddItemReal(hWnd, xChar1, DrawTextGetHeight(hdc, xChar1, $510), xType1, xType2, xChar2, xChar2, hIconInt, IconSizeX, IconSizeY, IconDescardable, FormatingOptions)
          hIconInt = 0
          xBoolLoop1 = #False
          If Not Len(xText) = 0
            xLong1 = FindString(xText, "://")
            xLong2 = FindString(xText, "@")
            If xLong2 < xLong1 And Not xLong2 = 0
              xLong1 = xLong2
              EndIf
            xType2\Top = 0
            xBoolLoop1 = #True
            EndIf
          Until xBoolLoop1 = 0
        Else
        HyperlinkList_AddItemReal(hWnd, xText, DrawTextGetHeight(hdc, xText, $510), @xType1, @xType2, "", "", hIconInt, IconSizeX, IconSizeY, IconDescardable, FormatingOptions)
        hIconInt = 0
        EndIf
      If hFont
        SelectObject_(hdc, hFontOld)
        EndIf
      EndIf
    DeleteDC_(hdc)
    If IconDescardable
      If hIconInt
        DestroyIcon_(hIconInt)
        EndIf
      If *hIcon
        PokeI(*hIcon, 0)
        EndIf
      EndIf
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 129
; FirstLine = 113
; Folding = -
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory