EnableExplicit

CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
  LibBuild_Include(BitmapStretchCopyEx)
  CompilerEndIf

#IconFromEMF_PenFix = #False

CompilerIf #IconFromEMF_PenFix
  #ELPWith = 60
  CompilerEndIf

Procedure IconFromEMF_ColorPenFix(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, lpData.i)
  Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
  Define.i xEMRL_ECP.EMREXTCREATEPEN

  If *lpEMFR
    Select *lpEMFR\iType
      Case #EMR_CREATEBRUSHINDIRECT
        MemCopyRTL(@xEMRL_CBI, *lpEMFR, SizeOf(EMRCREATEBRUSHINDIRECT))
        xEMRL_CBI\lb\lbColor = lpData
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_CBI, nObj)
      Case #EMR_EXTCREATEPEN
        MemCopyRTL(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
        CompilerIf #IconFromEMF_PenFix
          If xEMRL_ECP\elp\elpWidth < #ELPWith
            xEMRL_ECP\elp\elpWidth = #ELPWith
            EndIf
          CompilerEndIf
        xEMRL_ECP\elp\elpColor = lpData
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
      Default
        PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
      EndSelect
    EndIf

  ProcedureReturn #True
  EndProcedure

CompilerIf #IconFromEMF_PenFix
  Procedure IconFromEMF_PenFix(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, lpData.i)
    Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
    Define.i xEMRL_ECP.EMREXTCREATEPEN
  
    If *lpEMFR
      Select *lpEMFR\iType
        Case #EMR_EXTCREATEPEN
          MemCopyRTL(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
          If xEMRL_ECP\elp\elpWidth < #ELPWith
            xEMRL_ECP\elp\elpWidth = #ELPWith
            EndIf
          PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
        Default
          PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
        EndSelect
      EndIf
  
    ProcedureReturn #True
    EndProcedure
  CompilerEndIf

Macro IconFromEMF_QualityShift(Value)
  (Value << 2)
  EndMacro

; Note that on Win7 classic taskswitcher (appears when switching FROM certain games) the simple dual-rgb icons dont work
; (note those work on win2000!)
; btw the alpha icons are more accurate regarding transparency, so it wasn't just time wasted for a workaround

Procedure.i IconFromEMF(hMeta, SizeX, SizeY)
  Define.i xResult
  Define.i hDC
  Define.i hBmpOld
  ;Define.i hEmf
  Define.i hBrush
  Define.RECT xType1
  Define.ICONINFO xType2
  Define.i hBmpCol
  Define.i hBmpMsk
  
  Define.BITMAPV5HEADER bi
  Define *xBmpCol
  Define *xBmpMsk
  Define *xBmpMix
  Define.i xX
  Define.i xY
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xRB
  Define.i xG
  Define.i xA

;IsMinWindowsXP = #False
;SizeX = 48
;SizeY = 16

  If hMeta
    hDC = GetDC_(0)
    If hDC
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      If IsMinWindowsXP
CompilerEndIf
        With bi
          \bV5Size = SizeOf(BITMAPV5HEADER);
          \bV5Width = SizeX << 1
          \bV5Height = SizeY << 1
          \bV5Planes = 1;
          \bV5BitCount = 32;
          \bV5Compression = #BI_bitfields;
          ; The following mask specification specifies a supported 32 BPP
          ; alpha format For Windows XP.
          \bV5RedMask   =  $00FF0000;
          \bV5GreenMask =  $0000FF00;
          \bV5BlueMask  =  $000000FF;
          \bV5AlphaMask =  $FF000000;
          EndWith

        hBmpCol = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpCol, 0, 0)
        hBmpMsk = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpMsk, 0, 0)
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
        Else
        hBmpCol = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
        hBmpMsk = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
        EndIf
CompilerEndIf

      ReleaseDC_(0, hDC)
      If hBmpCol
        If hBmpMsk
          hDC = CreateCompatibleDC_(0)
          If hDC
            hBmpOld = SelectObject_(hDC, hBmpCol)
            If hBmpOld
              CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                xType1\right = SizeX << 1
                xType1\bottom = SizeY << 1
                CompilerElse
                If IsMinWindowsXP
                  xType1\right = SizeX << 1
                  xType1\bottom = SizeY << 1
                  Else
                  xType1\right = IconFromEMF_QualityShift(SizeX)
                  xType1\bottom = IconFromEMF_QualityShift(SizeY)
                  EndIf
                CompilerEndIf

              hBrush = CreateSolidBrush_($000000)
              If hBrush
                FillRect_(hDC, xType1, hBrush)
                DeleteObject_(hBrush)
                EndIf
CompilerIf #IconFromEMF_PenFix
              If EnumEnhMetaFile_(hDC, hMeta, @IconFromEMF_PenFix(), $ffffff, @xType1)
CompilerElse
              If PlayEnhMetaFile_(hDC, hMeta, @xType1)
CompilerEndIf
                If SelectObject_(hDC, hBmpMsk)
                  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                    hBrush = CreateSolidBrush_($000000)
                    CompilerElse
                    If IsMinWindowsXP
                      hBrush = CreateSolidBrush_($000000)
                      Else
                      hBrush = CreateSolidBrush_($ffffff)
                      EndIf
                    CompilerEndIf
                  If hBrush
                    FillRect_(hDC, xType1, hBrush)
                    DeleteObject_(hBrush)
                    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                      If EnumEnhMetaFile_(hDC, hMeta, @IconFromEMF_ColorPenFix(), $ffffff, @xType1)
                        xResult = #True
                        EndIf                      
                      CompilerElse
                      If IsMinWindowsXP
                        If EnumEnhMetaFile_(hDC, hMeta, @IconFromEMF_ColorPenFix(), $ffffff, @xType1)
                          xResult = #True
                          EndIf                      
                        ElseIf EnumEnhMetaFile_(hDC, hMeta, @IconFromEMF_ColorPenFix(), 0, @xType1)
                        xResult = #True
                        EndIf
                      CompilerEndIf
                    EndIf
                  EndIf
                EndIf
              SelectObject_(hDC, hBmpOld)
              If xResult
                xType2\fIcon = #True
                xResult = #False
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
                If IsMinWindowsXP
CompilerEndIf
                  bi\bV5Width >> 1
                  bi\bV5Height >> 1
                  xType2\hbmColor = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpMix, 0, 0)
                  If xType2\hbmColor
                    xType2\hbmMask = CreateBitmap_(SizeX, SizeY, 1, 1, 0)
                    If xType2\hbmMask
                      CompilerIf #True
                        ;xLong1 = 0;(xY * SizeX * 4) * 4
                        xLong2 = SizeX << 3
                        For xY = 0 To SizeY-1
                          For xX = 0 To SizeX-1
                            xLong3 =  PeekL(*xBmpCol + xLong1)
                            xA  = PeekL(*xBmpMsk + xLong1) & $ff
                            xRB = xLong3 & $00ff00ff
                            xG  = xLong3 & $0000ff00

                            xLong3 =  PeekL(*xBmpCol + xLong1 + xLong2)
                            xA  + (PeekL(*xBmpMsk + xLong1 + xLong2) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong1 + 4

                            xLong3 =  PeekL(*xBmpCol + xLong1)
                            xA  + (PeekL(*xBmpMsk + xLong1) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong3 =  PeekL(*xBmpCol + xLong1 + xLong2)
                            xA  + (PeekL(*xBmpMsk + xLong1 + xLong2) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong1 + 4

                            ;xA = 0
                            PokeL(*xBmpMix + (xY * SizeX + xX) << 2, ((xRB >> 2) & $00ff00ff) | ((xG >> 2) & $0000ff00) | ((xA >> 2) << 24))
                            Next
                          xLong1 + xLong2
                          Next
                        CompilerElse
                        For xY = 0 To SizeY-1
                          For xX = 0 To SizeX-1
                            xLong1 =  PeekL(*xBmpCol + (xX * SizeY * 4 + xY*2) * 4)
                            xLong1 | (PeekB(*xBmpMsk + (xX * SizeY * 4 + xY*2) * 4 + 1) << 24)
                            PokeL(*xBmpMix + (xX * SizeY + xY) << 2, xLong1)
                            Next
                          Next
                        CompilerEndIf

                      xResult = CreateIconIndirect_(@xType2)
                      DeleteObject_(xType2\hbmMask)
                      EndIf
                    DeleteObject_(xType2\hbmColor)
                    EndIf
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
                  Else
                  xType2\hbmColor = BitmapStretchCopyEx(hBmpCol, SizeX, SizeY, 0)
                  If xType2\hbmColor
                    xType2\hbmMask = BitmapStretchCopyEx(hBmpMsk, SizeX, SizeY, 0)
                    If xType2\hbmMask
                      xResult = CreateIconIndirect_(@xType2)
                      DeleteObject_(xType2\hbmMask)
                      EndIf
                    DeleteObject_(xType2\hbmColor)
                    EndIf
                  EndIf
CompilerEndIf
                EndIf
              EndIf
            DeleteDC_(hDC)
            EndIf
          DeleteObject_(hBmpMsk)
          EndIf
        DeleteObject_(hBmpCol)
        ElseIf hBmpMsk
        DeleteObject_(hBmpMsk)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 147
; FirstLine = 117
; Folding = ---
; EnableUnicode
; EnableXP