EnableExplicit

LibBuild_Include(BitmapFromWEMF)

Procedure.i BitmapFromWEMF_Masked(hMeta, Width, Height, BgColor.i, *ColorFixer)
  Define.i xResult
  Define.i hDC
  Define.i hBmp
  Define.i hBmpOld
  Define.RECT xType1
  Define.i xColor

  #AddXOrMask = #False ; Icons are half-height on Win7 if activated!
  If hMeta
    CompilerIf #AddXOrMask
      hBmp = CreateBitmap_(Width, Height << 1, 1, 1, 0)
      CompilerElse
      hBmp = CreateBitmap_(Width, Height, 1, 1, 0)
      CompilerEndIf
    If hBmp
      hDC = CreateCompatibleDC_(0)
      If hDC
        hBmpOld = SelectObject_(hDC, hBmp)
        If hBmpOld
          If BitmapFromWEMFEx(hDC, hMeta, 0, 0, Width, Height, BgColor, *ColorFixer)
            CompilerIf #AddXOrMask
              xColor = CreateSolidBrush_($ffffff)
              If xColor
                xType1\bottom = Height << 1
                xType1\top = Height
                xType1\right = Width
                FillRect_(hDC, @xType1, xColor)
                xResult = hBmp
                DeleteObject_(xColor)
                EndIf
              CompilerElse
              xResult = hBmp
              CompilerEndIf
            EndIf
          SelectObject_(hDC, hBmpOld)
          EndIf
        DeleteDC_(hDC)
        EndIf
      If Not xResult
        DeleteObject_(hBmp)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure IconFromWMF_ColorFix(RType.i, RSMode.i, xColor.i)
  ProcedureReturn 0
  EndProcedure

Procedure.i IconFromWMF(hMeta, SizeX = 0, SizeY = 0)
  Define.i xResult
  Define.ICONINFO xType1

  If SizeX = 0 And SizeY = 0
    SizeX = 32
    SizeY = 32
    ElseIf SizeX = 0
    SizeX = SizeY
    ElseIf SizeY = 0
    SizeY = SizeX
    EndIf

Debug "IconLoading"
Debug SizeX
Debug SizeY
  If hMeta
    xType1\hbmColor = BitmapFromWEMF(hMeta, SizeX, SizeY, $000000, 0)
    If xType1\hbmColor
      ;xType1\hbmMask = BitmapFromWEMF(hMeta, SizeX, SizeY, $ffffff, @IconFromWMF_ColorFix())
      xType1\hbmMask = BitmapFromWEMF_Masked(hMeta, SizeX, SizeY, $ffffff, @IconFromWMF_ColorFix())
      If xType1\hbmMask
        xType1\fIcon = #True
        xResult = CreateIconIndirect_(@xType1)
        DeleteObject_(xType1\hbmMask)
        EndIf
      DeleteObject_(xType1\hbmColor)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 12
; FirstLine = 3
; Folding = -
; EnableUnicode
; EnableXP