EnableExplicit

Macro Window_Resize_Begin(hWnd, Width, Height)
  Define.RECT Resize_xType1
  Define.i Width
  Define.i Height

  If hWnd
    If GetClientRect_(hWnd, @Resize_xType1)
      Width = Resize_xType1\right - Resize_xType1\left
      If Width < 0: Width = 0: EndIf
  
      Height = Resize_xType1\bottom - Resize_xType1\top
      If Height < 0: Height = 0: EndIf
  EndMacro

Macro Window_Pos(hWnd, Left, Top, Width, Height)
  SetWindowPos_(hWnd, 0, Left, Top, Width, Height, $214)
  EndMacro

Macro Window_Move(hWnd, Left, Top)
  SetWindowPos_(hWnd, 0, Left, Top, $215)
  EndMacro

Macro Window_Size(hWnd, Width, Height)
  SetWindowPos_(hWnd, 0, 0, 0, Width, Height, $216)
  EndMacro

Macro Window_Resize_End()
      EndIf
    EndIf
  EndMacro

Macro Window_SetFont(hWnd, hFont, RefreshNow)
  If hWnd And hFont
    SendMessage_(hWnd, #WM_SETFONT, hFont, RefreshNow)
    EndIf
  EndMacro

Macro IMath_OptConstDivideFloor(Result, Value, Fact)
  CompilerIf Fact = 8
    Result = Value >> 3
    CompilerElseIf Fact = 4
    Result = Value >> 2
    CompilerElseIf Fact = 2
    Result = Value >> 1
    CompilerElse
    Result = Int(Value / Fact)
    CompilerEndIf
  EndMacro

Macro IMath_OptConstDivideRound(Result, Value, Fact)
  CompilerIf Fact = 8
    Result = Value >> 3
    CompilerElseIf Fact = 4
    Result = Value >> 2
    CompilerElseIf Fact = 2
    Result = Value >> 1
    CompilerElse
    Result = Round(Value / Fact, #PB_Round_Nearest)
    CompilerEndIf
  EndMacro

Macro IMath_OptConstMultiplyFloor(Result, Value, Fact)
  CompilerIf Fact = 8
    Result = Value << 3
    CompilerElseIf Fact = 4
    Result = Value << 2
    CompilerElseIf Fact = 2
    Result = Value << 1
    CompilerElse
    Result = Int(Value * Fact)
    CompilerEndIf
  EndMacro

Macro IMath_OptConstMultiplyRound(Result, Value, Fact)
  CompilerIf Fact = 8
    Result = Value << 3
    CompilerElseIf Fact = 4
    Result = Value << 2
    CompilerElseIf Fact = 2
    Result = Value << 1
    CompilerElse
    Result = Round(Value * Fact, #PB_Round_Nearest)
    CompilerEndIf
  EndMacro

Procedure.i InstrRevString(xString.s, ToFind.s, StartPos.i = -1, CaseInSensitive.i = #False) 
  Protected xLength.i
  Protected *position
   
  xLength = Len(ToFind)
  CompilerIf #PB_Compiler_Unicode
    *position = @xString + ((Len(xString)-xLength) << 1)
    If Not StartPos = -1
      StartPos = @xString + ((StartPos - 1) << 1)
      If StartPos < *position
        *position = StartPos
        EndIf
      EndIf
    While *position > @xString
      If CompareMemoryString(*position, @ToFind, CaseInSensitive, xLength) = 0 
        ProcedureReturn ((*position-@xString) >> 1) + 1
        EndIf 
      *position - 2
       Wend 
    CompilerElse
    *position = @xString + (Len(xString)-xLength)
    If Not StartPos = -1
      StartPos = @xString + StartPos - 1
      If StartPos < *position
        *position = StartPos
        EndIf
      EndIf
    While *position > @xString
      If CompareMemoryString(*position, @ToFind, CaseInSensitive, xLength) = 0 
        ProcedureReturn *position-@xString + 1 
        EndIf 
      *position - 1
       Wend 
    CompilerEndIf
  ProcedureReturn 0 
  EndProcedure

Procedure.i InstrRevChar(xString.s, ToFind.i, StartPos.i = $7fffffff) 
  Define.i xLong1

  EnableASM
  xLong1 = @xString
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    CompilerIf #PB_Compiler_Unicode
      mov rax, xLong1
      mov rcx, ToFind
      mov rdx, StartPos
      
      push rbx
      push rbp
      push rsi
      !xor rbx, rbx
      dec rbx
      mov rbp, rdx
      mov rsi, rax
      dec rax
      dec rax
  !InstrRevChar_Loop:
      inc rax
      inc rax
      mov dx, [rax]
      !or dx, dx
      jz InstrRevChar_EoS
      sub dx, cx
      jnz InstrRevChar_Loop
  
      mov rdx, rax
      sub rdx, rsi
      shr rdx, 1
      cmp rdx, rbp
      jnb InstrRevChar_EoL
      mov rbx, rdx
      jmp InstrRevChar_Loop
    
  !InstrRevChar_EoS:
  !InstrRevChar_EoL:
      mov rax, rbx
      inc rax
      pop rsi
      pop rbp
      pop rbx
      ProcedureReturn
      CompilerElse
; For LineSpec compatibility (Info dialog)!
      mov rax, xLong1
      mov rcx, ToFind
      mov rdx, StartPos
      
      push rbx
      push rbp
      push rsi
      !xor rbx, rbx
      dec rbx
      mov rbp, rdx
      mov rsi, rax
      dec rax
  !InstrRevChar_Loop:
      inc rax
      mov dl, [rax]
      !or dl, dl
      jz InstrRevChar_EoS
      sub dl, cl
      jnz InstrRevChar_Loop
  
      mov rdx, rax
      sub rdx, rsi
      cmp rdx, rbp
      jnb InstrRevChar_EoL
      mov rbx, rdx
      jmp InstrRevChar_Loop
    
  !InstrRevChar_EoS:
  !InstrRevChar_EoL:
      mov rax, rbx
      inc rax
      pop rsi
      pop rbp
      pop rbx
      ProcedureReturn
      CompilerEndIf
    CompilerElseIf #PB_Compiler_Unicode
    mov eax, xLong1
    mov ecx, ToFind
    mov edx, StartPos
    
    push ebx
    push ebp
    push esi
    !xor ebx, ebx
    dec ebx
    mov ebp, edx
    mov esi, eax
    dec eax
    dec eax
!InstrRevChar_Loop:
    inc eax
    inc eax
    mov dx, [eax]
    !or dl, dl
    jz InstrRevChar_EoS
    sub dx, cx
    jnz InstrRevChar_Loop

    mov edx, eax
    sub edx, esi
    shr edx, 1
    cmp edx, ebp
    jnb InstrRevChar_EoL
    mov ebx, edx
    jmp InstrRevChar_Loop
  
!InstrRevChar_EoS:
!InstrRevChar_EoL:
    mov eax, ebx
    inc eax
    pop esi
    pop ebp
    pop ebx
    ProcedureReturn
    CompilerElse
    mov eax, xLong1
    mov ecx, ToFind
    mov edx, StartPos
    
    push ebx
    push ebp
    push esi
    !xor ebx, ebx
    dec ebx
    mov ebp, edx
    mov esi, eax
    dec eax
!InstrRevChar_Loop:
    inc eax
    mov dl, [eax]
    !or dl, dl
    jz InstrRevChar_EoS
    sub dl, cl
    jnz InstrRevChar_Loop

    mov edx, eax
    sub edx, esi
    cmp edx, ebp
    jnb InstrRevChar_EoL
    mov ebx, edx
    jmp InstrRevChar_Loop
  
!InstrRevChar_EoS:
!InstrRevChar_EoL:
    mov eax, ebx
    inc eax
    pop esi
    pop ebp
    pop ebx
    ProcedureReturn
    CompilerEndIf
  DisableASM
  EndProcedure

Procedure.i IMath_DivURD(Var1.i, Var2.i)
  EnableASM
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    !xor rdx, rdx
    mov rax, Var1
    mov rcx, Var2
    div rcx
    mov Var1, rax
    CompilerElse
    !xor edx, edx
    mov eax, Var1
    mov ecx, Var2
    div ecx
    mov Var1, eax
    CompilerEndIf
  DisableASM
  ProcedureReturn Var1
  EndProcedure

Macro LoWordU(lParam)
  (lParam & $ffff)
  EndMacro

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Macro HiWordU(lParam)
    ((lParam >> 16) & $ffff)
    EndMacro
  CompilerElse
  Macro HiWordU(lParam)
    (lParam >> 16)
    EndMacro
  CompilerEndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 193
; FirstLine = 178
; Folding = ----
; EnableUnicode
; EnableXP