﻿EnableExplicit

Procedure RegisterDeviceNotification_Main_LibBuildPostInit()
  Global *RegisterDeviceNotification
  Global *UnregisterDeviceNotification
  Global Dim DeviceNotificationAPI_Handle.i(25)

  Structure DEV_BROADCAST_HANDLE
    dbcc_size.l
    dbcc_devicetype.l
    dbcc_reserved.l
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      alignment1.l
      CompilerEndIf
    dbch_handle.i
    dbch_hdevnotify.i
    dbch_eventguid.GUID
    dbch_nameoffset.l
    dbch_data.l ; 1/0 bytes, but structure size 'alignment' is critical l ; 1(0)+ byte
    EndStructure

  Define.i xLong1

  xLong1 = GetModuleHandle_(@"user32.dll")
  If xLong1
    *RegisterDeviceNotification = GetProcAddressAW(xLong1, "RegisterDeviceNotification")
    *UnregisterDeviceNotification = GetProcAddress(xLong1, "UnregisterDeviceNotification")
    EndIf
  EndProcedure

;boolean
Procedure.i RegisterDevicesNotification(hWnd.i, DriveLetterID.i)
  CompilerIf #PB_Compiler_Unicode
    Define.i xResult
    Define.s xChar1
    Define.DEV_BROADCAST_HANDLE NotificationFilter
    Define.i xLong1

    If *RegisterDeviceNotification
;Debug "########## Registering: " + Chr(DriveLetterID + 65) + ":\\"
      xChar1 = Chr(DriveLetterID + 65) + ":\\"
      xLong1 = SetErrorMode_( #SEM_NOOPENFILEERRORBOX | #SEM_FAILCRITICALERRORS)
      NotificationFilter\dbch_handle = CreateFile_(@xChar1, $80000000, 3, 0, 3, $2000080, 0)
      SetErrorMode_(xLong1)
;Debug "########## Handle: " + Str(NotificationFilter\dbch_handle)
      If Not NotificationFilter\dbch_handle = -1
        NotificationFilter\dbcc_size = SizeOf(NotificationFilter)
;Debug "########## Size: " + Str(NotificationFilter\dbcc_size)
        NotificationFilter\dbcc_devicetype = 6
        DeviceNotificationAPI_Handle(DriveLetterID) = CallFunctionFast(*RegisterDeviceNotification, hWnd, @NotificationFilter, 0)
;Define.i xLong1 = GetLastError_()
;Debug "########## 2hwnd: " + Str(DeviceNotificationAPI_Handle(DriveLetterID))
;Debug "########## error: " + Str(xLong1)
        CloseHandle_(NotificationFilter\dbch_handle)
        EndIf
      If DeviceNotificationAPI_Handle(DriveLetterID)
        xResult = #True
        EndIf
      EndIf
    ProcedureReturn xResult
    CompilerElse
    ProcedureReturn #True
    CompilerEndIf
  EndProcedure

Procedure.i RemovableDevices_ResolveDriveID(*lParam.DEV_BROADCAST_HANDLE)
  Define.i xResult
  Define.i xLong1

  xResult = -1
  If *lParam
    If *lParam\dbch_hdevnotify
      For xLong1 = 2 To 25
        If *lParam\dbch_hdevnotify = DeviceNotificationAPI_Handle(xLong1)
          xResult = xLong1
          Break
          EndIf
        Next
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure RemovableDevices_Unregister(DriveLetterID.i)
  If DeviceNotificationAPI_Handle(DriveLetterID)
    If *UnregisterDeviceNotification
      CallFunctionFast(*UnregisterDeviceNotification, DeviceNotificationAPI_Handle(DriveLetterID))
      EndIf
    DeviceNotificationAPI_Handle(DriveLetterID) = 0
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x64)
; CursorPosition = 39
; FirstLine = 29
; Folding = --
; EnableUnicode
; EnableXP